///////////////////////////////////////////////////////////////////////////////
//
// (c) 1997 by Marc van Shaney , aka Kaya Memisoglu
//
// This Source-Code was written by and is copyrighted by Kaya Memisoglu
// You may use the whole code or only parts of it in your own programs
// whether they are commercial or not. BUT you must give credits for these
// parts to me (Kaya Memisoglu  or  Marc van Shaney).
// I am not responsible for any damage or loss caused by this program, so
// if you success in erasing your harddisk with this code, then it is your
// own fault and you should not claim me to be responsible...
// I would be very pleased if you also sent me a postcard or even a letter
// if you can use this code. My address:
//
//        Kaya Memisoglu
//        Reichenberger Ring 50
//        63512 Hainburg
//        Germany
//
//

#include "../include/gomez.h"

#define SINESHIFT			14
#define SINESIZE			(1<<SINESHIFT)

class GPlasma : public GApplication {
	private:
	GFrame		Frame;

	public:
	GPlasma():GApplication("GPlasma") {};

	protected:
	BOOL FASTCALL OnStart(LONG );
	BOOL FASTCALL OnTerminate(void);
	BOOL FASTCALL OnChar(LONG );
	BOOL FASTCALL OnTimer(LONG ,LONG );
    BOOL FASTCALL OnActivate(void);
    BOOL FASTCALL OnDeactivate(void);

	private:
	BYTE		SineTab[SINESIZE];
	INT			V1,V2,V3,V4,V5,V6;
   };


BOOL FASTCALL GPlasma::OnStart(LONG p)
{
 INT i;
 GPalette pal;

 for (i=0;i<SINESIZE;i++)
	SineTab[i]=(BYTE)(INT)(sin((DOUBLE)i/(DOUBLE)SINESIZE*M_PI*2)*32.0+32.0);
 V1=V2=V3=V4=V5=V6=0;

 Open(320,240,8);
 Frame.Alloc(GetWidth(),GetHeight(),8);

 pal.ImportMAP("gplasma.map");
 SetPalette(&pal);
 RealizePalette();
 Frame.SetPalette(&pal);
 Frame.RealizePalette();
 Frame.ClearImage(0);

 SetTimerSpeed(50);
 SetPriority(GMZ_PRIORITY_HIGH);

 return TRUE;
}

BOOL FASTCALL GPlasma::OnTerminate(void)
{
 SetPriority(GMZ_PRIORITY_IDLE);
 SetTimerSpeed(0);
 Frame.Free();
 Close();

 return TRUE;
}

BOOL FASTCALL GPlasma::OnActivate(void)
{
 SetPriority(GMZ_PRIORITY_HIGH);
 return TRUE;
}

BOOL FASTCALL GPlasma::OnDeactivate(void)
{
 SetPriority(GMZ_PRIORITY_IDLE);
 return TRUE;
}

BOOL FASTCALL GPlasma::OnChar(LONG key)
{
 switch(key)
   {
	case 'x': Terminate(); break;
   }

 return TRUE;
}

BOOL FASTCALL GPlasma::OnTimer(LONG id,LONG time)
{
 FAST BYTE *frm,*eol,*eof;
 INT x1,x2,x3,x4,x5,x6;

 x2=V2;
 x4=V4;
 x6=V6;
 frm=(BYTE *)Frame.GetImage();
 eof=(BYTE *)Frame.GetImage()+Frame.GetSize();
 while(frm<eof)
   {
	x1=((INT)SineTab[x2&(SINESIZE-1)]<<3);
	x3=((INT)SineTab[x4&(SINESIZE-1)]<<3);
	x5=((INT)SineTab[x6&(SINESIZE-1)]<<3);
	eol=frm+Frame.GetLineSize();
	while(frm<eol)
	   {
		*frm++=(BYTE)SineTab[x1&(SINESIZE-1)]+
			 (BYTE)SineTab[x3&(SINESIZE-1)]+
			 (BYTE)SineTab[x5&(SINESIZE-1)];
		x1+=((INT)SineTab[x2&(SINESIZE-1)]);
		x3+=((INT)SineTab[x4&(SINESIZE-1)]);
		x5+=((INT)SineTab[x6&(SINESIZE-1)]);
	   }
	x2+=((INT)SineTab[V2&(SINESIZE-1)])+34;
	x4+=((INT)SineTab[V4&(SINESIZE-1)])+27;
	x6+=((INT)SineTab[V6&(SINESIZE-1)])+19;
   }

 V2+=127;
 V4+=331;
 V6+=217;

 Frame.Put(this);
 return TRUE;
}

void main(void)
{
 GPlasma Scope;
 Scope.Start();
}
