///////////////////////////////////////////////////////////////////////////////
//
// (c) 1997 by Marc van Shaney , aka Kaya Memisoglu
//
// This Source-Code was written by and is copyrighted by Kaya Memisoglu
// You may use the whole code or only parts of it in your own programs
// whether they are commercial or not. BUT you must give credits for these
// parts to me (Kaya Memisoglu  or  Marc van Shaney).
// I am not responsible for any damage or loss caused by this program, so
// if you success in erasing your harddisk with this code, then it is your
// own fault and you should not claim me to be responsible...
// I would be very pleased if you also sent me a postcard or even a letter
// if you can use this code. My address:
//
//        Kaya Memisoglu
//        Reichenberger Ring 50
//        63512 Hainburg
//        Germany
//
//



#include "../include/gomez.h"

#define NUMSAMPLES				32

class GScope : public GApplication {
	private:
	GFrame		Frame;
	GSoundInput	Sound;
	GSample		Sample[NUMSAMPLES];
	static GSample *Current;

	public:
	GScope():GApplication("Oscilloscope") {};

	protected:
	BOOL FASTCALL OnStart(LONG );
	BOOL FASTCALL OnTerminate(void);
	BOOL FASTCALL OnChar(LONG );
	BOOL FASTCALL OnTimer(LONG ,LONG );
    BOOL FASTCALL OnActivate(void);
    BOOL FASTCALL OnDeactivate(void);

	private:
	static BOOL FASTCALL SoundProc(INT ,GSoundInput *,GSample *);
   };

GSample* GScope::Current;



BOOL FASTCALL GScope::OnStart(LONG p)
{
 INT i;

 Open(320,200,8);
 Frame.Alloc(GetWidth(),GetHeight(),8);
 for (i=0;i<NUMSAMPLES;i++)
	Sample[i].Alloc(1000,22000,8,1);
 Current=&Sample[0];
 Sound.SetHandler(SoundProc);
 Sound.Open(&Sample[0]);
 for (i=0;i<NUMSAMPLES;i++)
	Sound.AddBuffer(&Sample[i]);

 SetTimerSpeed(50);
 SetPriority(GMZ_PRIORITY_HIGH);

 return TRUE;
}

BOOL FASTCALL GScope::OnTerminate(void)
{
 INT i;

 SetPriority(GMZ_PRIORITY_IDLE);
 SetTimerSpeed(0);
 Sound.Stop();
 Sound.Close();

 for (i=0;i<NUMSAMPLES;i++)
	Sample[i].Free();
 Frame.Free();
 Close();

 return TRUE;
}

BOOL FASTCALL GScope::SoundProc(INT msg,GSoundInput *sound,GSample *smp)
{
 if (msg==GMZ_SOUND_DONE)
   {
	sound->AddBuffer(smp);
	Current=smp;
   }
 return TRUE;
}

BOOL FASTCALL GScope::OnActivate(void)
{
 SetPriority(GMZ_PRIORITY_HIGH);
 return TRUE;
}

BOOL FASTCALL GScope::OnDeactivate(void)
{
 SetPriority(GMZ_PRIORITY_IDLE);
 return TRUE;
}

BOOL FASTCALL GScope::OnChar(LONG key)
{
 switch(key)
   {
	case 'x': Terminate(); break;
   }

 return TRUE;
}

BOOL FASTCALL GScope::OnTimer(LONG id,LONG time)
{
 INT i;
 BYTE *smp=(BYTE *)Current->GetData();

 Frame.ClearImage(0);
 for (i=0;i<Frame.GetWidth();i++)
	Frame.PutPixel(i,smp[i]-32,255);
 Frame.Put(this);
 return TRUE;
}

void main(void)
{
 GScope Scope;
 Scope.Start();
}