///////////////////////////////////////////////////////////////////////////////
//
// (c) 1997 by Marc van Shaney , aka Kaya Memisoglu
//
// This Source-Code was written by and is copyrighted by Kaya Memisoglu
// You may use the whole code or only parts of it in your own programs
// whether they are commercial or not. BUT you must give credits for these
// parts to me (Kaya Memisoglu  or  Marc van Shaney).
// I am not responsible for any damage or loss caused by this program, so
// if you success in erasing your harddisk with this code, then it is your
// own fault and you should not claim me to be responsible...
// I would be very pleased if you also sent me a postcard or even a letter
// if you can use this code. My address:
//
//        Kaya Memisoglu
//        Reichenberger Ring 50
//        63512 Hainburg
//        Germany
//
//

#include "../include/gomez.h"
class GStencil : public GApplication {
	private:
	GFrame		Frame;
    GBitmap		Image;

	public:
	GStencil():GApplication("Stencil Buffer Test") {};

	protected:
	BOOL FASTCALL OnStart(LONG );
	BOOL FASTCALL OnTerminate(void);
	BOOL FASTCALL OnChar(LONG );
	BOOL FASTCALL OnTimer(LONG ,LONG );
    BOOL FASTCALL OnActivate(void);
    BOOL FASTCALL OnDeactivate(void);
   };

BOOL FASTCALL GStencil::OnStart(LONG p)
{
 CHAR *fname=Parameter.GetParameter(0);
 INT w,h;

 Image.ImportPCX(fname ? fname : "face.pcx");
 w=max(min(Image.GetWidth(),500),60);
 h=max(min(Image.GetHeight(),360),30);
 Open(w,h,8);
 Frame.Alloc(GetWidth(),GetHeight(),8);
 Frame.SetPalette(Image.GetPalette());
 SetPalette(Image.GetPalette());
 Frame.RealizePalette();
 RealizePalette();

 SetTimerSpeed(50);
 SetPriority(GMZ_PRIORITY_HIGH);

 return TRUE;
}

BOOL FASTCALL GStencil::OnTerminate(void)
{
 SetPriority(GMZ_PRIORITY_IDLE);
 SetTimerSpeed(0);
 Frame.Free();
 Image.Free();
 Close();

 return TRUE;
}

BOOL FASTCALL GStencil::OnActivate(void)
{
 SetPriority(GMZ_PRIORITY_HIGH);
 return TRUE;
}

BOOL FASTCALL GStencil::OnDeactivate(void)
{
 SetPriority(GMZ_PRIORITY_IDLE);
 return TRUE;
}

BOOL FASTCALL GStencil::OnChar(LONG key)
{
 switch(key)
   {
	case 'x': Terminate(); break;
   }

 return TRUE;
}

BOOL FASTCALL GStencil::OnTimer(LONG id,LONG time)
{
 Frame.PutBitmap(&Image,0,0);
 Frame.Put(this);
 return TRUE;
}

void main(void)
{
 GStencil Stencil;
 Stencil.Start();
}

