
/*
  Thanks goes to Federico 'pix' Feroldi for the original
  water algorithm idea...

  Some optimizations added by Jason Hood, and he has made an
  Allegro-able version, too.  (I may soon be using Allegro, so
  more things will be Allegro-able)

  I hope no one minds looking at my messy code...  It's really messy.
  (in my opinion, anyway)  It hasn't been properly commented/documented
  yet, either...  When it's properly documented, it'll be on my web site:
	http://www.VIS.colostate.edu/~scriven/

  Use options: -O3 -m486 -fforce-addr -ffast-math -fomit-frame-pointer
  (-O3 is the only one that makes much difference)
*/

#include "../include/gomez.h"


#define WATERWID  256
#define WATERSHFT 8
#define WATERHGT  200

#define FSin(a)			((LONG)(sin((DOUBLE)(LONG)(a)/360.0)*256.0*16.0))
#define FCos(a)			((LONG)(cos((DOUBLE)(LONG)(a)/360.0)*256.0*16.0))


class GWater : public GApplication {
	private:
	GBitmap     Image;
	GFrame		Frame;

	INT 		density , pheight , radius;
	INT			Hpage;
	INT 		xang, yang;
	INT			ox,oy;
	INT 		swirlangle;
	INT 		mode;
	INT 		movement;
	INT 		light;

	INT 		Height[2][WATERWID * WATERHGT];

	public:
	GWater():GApplication("Water Experiment") {};

	protected:
	BOOL FASTCALL OnStart(LONG );
	BOOL FASTCALL OnTerminate(void);
	BOOL FASTCALL OnMouseButton(DWORD ,LONG ,LONG );
	BOOL FASTCALL OnMouseMove(DWORD ,LONG ,LONG );
	BOOL FASTCALL OnChar(LONG );
	BOOL FASTCALL OnTimer(LONG ,LONG );
    BOOL FASTCALL OnActivate(void);
    BOOL FASTCALL OnDeactivate(void);

	private:
	void DrawWaterNoLight(void);
	void DrawWaterWithLight(void);
	void CalcWater(void);
	void CalcWaterBigFilter(void);
	void SmoothWater(void);

	void HeightBlob(INT x, INT y, INT radius, INT height);
	void HeightBox (INT x, INT y, INT radius, INT height);

	void WarpBlob(INT x, INT y, INT radius, INT height);
	void SineBlob(INT x, INT y, INT radius, INT height);
   };


BOOL FASTCALL GWater::OnStart(LONG p)
{
 GBitmap LoadImage;
 density = 4;
 pheight = 400;
 radius = 30;
 Hpage = 0;
 mode=0x4000;
 movement=1;
 light=0;
 ox=60;
 oy=60;

 xang = rand()%2048;
 yang = rand()%2048;
 swirlangle = rand()%2048;

 memset(Height[0], 0, sizeof(INT)*WATERWID*WATERHGT);
 memset(Height[1], 0, sizeof(INT)*WATERWID*WATERHGT);

 Open(WATERWID,WATERHGT,8);
 LoadImage.ImportPCX(_argv[1] ? _argv[1] : "face.pcx");
 LoadImage.Rescale(GetWidth(),GetHeight());
 Image.Alloc(GetWidth(),GetHeight()*3,8);
 Frame.Alloc(GetWidth(),GetHeight(),8);
 Frame.SetPalette(LoadImage.GetPalette());
 Frame.RealizePalette();
 SetPalette(LoadImage.GetPalette());
 RealizePalette();

 Image.PutImage(LoadImage.GetImage(),0,GetHeight());
 Image.PutImage(LoadImage.GetImage(),GetHeight(),GetHeight());
 Image.PutImage(LoadImage.GetImage(),2*GetHeight(),GetHeight());
 Frame.PutImage(LoadImage.GetImage());
 LoadImage.Free();

 SetTimerSpeed(50);
 SetPriority(GMZ_PRIORITY_HIGH);
 return TRUE;
}


BOOL FASTCALL GWater::OnTerminate(void)
{
 SetPriority(GMZ_PRIORITY_IDLE);
 SetTimerSpeed(0);
 Image.Free();
 Frame.Free();
 Close();
 return TRUE;
}


BOOL FASTCALL GWater::OnActivate(void)
{
 SetPriority(GMZ_PRIORITY_HIGH);
 return TRUE;
}


BOOL FASTCALL GWater::OnDeactivate(void)
{
 SetPriority(GMZ_PRIORITY_IDLE);
 return TRUE;
}


BOOL FASTCALL GWater::OnChar(LONG key)
{
  switch(key)
	  {
	    case 'x': Terminate(); break;
		case 'd': density--; break;
		case 'D': density++; break;

		case 'h': pheight-=40; break;
		case 'H': pheight+=40; break;

		case 'r': radius+=5; break;
		case 'R': radius-=5; break;

		case 'l': light++; break;
		case 'L': if(light>0) light--; break;

		case 'c': memset(Height[0], 0, sizeof(INT)*WATERWID*WATERHGT);
				  memset(Height[1], 0, sizeof(INT)*WATERWID*WATERHGT);
				  break;
		case 'z': if(movement)
					memset(Height[Hpage], 0, sizeof(INT)*WATERWID*WATERHGT);
				  else
					SmoothWater();
				  break;

		case 'w':
		case 'W': mode=mode | 0x4000;
				  density=4; light=1; pheight=600;
				  break;
		case 'j':
		case 'J': mode=mode & 0xbfff;
				  density=3; pheight=400; // light=0;
				  break;
		case 's': density=6; pheight=400; // light=0;
				  mode=mode & 0xbfff;
				  break;
		case 'S': density=8; pheight=400; // light=0;
				  mode=mode & 0xbfff;
				  break;
		case 'b': mode = mode & (0xbfff - 4);  mode ^= 4;
				  density=4; pheight=1400; radius=80; // light=1;
				  break;
		case 'B': mode = mode & (0xbfff - 4);  mode ^= 4;
				  density=4; pheight = -1400; radius=80; // light=1;
				  break;


		case 'm':
		case 'M': movement ^= 1;
		  if(movement)
		  {
			pheight=400;
		  }
		  else
		  {
			pheight=256;
		  }
		  break;

// Each bit of the mode variable is used to represent the state of a
// different option that can be turned on or off...
		case '1': mode ^= 1; break;
		case '2': mode ^= 2; break;
		case '3': mode ^= 4; break;
		case '4': mode ^= 8; if(mode&8) {xang=0; yang=0;} break;

		case ' ': mode &= 0x4000; break;

		case '6':
		  HeightBlob(-1, -1, rand()%(radius/2)+2, pheight);
		  break;

		case '7':
		  HeightBlob(WATERWID/2, WATERHGT/2, radius/2, pheight);
		  break;

		case '8':
		  HeightBox(WATERWID/2, WATERHGT/2, radius/2, pheight);
		  break;
	}

 return TRUE;
}


BOOL FASTCALL GWater::OnMouseButton(DWORD button,LONG posx,LONG posy)
{
 if (button & GDisplay::LBUTTONDOWN)
   {
	if(mode & 0x4000)
		HeightBlob(posx, posy, 2, pheight);
	else if(movement)
		SineBlob(posx, posy, radius, -pheight);
	else
		SineBlob(posx, posy, radius, -pheight);
   }
 if (button & GDisplay::RBUTTONDOWN)
   {
	if(mode & 0x4000)
		HeightBlob(posx, posy, radius/2, pheight);
	else if(movement)
		SineBlob(posx, posy, radius, pheight);
	else
		SineBlob(posx, posy, radius, pheight);
   }

 return TRUE;
}


BOOL FASTCALL GWater::OnMouseMove(DWORD button,LONG posx,LONG posy)
{
 return OnMouseButton(button,posx,posy);
}



BOOL FASTCALL GWater::OnTimer(LONG id,LONG time)
{
 INT offset;
 INT x,y;

 if(mode&1)
	{
		x = (WATERWID/2)
		  + ((
			 (
			  (FSin( (xang* 65) >>8) >>8) *
			  (FSin( (xang*349) >>8) >>8)
			 ) * ((WATERWID-8)/2)
			) >> 16);
		y = (WATERHGT/2)
		  + ((
			 (
			  (FSin( (yang*377) >>8) >>8) *
			  (FSin( (yang* 84) >>8) >>8)
			 ) * ((WATERHGT-8)/2)
			) >> 16);
		xang += 13;
		yang += 12;

  if(mode & 0x4000)
	   {
		offset = (oy+y)/2*WATERWID + (ox+x)/2;
		Height[Hpage][offset] = pheight;
		Height[Hpage][offset + 1] =
		Height[Hpage][offset - 1] =
		Height[Hpage][offset + WATERWID] =
		Height[Hpage][offset - WATERWID] = pheight >> 1;

		offset = y*WATERWID + x;
		Height[Hpage][offset] = pheight<<1;
		Height[Hpage][offset + 1] =
		Height[Hpage][offset - 1] =
		Height[Hpage][offset + WATERWID] =
		Height[Hpage][offset - WATERWID] = pheight;
	   }
	   else
	   {
		SineBlob((ox+x)/2, (oy+y)/2, 3, -1200);
		SineBlob(x, y, 4, -2000);
	   }

		ox = x;
		oy = y;
	}
  // The raindrops...
  if(mode&2)
	{
		x = rand()%(WATERWID-2) + 1;
		y = rand()%(WATERHGT-2) + 1;
		Height[Hpage][y*WATERWID + x] = rand()%(pheight<<2);
	}
  // The big splashes...
  if(mode&4)
	{
	  if(rand()%20 == 0)
	  {
		if(mode & 0x4000)
		  HeightBlob(-1, -1, radius/2, pheight);
		else
		  SineBlob(-1, -1, radius, -pheight*6);
	  }
	}
  //  The surfer (2) ... Swirling effect
  if(mode&8)
	{
		x = (WATERWID/2)
		  + ((
			 (FCos(swirlangle)) * (25)
			) >> 16);
		y = (WATERHGT/2)
		  + ((
			 (FSin(swirlangle)) * (25)
			) >> 16);
		swirlangle += 50;
		if(mode & 0x4000)
		  HeightBlob(x,y, radius/3, pheight);
		else
		  WarpBlob(x, y, radius, pheight);
	}

  if(light)
	  DrawWaterWithLight();
  else
	  DrawWaterNoLight();

  if(movement)
	  CalcWater();
  else
	  memcpy(&Height[Hpage^1][0], &Height[Hpage][0], sizeof(INT)*WATERWID*WATERHGT);
  Hpage^=1;
 return TRUE;
}


void GWater::DrawWaterNoLight(void)
{
  BYTE *BkGdImage;
  BYTE *temp;
  INT dx, dy;
  INT x, y;
  INT offset;
  INT *ptr;

  offset=WATERWID + 1;
  ptr = &Height[Hpage][0];
  BkGdImage=(BYTE *)Image.GetImage()+Image.GetSize()/3;
  temp=(BYTE *)Frame.GetImage();

  for (y = (WATERHGT-1)<<WATERSHFT; offset < y; offset += 2)
  {
	for (x = offset+WATERWID-2; offset < x; offset++)
	{
	  dx = ptr[offset] - ptr[offset+1];
	  dy = ptr[offset] - ptr[offset+WATERWID];
	  temp[offset] = BkGdImage[offset + ((dy>>3)<<WATERSHFT) + (dx>>3)];

	  offset++;
	  dx = ptr[offset] - ptr[offset+1];
	  dy = ptr[offset] - ptr[offset+WATERWID];
	  temp[offset] = BkGdImage[offset + ((dy>>3)<<WATERSHFT) + (dx>>3)];
	}
  }

 Frame.Put(this);
}


void GWater::DrawWaterWithLight(void)
{
  BYTE *BkGdImage;
  BYTE *temp;
  INT dx, dy;
  INT x, y;
  INT c;
  INT LightModifier;
  INT offset;
  INT *ptr;

  LightModifier=light-1;
  offset=WATERWID + 1;
  ptr = &Height[Hpage][0];
  BkGdImage=(BYTE *)Image.GetImage()+Image.GetSize()/3;
  temp=(BYTE *)Frame.GetImage();

  for (y = (WATERHGT-1)*WATERWID; offset < y; offset += 2)
  {
	for (x = offset+WATERWID-2; offset < x; offset++)
	{
	  dx = ptr[offset] - ptr[offset+1];
	  dy = ptr[offset] - ptr[offset+WATERWID];
	  c = BkGdImage[offset + ((dy>>3)<<WATERSHFT) + (dx>>3)] - (dx>>LightModifier);

	 // If anyone knows a better/faster way to do this, please tell me...
	  temp[offset] = (BYTE)((c < 0) ? 0 : (c > 255) ? 255 : c);
	 // This is the previous way I had been doing it...
//      if(c < 0) c=0;
//      else if (c > 255) c=255;
//      temp[offset] = c;

	  offset++;
	  dx = ptr[offset] - ptr[offset+1];
	  dy = ptr[offset] - ptr[offset+WATERWID];
	  c = BkGdImage[offset + ((dy>>3)<<WATERSHFT) + (dx>>3)] - (dx>>LightModifier);
	  temp[offset] = (BYTE)((c < 0) ? 0 : (c > 255) ? 255 : c);

	}
  }

 Frame.Put(this);
}


void GWater::CalcWater()
{
  INT newh;
  INT count;
  INT *newptr;
  INT *oldptr;
  INT x, y;

  count = WATERWID + 1;
  newptr = &Height[Hpage^1][0];
  oldptr = &Height[Hpage][0];

  // Sorry, this function might not be as readable as I'd like, because
  // I optimized it somewhat.  (enough to make me feel satisfied with it)

//  for(y=1; y<WATERHGT-1; y++)
//  {
//    for(x=1; x<WATERWID-1; x++)
//    {
  for (y = (WATERHGT-1)<<WATERSHFT; count < y; count += 2)
  {
	for (x = count+WATERWID-2; count < x; count++)
	{
/*********  This does the four-pixel method.  It looks bad. */
	  newh          = ((oldptr[count + WATERWID]
					  + oldptr[count - WATERWID]
					  + oldptr[count + 1]
					  + oldptr[count - 1]
					   ) >> 1 )
					  - newptr[count];
/**********/
// This does the eight-pixel method.  It looks much better.
/*
	  newh          = ((oldptr[count + WATERWID]
					  + oldptr[count - WATERWID]
					  + oldptr[count + 1]
					  + oldptr[count - 1]
					  + oldptr[count - WATERWID - 1]
					  + oldptr[count - WATERWID + 1]
					  + oldptr[count + WATERWID - 1]
					  + oldptr[count + WATERWID + 1]
					   ) >> 2 )
					  - newptr[count]; */


	  newptr[count] =  newh - (newh >> density);
/*
      newh =  oldptr[count]
           +  oldptr[count-1-WATERWID]
		   +  oldptr[count+1-WATERWID]
           +  oldptr[count-1+WATERWID]
           +  oldptr[count+1+WATERWID]
		   + ((oldptr[count-1]
		   +   oldptr[count+1]
           +   oldptr[count-WATERWID]
           +   oldptr[count+WATERWID])<<1);
*/
/*
// This is the "sludge" method...
	  newh = (oldptr[count]<<2)
           +  oldptr[count-1-WATERWID]
           +  oldptr[count+1-WATERWID]
           +  oldptr[count-1+WATERWID]
           +  oldptr[count+1+WATERWID]
		   + ((oldptr[count-1]
           +   oldptr[count+1]
		   +   oldptr[count-WATERWID]
		   +   oldptr[count+WATERWID])<<1);

      newptr[count] = (newh-(newh>>6)) >> density;
*/
//      count++;
    }
//    count += 2;
  }
/*
  for(count=1; count<WATERWID-1; count++)
  {
      newh          = ((oldptr[count + WATERWID]
                      + oldptr[count + 1]
					  + oldptr[count - 1]
//                      + oldptr[count - WATERWID + 1]
                      + oldptr[count + WATERWID + 1]
                       ) >> 1 )
                      - (newptr[count] >> 1);
	  newptr[count] =  newh - (newh >> density);
  }
*/

/*
  memcpy(newptr, newptr + WATERWID, WATERWID*sizeof(INT));
  memcpy(newptr+(WATERWID*WATERHGT)-WATERWID,
		 newptr+(WATERWID*WATERHGT)-(2*WATERWID), WATERWID*sizeof(INT));
  newptr += WATERWID;
  for(y=1; y<WATERHGT-1; y++)
  {
	*newptr = *(newptr+1);
	newptr += WATERWID-1;
	*newptr = *(newptr-1);
	newptr ++;
  }
*/
}


void GWater::SmoothWater(void)
{
  INT newh;
  INT count;
  INT *newptr;
  INT *oldptr;
  INT x, y;

  count = WATERWID + 1;
  newptr = &Height[Hpage][0];
  oldptr = &Height[Hpage^1][0];


  // Sorry, this function might not be as readable as I'd like, because
  // I optimized it somewhat.  (enough to make me feel satisfied with it)

  for(y=1; y<WATERHGT-1; y++)
  {
	for(x=1; x<WATERWID-1; x++)
	{
// This does the eight-pixel method.  It looks much better.

	  newh          = ((oldptr[count + WATERWID]
					  + oldptr[count - WATERWID]
					  + oldptr[count + 1]
					  + oldptr[count - 1]
					  + oldptr[count - WATERWID - 1]
					  + oldptr[count - WATERWID + 1]
					  + oldptr[count + WATERWID - 1]
					  + oldptr[count + WATERWID + 1]
					   ) >> 3 )
					  + newptr[count];


	  newptr[count] =  newh>>1;
	  count++;
	}
	count += 2;
  }
}


void GWater::CalcWaterBigFilter(void)
{
  INT newh;
  INT count;
  INT *newptr;
  INT *oldptr;
  INT x, y;

  count = (2*WATERWID) + 2;
  newptr = &Height[Hpage][0];
  oldptr = &Height[Hpage^1][0];


  // Sorry, this function might not be as readable as I'd like, because
  // I optimized it somewhat.  (enough to make me feel satisfied with it)

  for(y=2; y<WATERHGT-2; y++)
  {
	for(x=2; x<WATERWID-2; x++)
	{
// This does the 25-pixel method.  It looks much okay.

	  newh        = (
					 (
					  (
					   (oldptr[count + WATERWID]
                      + oldptr[count - WATERWID]
                      + oldptr[count + 1]
                      + oldptr[count - 1]
					   )<<1)
                      + ((oldptr[count - WATERWID - 1]
					  + oldptr[count - WATERWID + 1]
					  + oldptr[count + WATERWID - 1]
					  + oldptr[count + WATERWID + 1]))
                      + ( (
                          oldptr[count - (WATERWID*2)]
                        + oldptr[count + (WATERWID*2)]
						+ oldptr[count - 2]
                        + oldptr[count + 2]
						) >> 1 )
                      + ( (
                          oldptr[count - (WATERWID*2) - 1]
						+ oldptr[count - (WATERWID*2) + 1]
                        + oldptr[count + (WATERWID*2) - 1]
                        + oldptr[count + (WATERWID*2) + 1]
                        + oldptr[count - 2 - WATERWID]
                        + oldptr[count - 2 + WATERWID]
                        + oldptr[count + 2 - WATERWID]
                        + oldptr[count + 2 + WATERWID]
                        ) >> 2 )
					 )
					>> 3)
					- (newptr[count]);


	  newptr[count] =  newh - (newh >> density);
      count++;
	}
    count += 4;
  }
}



void GWater::HeightBlob(INT x, INT y, INT radius, INT height)
{
  INT rquad;
  INT cx, cy, cyq;
  INT left, top, right, bottom;


  rquad = radius * radius;

  // Make a randomly-placed blob...
  if(x<0) x = 1+radius+ rand()%(WATERWID-2*radius-1);
  if(y<0) y = 1+radius+ rand()%(WATERHGT-2*radius-1);

  left=-radius; right = radius;
  top=-radius; bottom = radius;

  // Perform edge clipping...
  if(x - radius < 1) left -= (x-radius-1);
  if(y - radius < 1) top  -= (y-radius-1);
  if(x + radius > WATERWID-1) right -= (x+radius-WATERWID+1);
  if(y + radius > WATERHGT-1) bottom-= (y+radius-WATERHGT+1);


  for(cy = top; cy < bottom; cy++)
  {
	cyq = cy*cy;
	for(cx = left; cx < right; cx++)
	{
	  if(cx*cx + cyq < rquad)
		Height[Hpage][((cy+y)<<WATERSHFT) + (cx+x)] += height;
	}
  }

}


void GWater::HeightBox (INT x, INT y, INT radius, INT height)
{
  INT cx, cy;
  INT left, top, right, bottom;


  if(x<0) x = 1+radius+ rand()%(WATERWID-2*radius-1);
  if(y<0) y = 1+radius+ rand()%(WATERHGT-2*radius-1);

  left=-radius; right = radius;
  top=-radius; bottom = radius;

  // Perform edge clipping...
  if(x - radius < 1) left -= (x-radius-1);
  if(y - radius < 1) top  -= (y-radius-1);
  if(x + radius > WATERWID-1) right -= (x+radius-WATERWID+1);
  if(y + radius > WATERHGT-1) bottom-= (y+radius-WATERHGT+1);

  for(cy = top; cy < bottom; cy++)
  {
	for(cx = left; cx < right; cx++)
	{
		Height[Hpage][((cy+y)<<WATERSHFT) + (cx+x)] = height;
	}
  }

}


void GWater::WarpBlob(INT x, INT y, INT radius, INT height)
{
  INT cx, cy;
  INT left,top,right,bottom;
  INT square;
  INT radsquare;

//  radsquare = (radius*radius) << 8;
  radsquare = (radius*radius);

  height /= 64;

  left=-radius; right = radius;
  top=-radius; bottom = radius;

  // Perform edge clipping...
  if(x - radius < 1) left -= (x-radius-1);
  if(y - radius < 1) top  -= (y-radius-1);
  if(x + radius > WATERWID-1) right -= (x+radius-WATERWID+1);
  if(y + radius > WATERHGT-1) bottom-= (y+radius-WATERHGT+1);

  for(cy = top; cy < bottom; cy++)
  {
	for(cx = left; cx < right; cx++)
	{
	  square = cy*cy + cx*cx;
//      square <<= 8;
	  if(square < radsquare)
	  {
//        Height[Hpage][WATERWID*(cy+y) + cx+x]
//          += (sqrt(radsquare)-sqrt(square))*height;
		Height[Hpage][((cy+y)<<WATERSHFT) + cx+x]
		  += (radius-sqrt(square))*(DOUBLE)(height);
	  }
	}
  }
}

void GWater::SineBlob(INT x, INT y, INT radius, INT height)
{
  INT cx, cy;
  INT left,top,right,bottom;
  INT square, dist;
  INT radsquare;
  DOUBLE length = (1024.0/(DOUBLE)radius)*(1024.0/(DOUBLE)radius);

  if(x<0) x = 1+radius+ rand()%(WATERWID-2*radius-1);
  if(y<0) y = 1+radius+ rand()%(WATERHGT-2*radius-1);


//  radsquare = (radius*radius) << 8;
  radsquare = (radius*radius);

//  height /= 8;

  left=-radius; right = radius;
  top=-radius; bottom = radius;


  // Perform edge clipping...
  if(x - radius < 1) left -= (x-radius-1);
  if(y - radius < 1) top  -= (y-radius-1);
  if(x + radius > WATERWID-1) right -= (x+radius-WATERWID+1);
  if(y + radius > WATERHGT-1) bottom-= (y+radius-WATERHGT+1);

  for(cy = top; cy < bottom; cy++)
  {
	for(cx = left; cx < right; cx++)
	{
	  square = cy*cy + cx*cx;
	  if(square < radsquare)
	  {
		dist = sqrt(square*length);
		Height[Hpage][((cy+y)<<WATERSHFT) + cx+x]
		  += (INT)((FCos(dist)+0xffff)*(height)) >> 19;
	  }
	}
  }
}


void main(void)
{
 static GWater Water;
 Water.Start();
}
