///////////////////////////////////////////////////////////////////////////////
//
// (c) 1997 by Marc van Shaney , aka Kaya Memisoglu
//
// This Source-Code was written by and is copyrighted by Kaya Memisoglu
// You may use the whole code or only parts of it in your own programs
// whether they are commercial or not. BUT you must give credits for these
// parts to me (Kaya Memisoglu  or  Marc van Shaney).
// I am not responsible for any damage or loss caused by this program, so
// if you success in erasing your harddisk with this code, then it is your
// own fault and you should not claim me to be responsible...
// I would be very pleased if you also sent me a postcard or even a letter
// if you can use this code. My address:
//
//        Kaya Memisoglu
//        Reichenberger Ring 50
//        63512 Hainburg
//        Germany
//
//

#ifndef __GDISPLAY_H
#define __GDISPLAY_H

#include "../include/gomez.h"

#if defined(__FORWINDOWS__)
 #define WM_MESSAGE_NOTIFY			(WM_USER+100)
#endif

#if defined(__FORWINDOWS__)
 #define GKEY_BACK					VK_BACK
 #define GKEY_TAB					VK_TAB
 #define GKEY_CLEAR					VK_CLEAR
 #define GKEY_RETURN	 			VK_RETURN
 #define GKEY_SHIFT					VK_SHIFT
 #define GKEY_CONTROL				VK_CONTROL
 #define GKEY_ALT					VK_MENU
 #define GKEY_PAUSE					VK_PAUSE
 #define GKEY_CAPITAL				VK_CAPITAL
 #define GKEY_ESCAPE 				VK_ESCAPE
 #define GKEY_SPACE					VK_SPACE
 #define GKEY_PRIOR 	 			VK_PRIOR
 #define GKEY_NEXT					VK_NEXT
 #define GKEY_END					VK_END
 #define GKEY_HOME					VK_HOME
 #define GKEY_LEFT					VK_LEFT
 #define GKEY_UP		 			VK_UP
 #define GKEY_RIGHT					VK_RIGHT
 #define GKEY_DOWN					VK_DOWN
 #define GKEY_SELECT	 			VK_SELECT
 #define GKEY_PRINT					VK_PRINT
 #define GKEY_SNAPSHOT				VK_SNAPSHOT
 #define GKEY_INSERT	 			VK_INSERT
 #define GKEY_DELETE	 			VK_DELETE
 #define GKEY_HELP					VK_HELP
 #define GKEY_NUMPAD0				VK_NUMPAD0
 #define GKEY_NUMPAD1				VK_NUMPAD1
 #define GKEY_NUMPAD2				VK_NUMPAD2
 #define GKEY_NUMPAD3				VK_NUMPAD3
 #define GKEY_NUMPAD4				VK_NUMPAD4
 #define GKEY_NUMPAD5				VK_NUMPAD5
 #define GKEY_NUMPAD6				VK_NUMPAD6
 #define GKEY_NUMPAD7				VK_NUMPAD7
 #define GKEY_NUMPAD8				VK_NUMPAD8
 #define GKEY_NUMPAD9				VK_NUMPAD9
 #define GKEY_MULTIPLY				VK_MULTIPLY
 #define GKEY_ADD					VK_ADD
 #define GKEY_SEPARATOR				VK_SEPARATOR
 #define GKEY_SUBTRACT				VK_SUBTRACT
 #define GKEY_DECIMAL				VK_DECIMAL
 #define GKEY_DIVIDE	 			VK_DIVIDE
 #define GKEY_F1		 			VK_F1
 #define GKEY_F2		 			VK_F2
 #define GKEY_F3		 			VK_F3
 #define GKEY_F4		 			VK_F4
 #define GKEY_F5		 			VK_F5
 #define GKEY_F6		 			VK_F6
 #define GKEY_F7		 			VK_F7
 #define GKEY_F8		 			VK_F8
 #define GKEY_F9		 			VK_F9
 #define GKEY_F10					VK_F10
 #define GKEY_F11					VK_F11
 #define GKEY_F12					VK_F12
 #define GKEY_F13					VK_F13
 #define GKEY_F14					VK_F14
 #define GKEY_F15					VK_F15
 #define GKEY_F16					VK_F16
 #define GKEY_F17					VK_F17
 #define GKEY_F18					VK_F18
 #define GKEY_F19					VK_F19
 #define GKEY_F20					VK_F20
 #define GKEY_F21					VK_F21
 #define GKEY_F22					VK_F22
 #define GKEY_F23					VK_F23
 #define GKEY_F24					VK_F24
 #define GKEY_NUMLOCK				VK_NUMLOCK
 #define GKEY_SCROLL	 			VK_SCROLL
 #define GKEY_LSHIFT	 			VK_LSHIFT
 #define GKEY_RSHIFT	 			VK_RSHIFT
 #define GKEY_LCONTROL				VK_LCONTROL
 #define GKEY_RCONTROL				VK_RCONTROL
 #define GKEY_LALT 					VK_LMENU
 #define GKEY_RALT         			VK_RMENU
 #define GKEY_PROCESS				VK_PROCESSKEY

#else
 #define GKEY_BACK
 #define GKEY_TAB
 #define GKEY_CLEAR
 #define GKEY_RETURN					
 #define GKEY_SHIFT					
 #define GKEY_CONTROL
 #define GKEY_ALT
 #define GKEY_PAUSE					
 #define GKEY_CAPITAL
 #define GKEY_ESCAPE
 #define GKEY_SPACE
 #define GKEY_PRIOR
 #define GKEY_NEXT
 #define GKEY_END					
 #define GKEY_HOME					
 #define GKEY_LEFT
 #define GKEY_UP
 #define GKEY_RIGHT
 #define GKEY_DOWN
 #define GKEY_SELECT
 #define GKEY_PRINT
 #define GKEY_EXECUTE
 #define GKEY_SNAPSHOT
 #define GKEY_INSERT
 #define GKEY_DELETE
 #define GKEY_HELP					
 #define GKEY_NUMPAD0				
 #define GKEY_NUMPAD1
 #define GKEY_NUMPAD2
 #define GKEY_NUMPAD3
 #define GKEY_NUMPAD4
 #define GKEY_NUMPAD5				
 #define GKEY_NUMPAD6
 #define GKEY_NUMPAD7				
 #define GKEY_NUMPAD8
 #define GKEY_NUMPAD9
 #define GKEY_MULTIPLY
 #define GKEY_ADD
 #define GKEY_SEPARATOR
 #define GKEY_SUBTRACT
 #define GKEY_DECIMAL
 #define GKEY_DIVIDE
 #define GKEY_F1
 #define GKEY_F2
 #define GKEY_F3
 #define GKEY_F4
 #define GKEY_F5
 #define GKEY_F6
 #define GKEY_F7
 #define GKEY_F8
 #define GKEY_F9
 #define GKEY_F10
 #define GKEY_F11
 #define GKEY_F12
 #define GKEY_F13
 #define GKEY_F14
 #define GKEY_F15
 #define GKEY_F16
 #define GKEY_F17
 #define GKEY_F18
 #define GKEY_F19
 #define GKEY_F20
 #define GKEY_F21
 #define GKEY_F22
 #define GKEY_F23
 #define GKEY_F24
 #define GKEY_NUMLOCK
 #define GKEY_SCROLL
 #define GKEY_LSHIFT
 #define GKEY_RSHIFT
 #define GKEY_LCONTROL
 #define GKEY_RCONTROL
 #define GKEY_LALT
 #define GKEY_RALT
 #define GKEY_PROCESS
#endif




class GDisplay : public GImage {
		friend class GFrame;

		#if defined(__FORWINDOWS__)
		 friend INT WINAPI WinMain(HINSTANCE ,HINSTANCE ,LPSTR ,INT );
		#else
		 friend void main(void);
		#endif

        public:
        enum {
            DISPLAY_TYPE = MAKETYPE('D','I','S','P')
        };
        enum {
            PALETTE =	0x00000001,
            RESIZEABLE = 0x00000002,
            STARTED = 0x00000004
        };
        enum {
			LBUTTONUP = 0x00000001,
			MBUTTONUP =	0x00000002,
			RBUTTONUP =	0x00000004,
			LBUTTONDOWN = 0x00000008,
			MBUTTONDOWN = 0x00000010,
			RBUTTONDOWN = 0x00000020
        };
        const static char CLASSNAME[];

		private:
		#if defined(__FORWINDOWS__)
		 HWND       WindowHandle;
		 HDC        DeviceHandle;
		 HPALETTE	PaletteHandle;
		 HPALETTE   OldPaletteHandle;
		 LOGPALETTE	*Palette;
        #elif defined(__FORX11__)
         Window		WindowHandle;
         GC			DeviceHandle;
         Colormap	PaletteHandle;
         XColor  	*Palette;
		 ULONG 		Colours[256];
		#elif defined(__FORDOS__)
		 GPalette  	*Palette
		 static INT	Mode;
		#else
		 GPalette   *Palette
		#endif

        protected:
		GPointL		MousePosition;
		DWORD		MouseButtons;
		LONG		TimerSpeed;
		LONG		SuspendCount;

		public:
		GDisplay(CHAR *name=NULL,DWORD typ=DISPLAY_TYPE);
		~GDisplay();

        CHAR*		FASTCALL SetDefaultName();

		BOOL		FASTCALL Open(CHAR* ,INT ,INT ,INT ,DWORD f=0);
		BOOL		FASTCALL Open(INT ,INT ,INT ,DWORD f=0);
		BOOL		FASTCALL Close(void);
		GPalette*	FASTCALL SetPalette(GPalette *,INT s=0,INT c=256);
		GPalette*	FASTCALL GetPalette(GPalette *,INT s=0,INT c=256);
		GColour		FASTCALL SetColour(INT ,GColour& );
		GColour  	FASTCALL GetColour(INT );
		BOOL        FASTCALL RealizePalette(void);
		BOOL        FASTCALL UnrealizePalette(void);

		BOOL        FASTCALL Start(LONG p=0);
		BOOL        FASTCALL Terminate(void);
		BOOL        FASTCALL Resume(void);
		BOOL        FASTCALL Suspend(void);
		LONG		FASTCALL GetSuspendCount(void);

		GPointL		FASTCALL GetMousePosition(void);
		DWORD		FASTCALL GetMouseButtons(void);
		BOOL        FASTCALL PutFrame(GFrame *,INT x=0,INT y=0);

		GRectL		FASTCALL SetClipWindow(INT ,INT ,INT ,INT );
		GRectL		FASTCALL SetClipWindow(GRectL& );
		CHAR*		FASTCALL GetFlagsName(CHAR *);

		LONG        FASTCALL SetTimerSpeed(LONG );
		LONG        FASTCALL GetTimerSpeed(void);

		PTR			FASTCALL GetDisplayHandle(void);
		BOOL		FASTCALL ReleaseDisplayHandle(PTR );

        BOOL		FASTCALL SetResizeable(BOOL );
        BOOL		FASTCALL IsResizeable();

		protected:
		virtual BOOL FASTCALL OnSuspend(void);
		virtual BOOL FASTCALL OnResume(void);
		virtual BOOL FASTCALL OnStart(LONG );
		virtual BOOL FASTCALL OnTerminate(void);
		virtual BOOL FASTCALL OnPaint(void);
		virtual BOOL FASTCALL OnResize(INT ,INT );
		virtual BOOL FASTCALL OnTimer(LONG ,LONG );
		virtual BOOL FASTCALL OnKeyDown(LONG );
		virtual BOOL FASTCALL OnKeyUp(LONG );
		virtual BOOL FASTCALL OnChar(LONG );
		virtual BOOL FASTCALL OnMouseMove(DWORD, LONG ,LONG );
		virtual BOOL FASTCALL OnMouseButton(DWORD ,LONG ,LONG );
        virtual BOOL FASTCALL OnActivate(void);
        virtual BOOL FASTCALL OnDeactivate(void);
        virtual BOOL FASTCALL OnMessage(void);

		private:
		#if defined(__FORWINDOWS__)
		 static LRESULT CALLBACK WindowStartProc(HWND hwnd, UINT Message,WPARAM wParam, LPARAM lParam);
		 static LRESULT CALLBACK WindowProc(HWND hwnd, UINT Message,WPARAM wParam, LPARAM lParam);
		 virtual WNDPROC FASTCALL GetWindowProc(void);
         void FASTCALL NotifyMessage();
         void FASTCALL UpdateWindowStyle();
		#endif
	   };



///////////////////////////////////////////////////////////////////////////////
//
// Implementation of GDisplay
//
inline GDisplay::GDisplay(CHAR* name,DWORD typ) : GImage(name,typ) {
   #if defined(__FORWINDOWS__)
  	WindowHandle=NULL;
  	DeviceHandle=NULL;
  	PaletteHandle=NULL;
  	OldPaletteHandle=NULL;
  	Palette=NULL;
   #elif defined(__FORDOS__)
   	Palette=NULL;
  	Mode=NULL;
   #else
  	Palette=NULL;
   #endif
}

inline GDisplay::~GDisplay() {
 	Close();
}

inline CHAR* FASTCALL GDisplay::SetDefaultName() {
 	strcpy(Name,"display");
    return Name;
}

inline BOOL FASTCALL GDisplay::Open(INT w,INT h,INT d,DWORD f) {
 	return Open(GetName(),w,h,d,f);
}

inline PTR FASTCALL GDisplay::GetDisplayHandle(void) {
   #if defined(__FORWINDOWS__)
  	return (PTR)GetDC(WindowHandle);
   #elif defined(__FORX11__)

   #else
  	return (PTR)this;
   #endif
}

inline BOOL FASTCALL GDisplay::ReleaseDisplayHandle(PTR hdc) {
   #if defined(__FORWINDOWS__)
  	return ReleaseDC(WindowHandle,(HDC)hdc);
   #elif defined(__FORX11__)

   #else
  	return TRUE;
   #endif
}

inline GColour FASTCALL GDisplay::GetColour(INT i) {
 	if(!Palette) return GColour(0,0,0);
   #if defined(__FORWINDOWS__)
  	return GColour(Palette->palPalEntry[i].peRed,
				   Palette->palPalEntry[i].peGreen,
				   Palette->palPalEntry[i].peBlue);
   #elif defined(__FORX11__)

   #else
  	return Palette->Colour[i];
   #endif
}

inline GRectL FASTCALL GDisplay::SetClipWindow(INT l,INT t,INT r,INT b) {
   #if defined(__FORWINDOWS__)
  	GImage::SetClipWindow(l,t,r,b);
  	SelectClipRgn(DeviceHandle,CreateRectRgn(ClipWindow.Left,ClipWindow.Top,ClipWindow.Right,ClipWindow.Bottom));
  	return ClipWindow;
   #else
  	return GImage::SetClipWindow(l,t,r,b);
   #endif
}

inline GRectL FASTCALL GDisplay::SetClipWindow(GRectL &r) {
   #if defined(__FORWINDOWS__)
  	GImage::SetClipWindow(r);
  	SelectClipRgn(DeviceHandle,CreateRectRgn(ClipWindow.Left,ClipWindow.Top,ClipWindow.Right,ClipWindow.Bottom));
  	return ClipWindow;
   #else
  	return GImage::SetClipWindow(r);
   #endif
}

inline BOOL FASTCALL GDisplay::PutFrame(GFrame *f,INT x,INT y) {
   #if defined(__FORWINDOWS__)
  	if (!DeviceHandle) return FALSE;
  	BitBlt(DeviceHandle,x,y,f->Width,f->Height,f->DeviceHandle,0,0,SRCCOPY);
 	return TRUE;
   #elif defined(__FORX11__)
 	return TRUE;
   #else
 	return FALSE;
   #endif
}

inline LONG FASTCALL GDisplay::GetSuspendCount(void) {
 	return SuspendCount;
}

inline LONG FASTCALL GDisplay::GetTimerSpeed(void) {
 	return TimerSpeed;
}

inline GPointL FASTCALL GDisplay::GetMousePosition(void) {
 	return MousePosition;
}

inline DWORD FASTCALL GDisplay::GetMouseButtons(void) {
 	return MouseButtons;
}

inline BOOL FASTCALL GDisplay::SetResizeable(BOOL state) {
	if (state)
		Flags|=RESIZEABLE;
    else
		Flags&=~RESIZEABLE;
   #if defined(__FORWINDOWS__)
	UpdateWindowStyle();
   #endif
    return state;
}

inline BOOL FASTCALL GDisplay::IsResizeable() {
	return (BOOL)(Flags & RESIZEABLE);
}

inline void FASTCALL GDisplay::NotifyMessage(void) {
   #if defined(__FORWINDOWS__)
  	::PostMessage(WindowHandle,WM_MESSAGE_NOTIFY,0,0);
   #elif defined(__FORX11__)

   #endif
}

inline BOOL FASTCALL GDisplay::OnPaint(void) {
 	return TRUE;
}

inline BOOL FASTCALL GDisplay::OnActivate(void) {
 	return TRUE;
}

inline BOOL FASTCALL GDisplay::OnDeactivate(void) {
 	return TRUE;
}

#pragma argsused
inline BOOL FASTCALL GDisplay::OnResize(INT a,INT b) {
 	return TRUE;
}

inline BOOL FASTCALL GDisplay::OnMessage(void) {
 	return TRUE;
}

#pragma argsused
inline BOOL FASTCALL GDisplay::OnTimer(LONG a,LONG b) {
 	return TRUE;
}

inline BOOL FASTCALL GDisplay::OnSuspend(void) {
 	return TRUE;
}

inline BOOL FASTCALL GDisplay::OnResume(void) {
 	return TRUE;
}

#pragma argsused
inline BOOL FASTCALL GDisplay::OnStart(LONG a) {
 	return TRUE;
}

inline BOOL FASTCALL GDisplay::OnTerminate(void) {
 	return Close();
}

#pragma argsused
inline BOOL FASTCALL GDisplay::OnKeyDown(LONG a) {
 	return TRUE;
}

#pragma argsused
inline BOOL FASTCALL GDisplay::OnKeyUp(LONG a) {
 	return TRUE;
}

#pragma argsused
inline BOOL FASTCALL GDisplay::OnChar(LONG a) {
 	return TRUE;
}

#pragma argsused
inline BOOL FASTCALL GDisplay::OnMouseMove(DWORD b,LONG x,LONG y) {
 	return TRUE;
}

#pragma argsused
inline BOOL FASTCALL GDisplay::OnMouseButton(DWORD a,LONG x,LONG y) {
 	return TRUE;
}

#if defined(__FORWINDOWS__)
inline WNDPROC FASTCALL GDisplay::GetWindowProc(void) {
 	return WindowProc;
}
#endif
#endif
