///////////////////////////////////////////////////////////////////////////////
//
// (c) 1997 by Marc van Shaney , aka Kaya Memisoglu
//
// This Source-Code was written by and is copyrighted by Kaya Memisoglu
// You may use the whole code or only parts of it in your own programs
// whether they are commercial or not. BUT you must give credits for these
// parts to me (Kaya Memisoglu  or  Marc van Shaney).
// I am not responsible for any damage or loss caused by this program, so
// if you success in erasing your harddisk with this code, then it is your
// own fault and you should not claim me to be responsible...
// I would be very pleased if you also sent me a postcard or even a letter
// if you can use this code. My address:
//
//        Kaya Memisoglu
//        Reichenberger Ring 50
//        63512 Hainburg
//        Germany
//
//


#ifndef __GERROR_H
#define __GERROR_H

#define GMZ_LOGFILE_ERRORS			((DWORD)0x00000001)
#define GMZ_LOGFILE_WARNINGS		((DWORD)0x00000002)
#define GMZ_LOGFILE_MESSAGES		((DWORD)0x00000004)
#define GMZ_LOGFILE_ALL				((DWORD)0x00000007)

#define GAssert(a) \
	{if (!(a)) GErrorLog.Error(__FILE__,__LINE__,"Assertion failed");}


class GLogFile {
		private:
        CHAR		Name[MAXPATH];
        FILE		*LogHandle;
        DWORD		LogLevel;
        DWORD		DisplayLevel;

        public:
        GLogFile(CHAR *fname=NULL);
        ~GLogFile();
        BOOL		FASTCALL Open(void);
        BOOL		FASTCALL Close(void);
        BOOL		FASTCALL Error(CHAR* file,CHAR* line,CHAR* );
        BOOL		FASTCALL Warning(CHAR* file,CHAR* line,CHAR* );
        BOOL		FASTCALL Message(CHAR* file,CHAR* line,CHAR* );
        BOOL		FASTCALL Error(CHAR* );
        BOOL		FASTCALL Warning(CHAR* );
        BOOL		FASTCALL Message(CHAR* );
        BOOL 		FASTCALL EnableLogLevel(DWORD );
        BOOL 		FASTCALL DisableLogLevel(DWORD );
        BOOL 		FASTCALL EnableDisplayLevel(DWORD );
        BOOL 		FASTCALL DisableDisplayLevel(DWORD );

        private:
        BOOL		FASTCALL Print(CHAR* file,CHAR* line,CHAR *type,CHAR *text);
	   };

inline GLogFile::GLogFile(CHAR *fname)
{
 if (fname)
 	strcpy(Name,fname);
 else
 	strcpy(Name,"gomez.log");
 LogHandle=NULL;
 LogLevel=GMZ_LOGFILE_ALL;
 DisplayLevel=GMZ_LOGFILE_ERRORS;
}

inline GLogFile::~GLogFile()
{
 Close();
}

inline BOOL FASTCALL GLogFile::Open(void)
{
 time_t today;
 if ((LogHandle=fopen(Name,"wt"))==NULL) return FALSE;
 time(&today);
 fprintf(LogHandle,"LogFile opened on %s\n",ctime(&today));
 return TRUE;
}

inline BOOL FASTCALL GLogFile::Close(void)
{
 time_t today;
 if (!LogHandle) return TRUE;
 time(&today);
 fprintf(LogHandle,"LogFile closed on %s\n",ctime(&today));
 fclose(LogHandle);
 LogHandle=NULL;
 return TRUE;
}

inline BOOL FASTCALL GLogFile::Error(CHAR *t)
{
 return Error("???","???",t);
}

inline BOOL FASTCALL GLogFile::Warning(CHAR *t)
{
 return Warning("???","???",t);
}

inline BOOL FASTCALL GLogFile::Message(CHAR *t)
{
 return Message("???","???",t);
}

inline BOOL FASTCALL GLogFile::Error(CHAR *f,CHAR *l,CHAR* m)
{
 if(LogLevel & GMZ_LOGFILE_ERRORS)
 	return Print(f,l,"Error",m);
 return TRUE;
}

inline BOOL FASTCALL GLogFile::Warning(CHAR *f,CHAR *l,CHAR* m)
{
 if(LogLevel & GMZ_LOGFILE_WARNINGS)
 	return Print(f,l,"Warning",m);
 return TRUE;
}

inline BOOL FASTCALL GLogFile::Message(CHAR *f,CHAR *l,CHAR* m)
{
 if(LogLevel & GMZ_LOGFILE_MESSAGES)
 	return Print(f,l,"Message",m);
 return TRUE;
}

inline BOOL FASTCALL GLogFile::Print(CHAR *f,CHAR *l,CHAR *t,CHAR* m)
{
 fprintf(LogHandle,"%s [%16s:%6s] : %s\n",t,f,l,m);
 return TRUE;
}
#endif
