///////////////////////////////////////////////////////////////////////////////
//
// (c) 1997 by Marc van Shaney , aka Kaya Memisoglu
//
// This Source-Code was written by and is copyrighted by Kaya Memisoglu
// You may use the whole code or only parts of it in your own programs
// whether they are commercial or not. BUT you must give credits for these
// parts to me (Kaya Memisoglu  or  Marc van Shaney).
// I am not responsible for any damage or loss caused by this program, so
// if you success in erasing your harddisk with this code, then it is your
// own fault and you should not claim me to be responsible...
// I would be very pleased if you also sent me a postcard or even a letter
// if you can use this code. My address:
//
//        Kaya Memisoglu
//        Reichenberger Ring 50
//        63512 Hainburg
//        Germany
//
//


#ifndef __GFRAME_H
#define __GFRAME_H

#include "../include/gomez.h"

#define GMZ_ALPHA_STENCILFAILED		((INT)0x00001)
#define GMZ_ALPHA_DEPTHFAILED		((INT)0x00002)
#define GMZ_ALPHA_STENCILPASSED		((INT)0x00004)
#define GMZ_ALPHA_DEPTHPASSED		((INT)0x00008)
#define GMZ_ALPHA_ALLPASSED			(GMZ_ALPHA_STENCILPASSED | GMZ_ALPHA_DEPTHPASSED)

#pragma option -a1
typedef struct {
		ULONG 		Depth;
        USHORT		Stencil;
        USHORT		Blend;
       } GAlpha;
typedef struct {
		LONG		Red;
        LONG		Green;
        LONG		Blue;
        LONG		Alpha;
	   } GAccPixel;
typedef struct {
		ULONG 		Depth;
        USHORT		Stencil;
        USHORT		Blend;
        DWORD		Colour;
	   } GExtPixel;
#pragma option -a.

class GAlphaBuffer : public GRasterImage {
		public:
        enum {
            ALPHABUFFER_TYPE = MAKETYPE('A','L','P','H')
        };
        enum {
            DEPTHBUFFER			= 0x00000001,
            STENCILBUFFER		= 0x00000002,
            BLENDBUFFER			= 0x00000004,
            PALETTE				= 0x00000008,
            STENCILENABLED		= 0x00000010,
            DEPTHENABLED		= 0x00000020,
            BLENDENABLED		= 0x00000040
		};
        enum {
            STENCILTEST_TRUE   	= 0x00001,
            STENCILTEST_FALSE  	= 0x00002,
            STENCILTEST_EQUAL  	= 0x00003,
            STENCILTEST_NOTEQUAL= 0x00004,
            STENCILTEST_GREATER	= 0x00005,
            STENCILTEST_LESS   	= 0x00006,
            STENCILTEST_GEQUAL 	= 0x00007,
            STENCILTEST_LEQUAL 	= 0x00008,

            STENCILOP_KEEP	   	= 0x00001,
            STENCILOP_ZERO	   	= 0x00002,
            STENCILOP_REPLACE  	= 0x00003,
            STENCILOP_INCREMENT	= 0x00004,
            STENCILOP_DECREMENT	= 0x00005,
            STENCILOP_INVERT   	= 0x00006,
            STENCILOP_MAX	   	= 0x00007,
            STENCILOP_MIN	   	= 0x00008,

            BLENDOP_IGNORE	   	= 0x00001,
            BLENDOP_REPLACE	   	= 0x00002,

            DEPTHTEST_TRUE	   	= 0x00001,
            DEPTHTEST_FALSE	   	= 0x00002,
            DEPTHTEST_EQUAL	   	= 0x00003,
            DEPTHTEST_NOTEQUAL 	= 0x00004,
            DEPTHTEST_GREATER  	= 0x00005,
            DEPTHTEST_LESS	   	= 0x00006,
            DEPTHTEST_GEQUAL   	= 0x00007,
            DEPTHTEST_LEQUAL   	= 0x00008
		};

		protected:
		BYTE		PixelMask[GMZ_MAX_FRAMEWIDTH];
		GAlpha*		AlphaBuffer;
        INT			StencilTest;
		INT			StencilOpFail;
        INT			StencilOpPass;
        INT			StencilOpZFail;
        USHORT		StencilMask;
        INT			DepthTest;
        BOOL		DepthMask;
        INT			BlendOpSrc;
        INT			BlendOpDst;

		public:
		GAlphaBuffer(CHAR *name=NULL,DWORD typ=ALPHABUFFER_TYPE);
		~GAlphaBuffer();

        CHAR*		FASTCALL SetDefaultName();

		BOOL 		FASTCALL Alloc(INT ,INT ,INT=0);
		BOOL		FASTCALL Free(void);
		BOOL		FASTCALL Resize(INT ,INT );
        BOOL		FASTCALL Clear(void);

        BOOL		FASTCALL ClearStencil(USHORT s=0);
        BOOL		FASTCALL ClearBlend(USHORT s=0);
        BOOL		FASTCALL ClearDepth(ULONG d=0);

		void		FASTCALL PutPixel(INT ,INT ,DWORD ,ULONG ,USHORT );
        void		FASTCALL PutSpan(INT ,INT ,INT ,GExtPixel* );
        void		FASTCALL GetSpan(INT ,INT ,INT ,GExtPixel* );
		void		FASTCALL PutSpan(INT ,INT ,INT ,GPixel* ,ULONG ,USHORT );
        void		FASTCALL PutSpan(INT ,INT ,INT ,DWORD ,ULONG ,USHORT );

		void		FASTCALL PutPixel(INT ,INT ,DWORD );
        void		FASTCALL PutSpan(INT ,INT ,INT ,GPixel* );
        void		FASTCALL PutSpan(INT ,INT ,INT ,DWORD );
        void		FASTCALL GetSpan(INT ,INT ,INT ,GPixel* );

		BOOL		FASTCALL ClearAlpha(ULONG d=0,USHORT s=0,USHORT b=0);
		GAlpha*	  	FASTCALL GetAlpha(void);
		GAlpha*	  	FASTCALL GetAlpha(GAlpha *,INT startrow=0,INT count=0);
		GAlpha*	  	FASTCALL SetAlpha(GAlpha *,INT startrow=0,INT count=0);

		INT 		FASTCALL SetStencilTest(INT );
		INT			FASTCALL GetStencilTest(void);
		BOOL		FASTCALL SetStencilOperation(INT ,INT ,INT );
        BOOL		FASTCALL EnableStencil(void);
        BOOL		FASTCALL DisableStencil(void);

		INT 		FASTCALL SetDepthTest(INT );
        INT			FASTCALL GetDepthTest(void);
        BOOL		FASTCALL EnableDepth(void);
        BOOL		FASTCALL DisableDepth(void);

		BOOL		FASTCALL EnableBlend(void);
        BOOL		FASTCALL DisableBlend(void);
		INT			FASTCALL SetBlendOperation(INT ,INT );

        BOOL		FASTCALL SetDepthMask(BOOL );
        BOOL		FASTCALL SetStencilMask(USHORT );

		CHAR*		FASTCALL GetFlagsName(CHAR *);

        protected:
        void		FASTCALL SetAlphaFunctions(void);
        void		FASTCALL AddStencilMask(GAlpha* ,INT ,USHORT );
        void		FASTCALL AddStencilMask(GAlpha* ,INT ,GExtPixel* );
        void		FASTCALL AddDepthMask(GAlpha* ,INT ,ULONG );
        void		FASTCALL AddDepthMask(GAlpha* ,INT ,GExtPixel* );
        void		FASTCALL ApplyStencilFunction(GAlpha* ,INT ,USHORT );
        void		FASTCALL ApplyStencilFunction(GAlpha* ,INT ,GExtPixel *);

        private:
		BOOL		(FASTCALL GAlphaBuffer::*StencilTestFunc)(USHORT ,USHORT );
		USHORT		(FASTCALL GAlphaBuffer::*StencilOpFailFunc)(USHORT ,USHORT );
		USHORT		(FASTCALL GAlphaBuffer::*StencilOpPassFunc)(USHORT ,USHORT );
		USHORT		(FASTCALL GAlphaBuffer::*StencilOpZFailFunc)(USHORT ,USHORT );
		BOOL		(FASTCALL GAlphaBuffer::*DepthTestFunc)(ULONG ,ULONG );

		BOOL		FASTCALL StencilTestTrue(USHORT ,USHORT );
		BOOL		FASTCALL StencilTestFalse(USHORT ,USHORT );
		BOOL		FASTCALL StencilTestEqual(USHORT ,USHORT );
		BOOL		FASTCALL StencilTestNotEqual(USHORT ,USHORT );
		BOOL		FASTCALL StencilTestLess(USHORT ,USHORT );
		BOOL		FASTCALL StencilTestLessEqual(USHORT ,USHORT );
		BOOL		FASTCALL StencilTestGreater(USHORT ,USHORT );
		BOOL		FASTCALL StencilTestGreaterEqual(USHORT ,USHORT );

  		BOOL		FASTCALL DepthTestTrue(ULONG ,ULONG );
		BOOL		FASTCALL DepthTestFalse(ULONG ,ULONG );
		BOOL		FASTCALL DepthTestEqual(ULONG ,ULONG );
		BOOL		FASTCALL DepthTestNotEqual(ULONG ,ULONG );
		BOOL		FASTCALL DepthTestLess(ULONG ,ULONG );
		BOOL		FASTCALL DepthTestLessEqual(ULONG ,ULONG );
 		BOOL		FASTCALL DepthTestGreater(ULONG ,ULONG );
		BOOL		FASTCALL DepthTestGreaterEqual(ULONG ,ULONG );

        USHORT		FASTCALL StencilOpKeep(USHORT ,USHORT );
        USHORT		FASTCALL StencilOpZero(USHORT ,USHORT );
        USHORT		FASTCALL StencilOpReplace(USHORT ,USHORT );
        USHORT		FASTCALL StencilOpIncrement(USHORT ,USHORT );
        USHORT		FASTCALL StencilOpDecrement(USHORT ,USHORT );
		USHORT		FASTCALL StencilOpInvert(USHORT ,USHORT );
        USHORT		FASTCALL StencilOpMin(USHORT ,USHORT );
        USHORT		FASTCALL StencilOpMax(USHORT ,USHORT );

        void		(FASTCALL GAlphaBuffer::*GetExtSpanFunc)(INT ,INT ,INT ,GExtPixel* );
        void 		(FASTCALL GAlphaBuffer::*PutExtSpanFunc)(INT ,INT ,INT ,GExtPixel* );
        void		(FASTCALL GAlphaBuffer::*PutPixSpanFunc)(INT ,INT ,INT ,GPixel* ,ULONG ,USHORT);
        void		(FASTCALL GAlphaBuffer::*PutColSpanFunc)(INT ,INT ,INT ,DWORD ,ULONG ,USHORT);

        void		FASTCALL PutExtSpan0(INT ,INT ,INT ,GExtPixel *);
        void		FASTCALL PutExtSpan8(INT ,INT ,INT ,GExtPixel *);
        void		FASTCALL PutExtSpan16(INT ,INT ,INT ,GExtPixel *);
        void		FASTCALL PutExtSpan32(INT ,INT ,INT ,GExtPixel *);
        void		FASTCALL GetExtSpan0(INT ,INT ,INT ,GExtPixel *);
        void		FASTCALL GetExtSpan8(INT ,INT ,INT ,GExtPixel *);
        void		FASTCALL GetExtSpan16(INT ,INT ,INT ,GExtPixel *);
        void		FASTCALL GetExtSpan32(INT ,INT ,INT ,GExtPixel *);
        void		FASTCALL PutPixSpan0(INT ,INT ,INT ,GPixel* ,ULONG ,USHORT );
        void		FASTCALL PutPixSpan8(INT ,INT ,INT ,GPixel* ,ULONG ,USHORT );
        void		FASTCALL PutPixSpan16(INT ,INT ,INT ,GPixel* ,ULONG ,USHORT );
        void		FASTCALL PutPixSpan32(INT ,INT ,INT ,GPixel* ,ULONG ,USHORT );
		void		FASTCALL PutColSpan0(INT ,INT ,INT ,DWORD ,ULONG ,USHORT );
		void		FASTCALL PutColSpan8(INT ,INT ,INT ,DWORD ,ULONG ,USHORT );
		void		FASTCALL PutColSpan16(INT ,INT ,INT ,DWORD ,ULONG ,USHORT );
		void		FASTCALL PutColSpan32(INT ,INT ,INT ,DWORD ,ULONG ,USHORT );
	   };

class GFrame : public GAlphaBuffer {
		friend class GDisplay;

        public:
        enum {
        	FRAME_TYPE = MAKETYPE('F','R','A','M')
        };

		protected:
		GDisplay* 	Display;

		private:
		#if defined(__FORWINDOWS__)
		 HDC       	DeviceHandle;
		 RGBQUAD*  	Palette;
		 HBITMAP  	BitmapHandle;
		 HBITMAP   	OldBitmapHandle;
		 BITMAPINFO* BitmapInfo;
        #elif defined(__FORX11__)

		#else
		 GPalette* 	Palette;
		#endif

		public:
		GFrame(GDisplay *hdc=NULL);
		~GFrame();

        CHAR*		FASTCALL SetDefaultName();

		BOOL 		FASTCALL Alloc(INT ,INT ,INT=0);
		BOOL		FASTCALL Free(void);
		BOOL		FASTCALL Resize(INT ,INT );
		BOOL		FASTCALL Put(PTR ,INT x=0,INT y=0);
		BOOL		FASTCALL Put(GDisplay *,INT x=0,INT y=0);

		GPalette*	FASTCALL SetPalette(GPalette *,INT f=0,INT c=256);
		GPalette* 	FASTCALL GetPalette(GPalette *,INT f=0,INT c=256);
		GColour		FASTCALL SetColour(INT ,GColour& );
		GColour  	FASTCALL GetColour(INT );
		BOOL		FASTCALL RealizePalette(void);
		BOOL        FASTCALL UnrealizePalette(void);

		PTR			FASTCALL GetBitmapHandle(void);
	   };

class GAccumulationBuffer:public GImageBuffer<GAlpha> {
		public:
		GAccumulationBuffer(CHAR *name=NULL,DWORD typ=IMAGE_TYPE);
		~GAccumulationBuffer();

        CHAR*		FASTCALL SetDefaultName();
        
        BOOL		FASTCALL AddColour(GColour &);
        BOOL		FASTCALL SubColour(GColour &);
        BOOL		FASTCALL MultColour(DOUBLE ,DOUBLE ,DOUBLE ,DOUBLE );
		BOOL		FASTCALL MultColour(DOUBLE );

		BOOL		FASTCALL AddFrame(GFrame *);
		BOOL		FASTCALL SubFrame(GFrame *);
        BOOL		FASTCALL PutFrame(GFrame *);
        BOOL		FASTCALL GetFrame(GFrame *);

		CHAR*		FASTCALL GetFlagsName(CHAR *);
	   };

///////////////////////////////////////////////////////////////////////////////
//
// Implementation of GAlphaBuffer
//
inline GAlphaBuffer::GAlphaBuffer(CHAR *name,DWORD typ) : GRasterImage(name,typ) {
 	AlphaBuffer=NULL;
 	StencilTest=STENCILTEST_TRUE;
 	StencilOpPass=STENCILOP_REPLACE;
 	StencilOpFail=STENCILOP_KEEP;
 	StencilOpZFail=STENCILOP_KEEP;
 	StencilMask=~0;
 	DepthTest=DEPTHTEST_TRUE;
	DepthMask=TRUE;
 	BlendOpSrc=BLENDOP_IGNORE;
 	BlendOpDst=BLENDOP_REPLACE;
 	Flags&=~(DEPTHENABLED | STENCILENABLED);
 	SetPixelFunctions();
 	SetAlphaFunctions();
}

inline GAlphaBuffer::~GAlphaBuffer() {
 	Free();
}

inline CHAR* FASTCALL GAlphaBuffer::SetDefaultName() {
 	strcpy(Name,"alpha buffer");
    return Name;
}

inline BOOL FASTCALL GAlphaBuffer::Resize(INT w,INT h) {
 	INT d=Depth;
 	Free();
 	return Alloc(w,h,d);
}

inline BOOL FASTCALL GAlphaBuffer::Clear(void) {
 	if ((!ImageBuffer) || (!AlphaBuffer)) return FALSE;
 	memset(ImageBuffer,0,LineSize*Height);
 	memset(AlphaBuffer,0,Width*Height*sizeof(GAlpha));
 	return TRUE;
}

inline void	FASTCALL GAlphaBuffer::PutPixel(INT x,INT y,DWORD c) {
 	GRasterImage::PutPixel(x,y,c);
}

inline void	FASTCALL GAlphaBuffer::PutSpan(INT x,INT y,INT l,GPixel *p) {
 	GRasterImage::PutSpan(x,y,l,p);
}

inline void	FASTCALL GAlphaBuffer::PutSpan(INT x,INT y,INT l,DWORD c) {
 	GRasterImage::PutSpan(x,y,l,c);
}

inline void	FASTCALL GAlphaBuffer::GetSpan(INT x,INT y,INT l,GPixel *p) {
 	GRasterImage::GetSpan(x,y,l,p);
}

inline void FASTCALL GAlphaBuffer::PutSpan(INT x,INT y,INT l,GExtPixel *p) {
 	(this->*PutExtSpanFunc)(x,y,l,p);
}

inline void FASTCALL GAlphaBuffer::GetSpan(INT x,INT y,INT l,GExtPixel *p) {
 	(this->*GetExtSpanFunc)(x,y,l,p);
}

inline void FASTCALL GAlphaBuffer::PutSpan(INT x,INT y,INT l,GPixel *p,ULONG d,USHORT s) {
 	(this->*PutPixSpanFunc)(x,y,l,p,d,s);
}

inline void FASTCALL GAlphaBuffer::PutSpan(INT x,INT y,INT l,DWORD c,ULONG d,USHORT s) {
 	(this->*PutColSpanFunc)(x,y,l,c,d,s);
}

inline GAlpha* FASTCALL GAlphaBuffer::GetAlpha(void) {
 	return AlphaBuffer;
}

inline GAlpha* FASTCALL GAlphaBuffer::GetAlpha(GAlpha* dst,INT start,INT count) {
 	if (count==0) count=Height-start;
 	return (GAlpha *)memcpy(dst,&AlphaBuffer[start*Width],count*Width*sizeof(GAlpha));
}

inline GAlpha* FASTCALL GAlphaBuffer::SetAlpha(GAlpha* src,INT start,INT count) {
 	if (count==0) count=Height-start;
 	return (GAlpha *)memcpy(&AlphaBuffer[start*Width],src,count*Width*sizeof(GAlpha));
}

inline INT FASTCALL GAlphaBuffer::SetStencilTest(INT i) {
 	StencilTest=i;
 	SetAlphaFunctions();
 	return StencilTest;
}

inline INT FASTCALL GAlphaBuffer::GetStencilTest(void) {
 	return StencilTest;
}

inline BOOL FASTCALL GAlphaBuffer::SetStencilOperation(INT fail,INT pass,INT zfail) {
 	StencilOpFail=fail;
 	StencilOpPass=pass;
 	StencilOpZFail=zfail;
 	SetAlphaFunctions();
 	return ((StencilOpFail==fail) && (StencilOpPass==pass) && (StencilOpZFail==zfail));
}

inline BOOL FASTCALL GAlphaBuffer::EnableStencil(void) {
 	if (!(Flags & STENCILBUFFER) || !(AlphaBuffer)) return FALSE;
 	return (BOOL)(Flags|=STENCILENABLED);
}

inline BOOL FASTCALL GAlphaBuffer::DisableStencil(void) {
 	return (BOOL)(Flags&=~STENCILENABLED);
}

inline INT FASTCALL GAlphaBuffer::SetDepthTest(INT i) {
 	DepthTest=i;
 	SetAlphaFunctions();
 	return DepthTest;
}

inline INT FASTCALL GAlphaBuffer::GetDepthTest(void) {
 	return DepthTest;
}

inline BOOL FASTCALL GAlphaBuffer::EnableDepth(void) {
 	if (!(Flags & DEPTHBUFFER) || !(AlphaBuffer)) return FALSE;
 	return (BOOL)(Flags|=DEPTHENABLED);
}

inline BOOL FASTCALL GAlphaBuffer::DisableDepth(void) {
 	return (BOOL)(Flags&=~DEPTHENABLED);
}

inline BOOL FASTCALL GAlphaBuffer::SetBlendOperation(INT src,INT dst) {
 	BlendOpSrc=src;
 	BlendOpDst=dst;
 	SetAlphaFunctions();
 	return ((BlendOpSrc==src) && (BlendOpDst==dst));
}

inline BOOL FASTCALL GAlphaBuffer::EnableBlend(void) {
 	if (!(Flags & BLENDBUFFER) || !(AlphaBuffer)) return FALSE;
 	return (BOOL)(Flags|=BLENDENABLED);
}

inline BOOL FASTCALL GAlphaBuffer::DisableBlend(void) {
 	return (BOOL)(Flags&=~BLENDENABLED);
}

inline BOOL FASTCALL GAlphaBuffer::StencilTestEqual(USHORT o,USHORT n) {
 	return o==n;
}

inline BOOL FASTCALL GAlphaBuffer::StencilTestNotEqual(USHORT o,USHORT n) {
 	return o!=n;
}

inline BOOL FASTCALL GAlphaBuffer::StencilTestGreater(USHORT o,USHORT n) {
 	return o<n;
}

inline BOOL FASTCALL GAlphaBuffer::StencilTestGreaterEqual(USHORT o,USHORT n) {
 	return o<=n;
}

inline BOOL FASTCALL GAlphaBuffer::StencilTestLess(USHORT o,USHORT n) {
 	return o>n;
}

inline BOOL FASTCALL GAlphaBuffer::StencilTestLessEqual(USHORT o,USHORT n) {
 	return o>=n;
}

#pragma argsused
inline BOOL FASTCALL GAlphaBuffer::StencilTestTrue(USHORT o,USHORT n) {
 	return TRUE;
}

#pragma argsused
inline BOOL FASTCALL GAlphaBuffer::StencilTestFalse(USHORT o,USHORT n) {
 	return FALSE;
}

#pragma argsused
inline USHORT FASTCALL GAlphaBuffer::StencilOpKeep(USHORT o,USHORT n) {
 	return o;
}

#pragma argsused
inline USHORT FASTCALL GAlphaBuffer::StencilOpReplace(USHORT o,USHORT n) {
 	return n;
}

inline USHORT FASTCALL GAlphaBuffer::StencilOpMax(USHORT o,USHORT n) {
 	return (o>n) ? o : n;
}

inline USHORT FASTCALL GAlphaBuffer::StencilOpMin(USHORT o,USHORT n) {
 	return (o<n) ? o : n;
}

#pragma argsused
inline USHORT FASTCALL GAlphaBuffer::StencilOpZero(USHORT o,USHORT n) {
 	return 0;
}

#pragma argsused
inline USHORT FASTCALL GAlphaBuffer::StencilOpIncrement(USHORT o,USHORT n) {
 	if ((o+1)>o) return (USHORT)(o+1);
 	return o;
}

#pragma argsused
inline USHORT FASTCALL GAlphaBuffer::StencilOpDecrement(USHORT o,USHORT n) {
 	if ((o-1)<o) return (USHORT)(o-1);
 	return o;
}

#pragma argsused
inline USHORT FASTCALL GAlphaBuffer::StencilOpInvert(USHORT o,USHORT n) {
 	return (USHORT)~o;
}

inline BOOL FASTCALL GAlphaBuffer::DepthTestEqual(ULONG o,ULONG n) {
 	return o==n;
}

inline BOOL FASTCALL GAlphaBuffer::DepthTestNotEqual(ULONG o,ULONG n) {
 	return o!=n;
}

inline BOOL FASTCALL GAlphaBuffer::DepthTestGreater(ULONG o,ULONG n) {
 	return o<n;
}

inline BOOL FASTCALL GAlphaBuffer::DepthTestGreaterEqual(ULONG o,ULONG n) {
 	return o<=n;
}

inline BOOL FASTCALL GAlphaBuffer::DepthTestLess(ULONG o,ULONG n) {
 	return o>n;
}

inline BOOL FASTCALL GAlphaBuffer::DepthTestLessEqual(ULONG o,ULONG n) {
 	return o>=n;
}

#pragma argsused
inline BOOL FASTCALL GAlphaBuffer::DepthTestTrue(ULONG o,ULONG n) {
 	return TRUE;
}

#pragma argsused
inline BOOL FASTCALL GAlphaBuffer::DepthTestFalse(ULONG o,ULONG n) {
 	return FALSE;
}



///////////////////////////////////////////////////////////////////////////////
//
// Implementation of GFrame
//
inline GFrame::~GFrame() {
 	Free();
   #if defined(__FORWINDOWS__)
 	if (DeviceHandle) DeleteDC(DeviceHandle);
  	DeviceHandle=NULL;
   #endif
}

inline PTR FASTCALL GFrame::GetBitmapHandle(void) {
   #if defined(__FORWINDOWS__)
  	return BitmapHandle;
   #else
  	return FrameBuffer;
   #endif
}

inline CHAR* FASTCALL GFrame::SetDefaultName() {
 	strcpy(Name,"frame buffer");
    return Name;
}

inline GColour FASTCALL GFrame::GetColour(INT i) {
 	if(!Palette) return GColour(0,0,0);
   #if defined(__FORWINDOWS__)
  	return GColour(Palette[i].rgbRed,
  				   Palette[i].rgbGreen,
				   Palette[i].rgbBlue);
   #else
  	return Palette->Colour[i];
   #endif
}

///////////////////////////////////////////////////////////////////////////////
//
// Implementation of GAccumulationBuffer
//
inline GAccumulationBuffer::GAccumulationBuffer(CHAR *n,DWORD t) : GImageBuffer<GAlpha> (n,t) {
 	ImageBuffer=NULL;
}

inline GAccumulationBuffer::~GAccumulationBuffer() {
 	Free();
}

inline CHAR* FASTCALL GAccumulationBuffer::SetDefaultName() {
 	strcpy(Name,"accumulation buffer");
    return Name;
}

#endif
