///////////////////////////////////////////////////////////////////////////////
//
// (c) 1997 by Marc van Shaney , aka Kaya Memisoglu
//
// This Source-Code was written by and is copyrighted by Kaya Memisoglu
// You may use the whole code or only parts of it in your own programs
// whether they are commercial or not. BUT you must give credits for these
// parts to me (Kaya Memisoglu  or  Marc van Shaney).
// I am not responsible for any damage or loss caused by this program, so
// if you success in erasing your harddisk with this code, then it is your
// own fault and you should not claim me to be responsible...
// I would be very pleased if you also sent me a postcard or even a letter
// if you can use this code. My address:
//
//        Kaya Memisoglu
//        Reichenberger Ring 50
//        63512 Hainburg
//        Germany
//
//


#ifndef __GMAGIC_H
#define __GMAGIC_H

#include "../include/gomez.h"


class GMagic {
		protected:
		BYTE		Type[4];

		public:
		GMagic();
		GMagic(BYTE ,BYTE ,BYTE ,BYTE );
		GMagic(BYTE *);
		~GMagic();

		GMagic&		FASTCALL operator=(GMagic &);
		GMagic&		FASTCALL operator=(BYTE *);
		GMagic&		FASTCALL operator=(DWORD );
		BOOL		FASTCALL operator==(GMagic &);
		BOOL		FASTCALL operator==(BYTE *);
		BOOL		FASTCALL operator!=(GMagic &);
		BOOL		FASTCALL operator!=(BYTE *);

		BYTE*		FASTCALL ToString(BYTE *);
		DWORD		FASTCALL ToDword(void);
	   };

inline GMagic::GMagic() {
 	Type[0]=Type[1]=Type[2]=Type[3]=0;
}

inline GMagic::~GMagic() {
}

inline GMagic::GMagic(BYTE ch0,BYTE ch1,BYTE ch2,BYTE ch3) {
 	Type[0]=ch0;
 	Type[1]=ch1;
 	Type[2]=ch2;
	Type[3]=ch3;
}

inline GMagic::GMagic(BYTE *ch) {
 	Type[0]=ch[0];
 	Type[1]=ch[1];
 	Type[2]=ch[2];
 	Type[3]=ch[3];
}

inline BYTE* FASTCALL GMagic::ToString(BYTE *ch) {
 	ch[0]=Type[0];
 	ch[1]=Type[1];
 	ch[2]=Type[2];
 	ch[3]=Type[3];
 	return ch;
}

inline DWORD FASTCALL GMagic::ToDword(void) {
   #if defined(__LSBFIRST__)
 	return ((DWORD)Type[0]) | ((DWORD)Type[1]<<8) | ((DWORD)Type[2]<<16) | ((DWORD)Type[3]<<24);
   #else
 	return ((DWORD)Type[3]) | ((DWORD)Type[2]<<8) | ((DWORD)Type[1]<<16) | ((DWORD)Type[0]<<24);
   #endif
}

inline GMagic& FASTCALL GMagic::operator=(GMagic &t) {
 	memcpy(Type,t.Type,sizeof(Type));
 	return *this;
}

inline GMagic& FASTCALL GMagic::operator=(BYTE *ch) {
 	Type[0]=ch[0];
 	Type[1]=ch[1];
 	Type[2]=ch[2];
 	Type[3]=ch[3];
 	return *this;
}

inline GMagic& FASTCALL GMagic::operator=(DWORD t) {
   #if defined(__LSBFIRST__)
 	Type[0]=*((BYTE *)(&t));
 	Type[1]=*((BYTE *)(&t)+1);
 	Type[2]=*((BYTE *)(&t)+2);
 	Type[3]=*((BYTE *)(&t)+3);
   #else
 	Type[0]=*((BYTE *)(&t)+3);
 	Type[1]=*((BYTE *)(&t)+2);
 	Type[2]=*((BYTE *)(&t)+1);
 	Type[3]=*((BYTE *)(&t));
   #endif
 	return *this;
}

inline BOOL FASTCALL GMagic::operator==(GMagic &t) {
 	return ((Type[0]==t.Type[0]) &&
	  	 	(Type[1]==t.Type[1]) &&
			(Type[2]==t.Type[2]) &&
			(Type[3]==t.Type[3]));
}

inline BOOL FASTCALL GMagic::operator==(BYTE *ch) {
 	return ((Type[0]==ch[0]) &&
			(Type[1]==ch[1]) &&
			(Type[2]==ch[2]) &&
			(Type[3]==ch[3]));
}

inline BOOL FASTCALL GMagic::operator!=(GMagic &t) {
 	return ((Type[0]!=t.Type[0]) ||
			(Type[1]!=t.Type[1]) ||
			(Type[2]!=t.Type[2]) ||
			(Type[3]!=t.Type[3]));
}

inline BOOL FASTCALL GMagic::operator!=(BYTE *ch) {
 	return ((Type[0]!=ch[0]) ||
			(Type[1]!=ch[1]) ||
			(Type[2]!=ch[2]) ||
			(Type[3]!=ch[3]));
}

#endif
