///////////////////////////////////////////////////////////////////////////////
//
// (c) 1997 by Marc van Shaney , aka Kaya Memisoglu
//
// This Source-Code was written by and is copyrighted by Kaya Memisoglu
// You may use the whole code or only parts of it in your own programs
// whether they are commercial or not. BUT you must give credits for these
// parts to me (Kaya Memisoglu  or  Marc van Shaney).
// I am not responsible for any damage or loss caused by this program, so
// if you success in erasing your harddisk with this code, then it is your
// own fault and you should not claim me to be responsible...
// I would be very pleased if you also sent me a postcard or even a letter
// if you can use this code. My address:
//
//        Kaya Memisoglu
//        Reichenberger Ring 50
//        63512 Hainburg
//        Germany
//
//


#ifndef __GMESSAGEQUEUE_H
#define __GMESSAGEQUEUE_H


class GMessageQueue {
		protected:
		typedef struct {
			ULONG			Message;
            union {
            	   ULONG	Long1;
                   FLOAT	Float1;
                   PTR		Ptr1;
                  };
            union {
            	   ULONG	Long2;
                   FLOAT	Float2;
                   PTR		Ptr2;
                  };
           } GMessage;

		protected:
		GMessage	Msg[GMZ_MESSAGEQUEUE_SIZE];
        INT			First;
        INT			Last;

        public:
        GMessageQueue();

        BOOL		FASTCALL PostMessage(ULONG ,ULONG ,ULONG );
        BOOL		FASTCALL PostMessage(ULONG ,PTR ,PTR );
        BOOL		FASTCALL PostMessage(ULONG ,FLOAT ,FLOAT );
		BOOL		FASTCALL PostMessage(GMessage *);
        BOOL		FASTCALL IsEmpty(void);
        BOOL		FASTCALL IsFull(void);

		protected:
        BOOL		FASTCALL GetMessage(GMessage *);
        BOOL		FASTCALL PeekMessage(GMessage *);
        virtual void FASTCALL NotifyMessage(void);
	   };

///////////////////////////////////////////////////////////////////////////////
//
// Implementation of GMessageQueue
//
inline GMessageQueue::GMessageQueue()
{
 First=Last=0;
}

inline BOOL FASTCALL GMessageQueue::IsEmpty(void)
{
 if (Last==First) return TRUE;
 return FALSE;
}

inline BOOL FASTCALL GMessageQueue::IsFull(void)
{
 if (First==((Last+1) % GMZ_MESSAGEQUEUE_SIZE)) return TRUE;
 return FALSE;
}

inline BOOL FASTCALL GMessageQueue::PostMessage(ULONG m,ULONG p1,ULONG p2)
{
 INT i=(Last+1) % GMZ_MESSAGEQUEUE_SIZE;
 if (i==First) return FALSE;
 Msg[Last].Message=m;
 Msg[Last].Long1=p1;
 Msg[Last].Long2=p2;
 Last=i;
 NotifyMessage();
 return TRUE;
}

inline BOOL FASTCALL GMessageQueue::PostMessage(ULONG m,FLOAT p1,FLOAT p2)
{
 INT i=(Last+1) % GMZ_MESSAGEQUEUE_SIZE;
 if (i==First) return FALSE;
 Msg[Last].Message=m;
 Msg[Last].Float1=p1;
 Msg[Last].Float2=p2;
 Last=i;
 NotifyMessage();
 return TRUE;
}

inline BOOL FASTCALL GMessageQueue::PostMessage(ULONG m,PTR p1,PTR p2)
{
 INT i=(Last+1) % GMZ_MESSAGEQUEUE_SIZE;
 if (i==First) return FALSE;
 Msg[Last].Message=m;
 Msg[Last].Ptr1=p1;
 Msg[Last].Ptr2=p2;
 Last=i;
 NotifyMessage();
 return TRUE;
}

inline BOOL FASTCALL GMessageQueue::PostMessage(GMessage *m)
{
 INT i=(Last+1) % GMZ_MESSAGEQUEUE_SIZE;
 if (i==First) return FALSE;
 memcpy(&Msg[Last],m,sizeof(GMessage));
 Last=i;
 NotifyMessage();
 return TRUE;
}

inline BOOL FASTCALL GMessageQueue::GetMessage(GMessage *m)
{
 if (Last==First) return FALSE;
 memcpy(m,&Msg[First],sizeof(GMessage));
 First=(First +1)%GMZ_MESSAGEQUEUE_SIZE;
 return TRUE;
}

inline BOOL FASTCALL GMessageQueue::PeekMessage(GMessage *m)
{
 if (Last==First) return FALSE;
 memcpy(m,&Msg[First],sizeof(GMessage));
 return TRUE;
}

inline void FASTCALL GMessageQueue::NotifyMessage(void)
{
}

#endif
