///////////////////////////////////////////////////////////////////////////////
//
// (c) 1997 by Marc van Shaney , aka Kaya Memisoglu
//
// This Source-Code was written by and is copyrighted by Kaya Memisoglu
// You may use the whole code or only parts of it in your own programs
// whether they are commercial or not. BUT you must give credits for these
// parts to me (Kaya Memisoglu  or  Marc van Shaney).
// I am not responsible for any damage or loss caused by this program, so
// if you success in erasing your harddisk with this code, then it is your
// own fault and you should not claim me to be responsible...
// I would be very pleased if you also sent me a postcard or even a letter
// if you can use this code. My address:
//
//        Kaya Memisoglu
//        Reichenberger Ring 50
//        63512 Hainburg
//        Germany
//
///////////////////////////////////////////////////////////////////////////////
//
//
// The following #defines may be done in this file:
// 		GMZ_DEBUG
// 		GMZ_WALK_PREORDER
// 		GMZ_WALK_POSTORDER
//		GMZ_NAME_LENGTH				(64)
//		GMZ_OBJECTSTACK_SIZE		(64)
//		GMZ_OBJECTLIST_SIZE			(2048)
//		GMZ_THREAD_STACKSIZE		(32000)
//
// You can also change the values in the maths section, refering to
// the shift values. BUT: You really should know what you are doing there,
// or the system may crash ! There are some other #defines you should
// considerate in GSystem.h about the computing environment - have a look
// there.
//
//					Have fun !
//


#ifndef __GOMEZ_H
#define __GOMEZ_H


#define GMZ_WALK_PREORDER
//#define GMZ_WALK_POSTORDER
//#define GMZ_DEBUG

#define GMZ_NAME_LENGTH				64
#define GMZ_OBJECTSTACK_SIZE		64
#define GMZ_OBJECTLIST_SIZE			2048
#define GMZ_MESSAGEQUEUE_SIZE		16
#define GMZ_THREAD_STACKSIZE		64000
#define GMZ_MAX_TIMERS				32
#define GMZ_MAX_FRAMEWIDTH			2048

#define GMZ_LOG_QUIET				0
#define GMZ_LOG_ERROR				1
#define GMZ_LOG_WARNING				2
#define GMZ_LOG_MESSAGE				3


/*
 * Now a quick option-error-checking will be performed
 */
#if (sizeof(int)!=4)
#error This version of Gomez StandardLibrary only runs on 32bit systems
#endif

#if ((!defined __FIXEDMATH__) && (!defined __FLOATMATH__))
#error You must define __FIXEDMATH__ or __FLOATMATH__
#elif ((defined __FIXEDMATH__) && (defined __FLOATMATH__))
#error You cannot use both __FIXEDMATH__ and __FLOATMATH__
#endif

#if ((!defined GMZ_WALK_PREORDER) && (!defined GMZ_WALK_POSTORDER))
#error You must define GMZ_WALK_PREORDER or GMZ_WALK_POSTORDER
#elif ((defined GMZ_WALK_PREORDER) && (defined GMZ_WALK_POSTORDER))
#error You cannot use both GMZ_WALK_PREORDER and GMZ_WALK_POSTORDER
#endif



// Include some standard headers we'll likely need. Hope that this
// doesnt't get you into trouble...
#include <values.h>
#include <stdlib.h>
#include <stdio.h>
#include <iostream.h>
#include <fcntl.h>
#include <dir.h>
#include <math.h>
#include <mem.h>
#include <alloc.h>
#include <time.h>
#include <process.h>
#include <typeinfo.h>
#include <sys/stat.h>

// Include all other gomez-realted things. Note that you should _not_
// change the order, because some headers depend on others...
#include "../include/gsystem.h"
#include "../include/gtypes.h"
#include "../include/gmagic.h"
#include "../include/gerror.h"
#include "../include/gmath.h"

#if !defined(__BASEONLY__)
#include "../include/gmessage.h"
#include "../include/gfile.h"
#include "../include/gobject.h"
#include "../include/gpalette.h"
#include "../include/gbitmap.h"
#include "../include/gsound.h"
#include "../include/ggraphic.h"
#include "../include/gframe.h"
#include "../include/gdisplay.h"
#include "../include/gapplet.h"
#endif


///////////////////////////////////////////////////////////////////////////////
//
// Now follow some dirty startup-tricks
//
#if defined(__BASEONLY)

#else
 extern GLogFile GErrorLog;

 #if defined(__FORWINDOWS__)
  extern HINSTANCE GWindowInstance;
  INT WINAPI WinMain(HINSTANCE ,HINSTANCE ,LPSTR ,INT );
  #if defined(__WINMAIN__)
   #define WinMain _WinMain
   INT WINAPI WinMain(HINSTANCE ,HINSTANCE ,LPSTR ,INT );
  #else
   #define main _main
   void main(void);
  #endif
 #elif defined(__FORX11__)
  extern Window GRootWindowHandle;
  extern Display* GDisplayHandle;
  extern Visual* GDisplayVisual;
  extern int GScreenHandle;                              /* deafualt screen */
  void main(void);
  #define main _main
  void main(void);
 #else
  void main(void);
  #define main _main
  void main(void);
 #endif
#endif
#endif
