///////////////////////////////////////////////////////////////////////////////
//
// (c) 1997 by Marc van Shaney , aka Kaya Memisoglu
//
// This Source-Code was written by and is copyrighted by Kaya Memisoglu
// You may use the whole code or only parts of it in your own programs
// whether they are commercial or not. BUT you must give credits for these
// parts to me (Kaya Memisoglu  or  Marc van Shaney).
// I am not responsible for any damage or loss caused by this program, so
// if you success in erasing your harddisk with this code, then it is your
// own fault and you should not claim me to be responsible...
// I would be very pleased if you also sent me a postcard or even a letter
// if you can use this code. My address:
//
//        Kaya Memisoglu
//        Reichenberger Ring 50
//        63512 Hainburg
//        Germany
//
///////////////////////////////////////////////////////////////////////////////
//
// You MUST supply one of the following defines:
//		__FORWINDOWS__		- For Windows
//		__FORDOS__			- For DOS
//		__FOROS2__			- For OS/2
//		__FORUNIX__			- For unix
//		__FORLINUX__		- For Linux-environment
//
// If your target platform is DOS or WINDOWS, then you can simply define
//		__FORDOS__
//		__FORWINDOWS__
// Then this file will try to determine what word size and processor is
// used.
//
// You may also specify your processor platform:
//		__FORx86__			- Intel 80x86
//		__FORSPARC__		- Sun SPARC
//		__FORRx000__		- MIPS Rx000
//		__FORPPC__			- Power PC
//		__FORALPHA__		- DEC Alpha
// Note that the processor is detected automatically when compiling for
// Windows or DOS. (The later one must be an Intel !)
//
// Often it is helpfull to know about the byte-ordering. Here you can
// define:
//		__LSBFIRST__		- Like Intel,MIPS
//		__MSBFIRST__		- Like SPARC, Motorola
//
// You may also need the floating point format:
//		__FPIEEE__			- Like Intel
//		__FPIBM__			- For IBM workstations
//		__FPVAX__
//		__FPCRAY__
//
// And your compiler:
//		__FORBORLAND__		- Borland C++
//		__FORVISUAL__		- Microsoft Visual C++
//		__FORGNU__			- GNU C++
//		__FORWATCOM__		- Watcom Compiler
//
// Other useful macros that are used in GTypes.h are:
//		__FLOATMATH__		- Use floating point maths
//		__FIXEDMATH__		- Use fixed point maths
//
// Useful DOS-Macros:
//		__FORDOS16__        - Standard 16bit DOS
//		__FORDOS32__		- Some 32bit DOS extender
//		__FORDOS4GW__		- DOS4GW 32bit extender
//		__FORDOSPWPK16__	- Borland 16bit DOS extender
//		__FORDOSPWPK32__	- Borland 32bit DOS extender
//      __FORDOSTNT__		- ???
//
// Other useful windows options are:
//		__FORMFC__			- For Microsoft foundation classes
//		__FOROWL__			- For Borland Object Windows Library
//		__FORWIN16__		- Standard 16bit windows 3.11
//		__FORWIN32s__		- Win32s
//		__FORWIN95__		- Windows95
//		__FORWINNT__		- Windows NT
//		__FORWIN386__		- Watcom extneder for windows
//		__WINMAIN__			- Your program supplys an own WinMain function
//
// UNIX-Options are:
//		__FORX11__			- For unix with X-Windows
//		__FORMOTIF__	   	- For unix with Morif
//
// One important note for Windows users: If you want to write a portable
// program using void main(void), then you should not define __WINMAIN__,
// but if your program contains an own WinMain function, you MUST define
// __WINMAIN__, so GApplication will not define its own WinMain function !
//
// Notes for usage of threads: Threads will only be available, if the symbol
// __THREADS__ is defined (this is done automatically by Gomez depending on
// you compiling environment). If you use the Borland or Microsoft compiler,
// I suggest to enable the thread library.
//


#ifndef __GSYSTEM_H
#define __GSYSTEM_H


// Autodetect Borland compiler
#if defined(__BORLANDC__)
  #define __FORBORLAND__
  #if defined(__WIN32__)
	#define __FORWIN32__
  #elif defined(_Windows)
	#define __FORWINDOWS__
  #else
	#define __FORDOS__
  #endif
#endif

// Autodetect MS-C
#ifdef _MSC_VER
  #define __FORVISUAL__
  #if defined(__WIN32__)
	#define __FORWIN32__
  #elif defined(_Windows)
	#define __FORWINDOWS__
  #else
	#define __FORDOS__
  #endif
#endif

// Autodetect Watcom-C
#ifdef __WATCOMC__
  #define __FORWATCOM__
  #if defined(__WIN32__)
	#define __FORWIN32__
  #elif defined(_Windows)
	#define __FORWINDOWS__
  #else
	#define __FORDOS__
  #endif
#endif

// Autodetect GNUC
#ifdef __GNUC__
  #define __FORGNU__
#endif

// Autodetect wordsize for Windows and DOS
#if defined(__FORDOS__)
  #if (sizeof(int)==4)
	#define __FORDOS32__
  #else
	#define __FORDOS16__
  #endif
#elif defined(__FORWINDOWS__)
  #if (sizeof(int)==8)
	#define __FORWIN32s__
	#define __64BIT__
  #elif (sizeof(int)==4)
	#define __FORWIN32s__
  #elif (sizeof(int)==2)
	#define __FORWIN16__
  #endif
#endif


// Enable UNIX if X11 or MOTIF selected
#if (defined(__FORX11__) || defined(__FORMOTIF)) && !defined(__FORUNIX__)
  #define __FORUNIX__
#endif

// Enable UNIX if Linux
#if defined(__FORLINUX__) && !defined(__FORUNIX__)
  #define __FORUNIX__
#endif


#if defined (__FORDOS16__)			// Standard DOS 16bit
  #define __FORDOS__
  #define __16BIT__
  #define __FORx86__
#elif defined (__FORDOS32__)		// Some 32bit DOS-Extender
  #define __FORDOS__
  #define __32BIT__
  #define __FORx86__
#elif defined (__FORDOS4GW__)		// DOS4GW 32bit
  #define __FORDOS__
  #define __32BIT__
  #define __FORx86__
#elif defined (__FORDOSPWPK32__)  	// Borland Power Pack 32 Bit
  #define __FORDOS__
  #define __FORPOWERPACK__
  #define __32BIT__
  #define __FORx86__
#elif defined (__FORDOSPWPK16__)  	// Borland Power Pack 16 Bit
  #define __FORDOS__
  #define __FORPOWERPACK__
  #define __16BIT__
  #define __FORx86__
#elif defined (__FORDOSTNT__)
  #define __FORDOS__
  #define __32BIT__
  #define __FORx86__
#elif defined (__FORWIN16__)   		// For Windows 3.0+
  #define __FORWINDOWS__
  #define __16BIT__
  #define __FORx86__
  #ifndef _WIN32
	#define _WIN32
  #endif
#elif defined (__FORWIN32s__)  		// For Win32s
  #define __FORWINDOWS__
  #define __32BIT__
  #define __FORx86__
  #ifndef _WIN32
	#define _WIN32
  #endif
#elif defined (__FORWIN32__)   		// For Windows 95 or NT
  #define __FORWINDOWS__
  #define __32BIT__
  #define __FORx86__
  #define __LONGLONG__
  #define __THREADS__
#elif defined (__FORWIN95__)   		// For Windows 95
  #define __FORWINDOWS__
  #define __FORWIN32__
  #define __32BIT__
  #define __FORx86__
  #define __LONGLONG__
  #define __THREADS__
#elif defined (__FORWINNT__)		// For Windows NT
  #define __FORWINDOWS__
  #define __FORWIN32__
  #define __32BIT__
  #define __LONGLONG__
  #define __THREADS__
  #if   defined(_M_IX86)
	#define __FORx86__				// Intel 80x86
  #elif defined(_M_MRX000)
	#define __FORRx000__			// MIPS Rx000
  #elif defined(_M_ALPHA)
	#define __FORALPHA__			// DEC Alpha
  #elif defined(_M_PPC)
	#define __FORPPC__				// Power PC
  #endif
#elif defined (__FORWIN386__)  		// Watcom Extender
  #define __FORWINDOWS__
  #define __32BIT__
  #define __FORx86__
#elif defined (__FOROS2__)     		// OS/2
  #define __32BIT__
  #define __FORx86__
  #define __THREADS__
#elif defined (__FORUNIX__) 		// UNIX
  #define __32BIT__
  #define __THREADS__
#else
  #error You must define __FOR???__ for your target platform !
#endif


#if   defined (__FORx86__)
  #define __LSBFIRST__
  #define __FPIEEE__
#elif defined (__FORRx000__)
  #define __LSBFIRST__
#elif defined (__FORSPARC__)
  #define __MSBFIRST__
#endif


// Include some other files, if needed
#if defined (__FORWINDOWS__)
  #define  STRICT
  #include <dos.h>
  #include <windows.h>
  #include <windowsx.h>
  #if defined (__FORMFC__)
	#include <afxwin.h>
  #elif defined (__FOROWL__)
	#include <owl/owlall.h>
  #endif
#elif defined (__FORDOS__)
  #include <dos.h>
#elif defined (__FORX11__)
  #include <X11/Xlib.h>
  #include <X11/Xutil.h>
  #include <X11/Xresource.h>
#elif defined (__FORMOTIF__)
  #include <Xm/Xm.h>
#endif


#endif