///////////////////////////////////////////////////////////////////////////////
//
// (c) 1997 by Marc van Shaney , aka Kaya Memisoglu
//
// This Source-Code was written by and is copyrighted by Kaya Memisoglu
// You may use the whole code or only parts of it in your own programs
// whether they are commercial or not. BUT you must give credits for these
// parts to me (Kaya Memisoglu  or  Marc van Shaney).
// I am not responsible for any damage or loss caused by this program, so
// if you success in erasing your harddisk with this code, then it is your
// own fault and you should not claim me to be responsible...
// I would be very pleased if you also sent me a postcard or even a letter
// if you can use this code. My address:
//
//        Kaya Memisoglu
//        Reichenberger Ring 50
//        63512 Hainburg
//        Germany
//
//


#ifndef __GVEMAP_H
#define __GVEMAP_H

#include "../include/gvepro.h"




class GTextureMap:public GBitmap {
		friend class GVectorSystem;

		public:
        CHAR*		FASTCALL SetDefaultName();

		BOOL       	FASTCALL Alloc(INT w=GVE_TEXTURE_WIDTH,INT h=GVE_TEXTURE_HEIGHT,INT d=GVE_TEXTURE_DEPTH);
		BOOL       	FASTCALL MakeTexture(GPalette *p=NULL);
	   };

class GBumpMap:public GBitmap {
		friend class GVectorSystem;

		public:
        CHAR*		FASTCALL SetDefaultName();

		BOOL       	FASTCALL Alloc(INT w=GVE_TEXTURE_WIDTH,INT h=GVE_TEXTURE_HEIGHT,INT d=16);
		BOOL       	FASTCALL MakeBump(GPalette *p=NULL);
	   };

class GLightMap:public GBitmap {
		friend class GVectorSystem;

		public:
        CHAR*		FASTCALL SetDefaultName();

		BOOL       	FASTCALL Alloc(INT w=GVE_TEXTURE_WIDTH,INT h=GVE_TEXTURE_HEIGHT,INT d=8);
		BOOL       	FASTCALL MakeLight(GPalette *p=NULL);
	   };

inline BOOL FASTCALL GTextureMap::Alloc(INT w,INT h,INT d) {
 	return GBitmap::Alloc(w,h,d);
}

inline CHAR* FASTCALL GTextureMap::SetDefaultName() {
 	strcpy(Name,"texture map");
    return Name;
}

inline BOOL FASTCALL GLightMap::Alloc(INT w,INT h,INT d) {
 	return GBitmap::Alloc(w,h,d);
}

inline CHAR* FASTCALL GLightMap::SetDefaultName() {
 	strcpy(Name,"light map");
    return Name;
}

inline BOOL FASTCALL GBumpMap::Alloc(INT w,INT h,INT d) {
 	return GBitmap::Alloc(w,h,d);
}

inline CHAR* FASTCALL GBumpMap::SetDefaultName() {
 	strcpy(Name,"bump map");
    return Name;
}

#endif
