///////////////////////////////////////////////////////////////////////////////
//
// (c) 1997 by Marc van Shaney , aka Kaya Memisoglu
//
// This Source-Code was written by and is copyrighted by Kaya Memisoglu
// You may use the whole code or only parts of it in your own programs
// whether they are commercial or not. BUT you must give credits for these
// parts to me (Kaya Memisoglu  or  Marc van Shaney).
// I am not responsible for any damage or loss caused by this program, so
// if you success in erasing your harddisk with this code, then it is your
// own fault and you should not claim me to be responsible...
// I would be very pleased if you also sent me a postcard or even a letter
// if you can use this code. My address:
//
//        Kaya Memisoglu
//        Reichenberger Ring 50
//        63512 Hainburg
//        Germany
//
//


#ifndef __GVEMATH_H
#define __GVEMATH_H

#include "../include/gvepro.h"

typedef GTripleM<GVE_VECTOR_SHIFT> GVector;
typedef GTripleM<GVE_NORMAL_SHIFT> GNormal;


class GMatrix {
		public:
		MATH m[4][4];

		GMatrix() {};
		GMatrix(GVector r,GVector p);
		GMatrix 	FASTCALL operator*(GMatrix &a);
		GVector 	FASTCALL operator*(GVector &v);
		GNormal 	FASTCALL operator*(GNormal &n);
		GMatrix 	FASTCALL operator^(GMatrix &a);
		GVector 	FASTCALL operator^(GVector &v);
		GNormal 	FASTCALL operator^(GNormal &n);
		GMatrix 	FASTCALL operator/(GMatrix &a);
		GMatrix 	FASTCALL operator~();

		VOID		FASTCALL Translation(GVector t);
		VOID		FASTCALL Rotation(GVector r);
	   };

inline FASTCALL GVector GMatrix::operator *(GVector &v)
{
 #if defined(FIXED_MATH)
  return GVector((MATH)(LargeShrLong(LargeMul(m[0][0],v.x),GVE_MATRIX_SHIFT)+
					   LargeShrLong(LargeMul(m[0][1],v.y),GVE_MATRIX_SHIFT)+
					   LargeShrLong(LargeMul(m[0][2],v.z),GVE_MATRIX_SHIFT)+
					   m[0][3]),
				(MATH)(LargeShrLong(LargeMul(m[1][0],v.x),GVE_MATRIX_SHIFT)+
					   LargeShrLong(LargeMul(m[1][1],v.y),GVE_MATRIX_SHIFT)+
					   LargeShrLong(LargeMul(m[1][2],v.z),GVE_MATRIX_SHIFT)+
					   m[1][3]),
				(MATH)(LargeShrLong(LargeMul(m[2][0],v.x),GVE_MATRIX_SHIFT)+
					   LargeShrLong(LargeMul(m[2][1],v.y),GVE_MATRIX_SHIFT)+
					   LargeShrLong(LargeMul(m[2][2],v.z),GVE_MATRIX_SHIFT)+
					   m[2][3]));
 #else
  return GVector((DOUBLE)m[0][0]*(DOUBLE)v.x+(DOUBLE)m[0][1]*(DOUBLE)v.y+(DOUBLE)m[0][2]*(DOUBLE)v.z+m[0][3],
				 (DOUBLE)m[1][0]*(DOUBLE)v.x+(DOUBLE)m[1][1]*(DOUBLE)v.y+(DOUBLE)m[1][2]*(DOUBLE)v.z+m[1][3],
				 (DOUBLE)m[2][0]*(DOUBLE)v.x+(DOUBLE)m[2][1]*(DOUBLE)v.y+(DOUBLE)m[2][2]*(DOUBLE)v.z+m[2][3]);
 #endif
}


inline FASTCALL GNormal GMatrix::operator *(GNormal &v)
{
 #if defined(FIXED_MATH)
  return GNormal((MATH)(LargeShrLong(LargeMul(m[0][0],v.x),GVE_MATRIX_SHIFT)+
					   LargeShrLong(LargeMul(m[0][1],v.y),GVE_MATRIX_SHIFT)+
					   LargeShrLong(LargeMul(m[0][2],v.z),GVE_MATRIX_SHIFT)),
				(MATH)(LargeShrLong(LargeMul(m[1][0],v.x),GVE_MATRIX_SHIFT)+
					   LargeShrLong(LargeMul(m[1][1],v.y),GVE_MATRIX_SHIFT)+
					   LargeShrLong(LargeMul(m[1][2],v.z),GVE_MATRIX_SHIFT)),
				(MATH)(LargeShrLong(LargeMul(m[2][0],v.x),GVE_MATRIX_SHIFT)+
					   LargeShrLong(LargeMul(m[2][1],v.y),GVE_MATRIX_SHIFT)+
					   LargeShrLong(LargeMul(m[2][2],v.z),GVE_MATRIX_SHIFT)));
 #else
  return GNormal((DOUBLE)m[0][0]*(DOUBLE)v.x+(DOUBLE)m[0][1]*(DOUBLE)v.y+(DOUBLE)m[0][2]*(DOUBLE)v.z,
				 (DOUBLE)m[1][0]*(DOUBLE)v.x+(DOUBLE)m[1][1]*(DOUBLE)v.y+(DOUBLE)m[1][2]*(DOUBLE)v.z,
				 (DOUBLE)m[2][0]*(DOUBLE)v.x+(DOUBLE)m[2][1]*(DOUBLE)v.y+(DOUBLE)m[2][2]*(DOUBLE)v.z);
 #endif
}



inline FASTCALL GVector GMatrix::operator ^(GVector &v)
{
 GVector w;

 w.x=v.x-m[0][3];
 w.y=v.y-m[1][3];
 w.z=v.z-m[2][3];

 #if defined(FIXED_MATH)
  return GVector((MATH)(LargeShrLong(LargeMul(m[0][0],v.x),GVE_MATRIX_SHIFT)+
					   LargeShrLong(LargeMul(m[1][0],v.y),GVE_MATRIX_SHIFT)+
					   LargeShrLong(LargeMul(m[2][0],v.z),GVE_MATRIX_SHIFT)),
				(MATH)(LargeShrLong(LargeMul(m[0][1],v.x),GVE_MATRIX_SHIFT)+
					   LargeShrLong(LargeMul(m[1][1],v.y),GVE_MATRIX_SHIFT)+
					   LargeShrLong(LargeMul(m[2][1],v.z),GVE_MATRIX_SHIFT)),
				(MATH)(LargeShrLong(LargeMul(m[0][2],v.x),GVE_MATRIX_SHIFT)+
					   LargeShrLong(LargeMul(m[1][2],v.y),GVE_MATRIX_SHIFT)+
					   LargeShrLong(LargeMul(m[2][2],v.z),GVE_MATRIX_SHIFT)));
 #else
  return GVector((DOUBLE)m[0][0]*(DOUBLE)v.x+(DOUBLE)m[1][0]*(DOUBLE)v.y+(DOUBLE)m[2][0]*(DOUBLE)v.z,
				 (DOUBLE)m[0][1]*(DOUBLE)v.x+(DOUBLE)m[1][1]*(DOUBLE)v.y+(DOUBLE)m[2][1]*(DOUBLE)v.z,
				 (DOUBLE)m[0][2]*(DOUBLE)v.x+(DOUBLE)m[1][2]*(DOUBLE)v.y+(DOUBLE)m[2][2]*(DOUBLE)v.z);
 #endif
}



inline FASTCALL GNormal GMatrix::operator ^(GNormal &v)
{
 #if defined(FIXED_MATH)
  return GNormal((MATH)(LargeShrLong(LargeMul(m[0][0],v.x),GVE_MATRIX_SHIFT)+
					   LargeShrLong(LargeMul(m[1][0],v.y),GVE_MATRIX_SHIFT)+
					   LargeShrLong(LargeMul(m[2][0],v.z),GVE_MATRIX_SHIFT)),
				(MATH)(LargeShrLong(LargeMul(m[0][1],v.x),GVE_MATRIX_SHIFT)+
					   LargeShrLong(LargeMul(m[1][1],v.y),GVE_MATRIX_SHIFT)+
					   LargeShrLong(LargeMul(m[2][1],v.z),GVE_MATRIX_SHIFT)),
				(MATH)(LargeShrLong(LargeMul(m[0][2],v.x),GVE_MATRIX_SHIFT)+
					   LargeShrLong(LargeMul(m[1][2],v.y),GVE_MATRIX_SHIFT)+
					   LargeShrLong(LargeMul(m[2][2],v.z),GVE_MATRIX_SHIFT)));
 #else
  return GNormal((DOUBLE)m[0][0]*(DOUBLE)v.x+(DOUBLE)m[1][0]*(DOUBLE)v.y+(DOUBLE)m[2][0]*(DOUBLE)v.z,
				 (DOUBLE)m[0][1]*(DOUBLE)v.x+(DOUBLE)m[1][1]*(DOUBLE)v.y+(DOUBLE)m[2][1]*(DOUBLE)v.z,
				 (DOUBLE)m[0][2]*(DOUBLE)v.x+(DOUBLE)m[1][2]*(DOUBLE)v.y+(DOUBLE)m[2][2]*(DOUBLE)v.z);
 #endif
}

#endif