///////////////////////////////////////////////////////////////////////////////
//
// (c) 1997 by Marc van Shaney , aka Kaya Memisoglu
//
// This Source-Code was written by and is copyrighted by Kaya Memisoglu
// You may use the whole code or only parts of it in your own programs
// whether they are commercial or not. BUT you must give credits for these
// parts to me (Kaya Memisoglu  or  Marc van Shaney).
// I am not responsible for any damage or loss caused by this program, so
// if you success in erasing your harddisk with this code, then it is your
// own fault and you should not claim me to be responsible...
// I would be very pleased if you also sent me a postcard or even a letter
// if you can use this code. My address:
//
//        Kaya Memisoglu
//        Reichenberger Ring 50
//        63512 Hainburg
//        Germany
//
//


#include "../include/gomez.h"


void FASTCALL GAlphaBuffer::SetAlphaFunctions(void)
{
 switch(Depth)
   {
	case 8:
		PutExtSpanFunc=&GAlphaBuffer::PutExtSpan8;
		GetExtSpanFunc=&GAlphaBuffer::GetExtSpan8;
		PutPixSpanFunc=&GAlphaBuffer::PutPixSpan8;
		PutColSpanFunc=&GAlphaBuffer::PutColSpan8;
		break;
	case 15:
	case 16:
		PutExtSpanFunc=&GAlphaBuffer::PutExtSpan16;
		GetExtSpanFunc=&GAlphaBuffer::GetExtSpan16;
		PutPixSpanFunc=&GAlphaBuffer::PutPixSpan16;
		PutColSpanFunc=&GAlphaBuffer::PutColSpan16;
		break;
	case 24:
	case 32:
		PutExtSpanFunc=&GAlphaBuffer::PutExtSpan32;
		GetExtSpanFunc=&GAlphaBuffer::GetExtSpan32;
		PutPixSpanFunc=&GAlphaBuffer::PutPixSpan32;
		PutColSpanFunc=&GAlphaBuffer::PutColSpan32;
		break;
	default:
		PutExtSpanFunc=&GAlphaBuffer::PutExtSpan0;
		GetExtSpanFunc=&GAlphaBuffer::GetExtSpan0;
		PutPixSpanFunc=&GAlphaBuffer::PutPixSpan0;
		PutColSpanFunc=&GAlphaBuffer::PutColSpan0;
   }
 switch(StencilTest)
   {
	case STENCILTEST_TRUE:
		StencilTestFunc=&GAlphaBuffer::StencilTestTrue;
		break;
	case STENCILTEST_FALSE:
    	StencilTestFunc=&GAlphaBuffer::StencilTestFalse;
        break;
    case STENCILTEST_EQUAL:
    	StencilTestFunc=&GAlphaBuffer::StencilTestEqual;
        break;
    case STENCILTEST_NOTEQUAL:
    	StencilTestFunc=&GAlphaBuffer::StencilTestNotEqual;
        break;
    case STENCILTEST_GREATER:
    	StencilTestFunc=&GAlphaBuffer::StencilTestGreater;
        break;
    case STENCILTEST_GEQUAL:
    	StencilTestFunc=&GAlphaBuffer::StencilTestGreaterEqual;
        break;
    case STENCILTEST_LESS:
    	StencilTestFunc=&GAlphaBuffer::StencilTestLess;
        break;
    case STENCILTEST_LEQUAL:
    	StencilTestFunc=&GAlphaBuffer::StencilTestLessEqual;
        break;
	default:
    	StencilTestFunc=&GAlphaBuffer::StencilTestTrue;
        StencilTest=STENCILTEST_TRUE;
   }
 switch (StencilOpFail)
   {
    case STENCILOP_KEEP:
    	StencilOpFailFunc=&GAlphaBuffer::StencilOpKeep;
        break;
	case STENCILOP_ZERO:
    	StencilOpFailFunc=&GAlphaBuffer::StencilOpZero;
        break;
	case STENCILOP_REPLACE:
    	StencilOpFailFunc=&GAlphaBuffer::StencilOpReplace;
        break;
	case STENCILOP_INCREMENT:
    	StencilOpFailFunc=&GAlphaBuffer::StencilOpIncrement;
        break;
	case STENCILOP_DECREMENT:
    	StencilOpFailFunc=&GAlphaBuffer::StencilOpDecrement;
        break;
	case STENCILOP_INVERT:
    	StencilOpFailFunc=&GAlphaBuffer::StencilOpInvert;
        break;
	case STENCILOP_MAX:
    	StencilOpFailFunc=&GAlphaBuffer::StencilOpMax;
        break;
	case STENCILOP_MIN:
    	StencilOpFailFunc=&GAlphaBuffer::StencilOpMin;
        break;
    default:
    	StencilOpFailFunc=&GAlphaBuffer::StencilOpKeep;
   }
 switch (StencilOpZFail)
   {
    case STENCILOP_KEEP:
    	StencilOpZFailFunc=&GAlphaBuffer::StencilOpKeep;
        break;
	case STENCILOP_ZERO:
    	StencilOpZFailFunc=&GAlphaBuffer::StencilOpZero;
        break;
	case STENCILOP_REPLACE:
    	StencilOpZFailFunc=&GAlphaBuffer::StencilOpReplace;
        break;
	case STENCILOP_INCREMENT:
    	StencilOpZFailFunc=&GAlphaBuffer::StencilOpIncrement;
        break;
	case STENCILOP_DECREMENT:
    	StencilOpZFailFunc=&GAlphaBuffer::StencilOpDecrement;
        break;
	case STENCILOP_INVERT:
    	StencilOpZFailFunc=&GAlphaBuffer::StencilOpInvert;
        break;
	case STENCILOP_MAX:
    	StencilOpZFailFunc=&GAlphaBuffer::StencilOpMax;
        break;
	case STENCILOP_MIN:
    	StencilOpZFailFunc=&GAlphaBuffer::StencilOpMin;
        break;
    default:
    	StencilOpZFailFunc=&GAlphaBuffer::StencilOpKeep;
   }
 switch (StencilOpPass)
   {
    case STENCILOP_KEEP:
    	StencilOpPassFunc=&GAlphaBuffer::StencilOpKeep;
        break;
	case STENCILOP_ZERO:
    	StencilOpPassFunc=&GAlphaBuffer::StencilOpZero;
        break;
	case STENCILOP_REPLACE:
    	StencilOpPassFunc=&GAlphaBuffer::StencilOpReplace;
        break;
	case STENCILOP_INCREMENT:
    	StencilOpPassFunc=&GAlphaBuffer::StencilOpIncrement;
        break;
	case STENCILOP_DECREMENT:
    	StencilOpPassFunc=&GAlphaBuffer::StencilOpDecrement;
        break;
	case STENCILOP_INVERT:
    	StencilOpPassFunc=&GAlphaBuffer::StencilOpInvert;
        break;
	case STENCILOP_MAX:
    	StencilOpPassFunc=&GAlphaBuffer::StencilOpMax;
        break;
	case STENCILOP_MIN:
    	StencilOpPassFunc=&GAlphaBuffer::StencilOpMin;
        break;
    default:
    	StencilOpPassFunc=&GAlphaBuffer::StencilOpKeep;
   }
 switch(DepthTest)
   {
    case DEPTHTEST_TRUE:
    	DepthTestFunc=&GAlphaBuffer::DepthTestTrue;
        break;
    case DEPTHTEST_FALSE:
    	DepthTestFunc=&GAlphaBuffer::DepthTestFalse;
        break;
    case DEPTHTEST_EQUAL:
    	DepthTestFunc=&GAlphaBuffer::DepthTestEqual;
        break;
    case DEPTHTEST_NOTEQUAL:
    	DepthTestFunc=&GAlphaBuffer::DepthTestNotEqual;
        break;
    case DEPTHTEST_GREATER:
    	DepthTestFunc=&GAlphaBuffer::DepthTestGreater;
        break;
    case DEPTHTEST_GEQUAL:
    	DepthTestFunc=&GAlphaBuffer::DepthTestGreaterEqual;
        break;
    case DEPTHTEST_LESS:
    	DepthTestFunc=&GAlphaBuffer::DepthTestLess;
        break;
    case DEPTHTEST_LEQUAL:
    	DepthTestFunc=&GAlphaBuffer::DepthTestLessEqual;
        break;
	default:
    	DepthTestFunc=&GAlphaBuffer::DepthTestTrue;
        DepthTest=DEPTHTEST_TRUE;
   }
}


BOOL FASTCALL GAlphaBuffer::Alloc(INT width,INT height,INT depth)
{
 if(GRasterImage::Alloc(width,height,depth)!=TRUE) return FALSE;
 if((AlphaBuffer=(GAlpha *)malloc(Width*Height*sizeof(GAlpha)))==NULL) return FALSE;
 Flags|=DEPTHBUFFER | STENCILBUFFER;
 SetAlphaFunctions();

 return TRUE;
}


BOOL FASTCALL GAlphaBuffer::Free(void)
{
 if (AlphaBuffer)
	free(AlphaBuffer);
 if (ImageBuffer)
	free(ImageBuffer);

 (PTR)ImageBuffer=
 (PTR)AlphaBuffer=NULL;
 Flags=Width=Height=Depth=LineSize=0;
 return TRUE;
}


BOOL FASTCALL GAlphaBuffer::ClearAlpha(ULONG d,USHORT s,USHORT b)
{
 GAlpha *last,*current;
 if (!AlphaBuffer) return FALSE;
 last=AlphaBuffer+Width*Height;
 for(current=AlphaBuffer;current<last;current++)
   {
 	current->Depth=d;
    current->Stencil=s;
    current->Blend=b;
   }

 return TRUE;
}


BOOL FASTCALL GAlphaBuffer::ClearStencil(USHORT s)
{
 GAlpha *last,*current;
 if (!AlphaBuffer) return FALSE;
 last=AlphaBuffer+Width*Height;
 for(current=AlphaBuffer;current<last;current++)
    current->Stencil=s;

 return TRUE;
}


BOOL FASTCALL GAlphaBuffer::ClearBlend(USHORT b)
{
 GAlpha *last,*current;
 if (!AlphaBuffer) return FALSE;
 last=AlphaBuffer+Width*Height;
 for(current=AlphaBuffer;current<last;current++)
    current->Blend=b;

 return TRUE;
}


BOOL FASTCALL GAlphaBuffer::ClearDepth(ULONG d)
{
 GAlpha *last,*current;
 if (!AlphaBuffer) return FALSE;
 last=AlphaBuffer+Width*Height;
 for(current=AlphaBuffer;current<last;current++)
    current->Depth=d;

 return TRUE;
}


CHAR* FASTCALL GAlphaBuffer::GetFlagsName(CHAR *buffer)
{
 buffer[0]=0;
 if (Flags & DEPTHBUFFER)  	strcat(buffer,"DEPTHBUFFER ");
 if (Flags & STENCILBUFFER)  	strcat(buffer,"STENCILBUFFER ");
 if (Flags & BLENDBUFFER)  	strcat(buffer,"BLENDBUFFER ");
 if (Flags & DEPTHENABLED)  	strcat(buffer,"DEPTHENABLED ");
 if (Flags & STENCILENABLED)  strcat(buffer,"STENCILENABLED ");
 if (Flags & BLENDENABLED)  	strcat(buffer,"BLENDENABLED ");
 if (Flags & PALETTE)  	 	strcat(buffer,"PALETTE ");
 return buffer;
}


void FASTCALL GAlphaBuffer::PutPixel(INT x,INT y,DWORD col,ULONG d,USHORT s)
{
 if ((x<ClipWindow.Left) || (y<ClipWindow.Top) ||
	(x>ClipWindow.Right) || (y>ClipWindow.Bottom)) return;
 if (Flags & STENCILENABLED)
   {
    if ((this->*StencilTestFunc)(AlphaBuffer[y*Width+x].Stencil,s))
       {
        if (Flags & DEPTHENABLED)
           {
            if ((this->*DepthTestFunc)(AlphaBuffer[y*Width+x].Depth,d))
               {
	        	AlphaBuffer[y*Width+x].Stencil=(this->*StencilOpPassFunc)(AlphaBuffer[y*Width+x].Stencil,s);
	        	AlphaBuffer[y*Width+x].Depth=d;
                PutFastPixel(x,y,col);
               }
            else
               {
	        	AlphaBuffer[y*Width+x].Stencil=(this->*StencilOpZFailFunc)(AlphaBuffer[y*Width+x].Stencil,s);
			   }
           }
        else
           {
        	AlphaBuffer[y*Width+x].Stencil=(this->*StencilOpPassFunc)(AlphaBuffer[y*Width+x].Stencil,s);
            PutFastPixel(x,y,col);
           }
       }
    else
       {
        AlphaBuffer[y*Width+x].Stencil=(this->*StencilOpFailFunc)(AlphaBuffer[y*Width+x].Stencil,s);
       }
   }
 else if (Flags & DEPTHENABLED)
   {
    if ((this->*DepthTestFunc)(AlphaBuffer[y*Width+x].Depth,d))
       {
	    AlphaBuffer[y*Width+x].Depth=d;
        PutFastPixel(x,y,col);
       }
   }
 else PutFastPixel(x,y,col);
}


///////////////////////////////////////////////////////////////////////////////
//
// Stencil and depth buffer span preparation routines
//
void FASTCALL GAlphaBuffer::AddStencilMask(GAlpha *alpha,INT l,USHORT d)
{
 #define DoStencilTest(cmp)  							\
    	while(l--)                              		\
          	if (alpha[l].Stencil cmp d)  			   	\
            	PixelMask[l]|=GMZ_ALPHA_STENCILPASSED;  \
            else                                		\
            	PixelMask[l]=GMZ_ALPHA_STENCILFAILED;

 switch (StencilTest)
   {
    case STENCILTEST_TRUE:
    	while(l--)
        	alpha[l].Stencil|=GMZ_ALPHA_STENCILPASSED;
        break;
    case STENCILTEST_FALSE:
    	while(l--)
        	alpha[l].Stencil|=GMZ_ALPHA_STENCILFAILED;
        break;
    case STENCILTEST_EQUAL:
    	DoStencilTest(==);
        break;
    case STENCILTEST_NOTEQUAL:
    	DoStencilTest(!=);
        break;
    case STENCILTEST_GREATER:
    	DoStencilTest(<);
        break;
    case STENCILTEST_GEQUAL:
    	DoStencilTest(<=);
        break;
    case STENCILTEST_LESS:
    	DoStencilTest(>);
        break;
    case STENCILTEST_LEQUAL:
    	DoStencilTest(>=);
        break;
   }
 #undef DoStencilTest
}


void FASTCALL GAlphaBuffer::AddStencilMask(GAlpha *alpha,INT l,GExtPixel *p)
{
 #define DoStencilTest(cmp)  							\
    	while(l--)                              		\
          	if (alpha[l].Stencil cmp p[l].Stencil)     	\
            	PixelMask[l]|=GMZ_ALPHA_STENCILPASSED;  \
            else                                		\
            	PixelMask[l]=GMZ_ALPHA_STENCILFAILED;

 switch (StencilTest)
   {
    case STENCILTEST_TRUE:
    	while(l--)
        	alpha[l].Stencil|=GMZ_ALPHA_STENCILPASSED;
        break;
    case STENCILTEST_FALSE:
    	while(l--)
        	alpha[l].Stencil|=GMZ_ALPHA_STENCILFAILED;
        break;
    case STENCILTEST_EQUAL:
    	DoStencilTest(==);
        break;
    case STENCILTEST_NOTEQUAL:
    	DoStencilTest(!=);
        break;
    case STENCILTEST_GREATER:
    	DoStencilTest(<);
        break;
    case STENCILTEST_GEQUAL:
    	DoStencilTest(<=);
        break;
    case STENCILTEST_LESS:
    	DoStencilTest(>);
        break;
    case STENCILTEST_LEQUAL:
    	DoStencilTest(>=);
        break;
   }
 #undef DoStencilTest
}


void FASTCALL GAlphaBuffer::AddDepthMask(GAlpha *alpha,INT l,ULONG d)
{
 #define DoDepthTest(a) 									\
 		if (DepthMask)										\
	    	while(l--)                              		\
	          	if (alpha[l].Depth a d)  			   		\
	               {										\
	            	PixelMask[l]|=GMZ_ALPHA_DEPTHPASSED;	\
 	                alpha[l].Depth=d;             			\
	               }                                		\
	            else                                		\
	            	PixelMask[l]|=GMZ_ALPHA_DEPTHFAILED; 	\
        else                                        		\
	    	while(l--)                              		\
	          	if (alpha[l].Depth a d)  			   		\
	            	PixelMask[l]|=GMZ_ALPHA_DEPTHPASSED;	\
	            else                                		\
	            	PixelMask[l]|=GMZ_ALPHA_DEPTHFAILED;

 switch (DepthTest)
   {
    case DEPTHTEST_TRUE:
    	while(l--)
           {
           	PixelMask[l]|=GMZ_ALPHA_DEPTHPASSED;
            if (DepthMask)
	            alpha[l].Depth=d;
           }
        break;
    case DEPTHTEST_FALSE:
    	while(l--)
           	PixelMask[l]|=GMZ_ALPHA_DEPTHFAILED;
        break;
    case STENCILTEST_EQUAL:
    	DoDepthTest(==);
        break;
    case STENCILTEST_NOTEQUAL:
    	DoDepthTest(!=);
        break;
    case STENCILTEST_GREATER:
    	DoDepthTest(<);
        break;
    case STENCILTEST_GEQUAL:
    	DoDepthTest(<=);
        break;
    case STENCILTEST_LESS:
    	DoDepthTest(>);
        break;
    case STENCILTEST_LEQUAL:
    	DoDepthTest(>=);
        break;
   }
 #undef DoDepthTest
}


void FASTCALL GAlphaBuffer::AddDepthMask(GAlpha *alpha,INT l,GExtPixel *p)
{
 #define DoDepthTest(a) 									\
 		if (DepthMask)										\
	    	while(l--)                              		\
	          	if (alpha[l].Depth a p[l].Depth) 	   		\
	               {										\
	            	PixelMask[l]|=GMZ_ALPHA_DEPTHPASSED;	\
 	                alpha[l].Depth=p[l].Depth;         		\
	               }                                		\
	            else                                		\
	            	PixelMask[l]|=GMZ_ALPHA_DEPTHFAILED; 	\
        else                                        		\
	    	while(l--)                              		\
	          	if (alpha[l].Depth a p[l].Depth)	   		\
	            	PixelMask[l]|=GMZ_ALPHA_DEPTHPASSED;	\
	            else                                		\
	            	PixelMask[l]|=GMZ_ALPHA_DEPTHFAILED;


 switch (DepthTest)
   {
    case DEPTHTEST_TRUE:
    	while(l--)
           {
           	PixelMask[l]|=GMZ_ALPHA_DEPTHPASSED;
            if (DepthMask)
	            alpha[l].Depth=p[l].Depth;
           }
        break;
    case DEPTHTEST_FALSE:
    	while(l--)
           	PixelMask[l]|=GMZ_ALPHA_DEPTHFAILED;
        break;
    case STENCILTEST_EQUAL:
    	DoDepthTest(==);
        break;
    case STENCILTEST_NOTEQUAL:
    	DoDepthTest(!=);
        break;
    case STENCILTEST_GREATER:
    	DoDepthTest(<);
        break;
    case STENCILTEST_GEQUAL:
    	DoDepthTest(<=);
        break;
    case STENCILTEST_LESS:
    	DoDepthTest(>);
        break;
    case STENCILTEST_LEQUAL:
    	DoDepthTest(>=);
        break;
   }
 #undef DoDepthTest
}


///////////////////////////////////////////////////////////////////////////////
//
// Stencilbuffer operation functions
//
#define DoStencilOp(op,flag,stencil) 							\
   {                                                    		\
 	INT i;                                              		\
 	switch (op)                                         		\
	   {                                                		\
		case STENCILOP_ZERO:                        		\
	    	for(i=0;i<l;i++)                            		\
	        	if ((PixelMask[i] & (flag))==(flag))    		\
	            	alpha[i].Stencil=0;                 		\
	        break;                                      		\
	    case STENCILOP_INCREMENT:                   		\
	    	for(i=0;i<l;i++)                            		\
	        	if ((PixelMask[i] & (flag))==(flag))    		\
	               {                                    		\
	                if (++alpha[i].Stencil==0)          		\
	                	alpha[i].Stencil=(USHORT)~0;    		\
	               }                                    		\
	        break;                                      		\
	    case STENCILOP_DECREMENT:                   		\
	    	for(i=0;i<l;i++)                            		\
	        	if ((PixelMask[i] & (flag))==(flag))    		\
	               {                                    		\
	                if (--alpha[i].Stencil==(USHORT)~0) 		\
	                	alpha[i].Stencil=(USHORT)~0;    		\
	               }                                    		\
	        break;                                      		\
	    case STENCILOP_REPLACE:                     		\
	    	for(i=0;i<l;i++)                            		\
	        	if ((PixelMask[i] & (flag))==(flag))    		\
	                alpha[i].Stencil=(stencil);           		\
	        break;                                      		\
	    case STENCILOP_INVERT:                      		\
	    	for(i=0;i<l;i++)                            		\
	        	if ((PixelMask[i] & (flag))==(flag))    		\
	                alpha[i].Stencil=(USHORT)~alpha[i].Stencil; \
			break;                                      		\
	    case STENCILOP_MAX:                      			\
	    	for(i=0;i<l;i++)                            		\
	        	if (((PixelMask[i] & (flag))==(flag)) && 		\
                	 (alpha[i].Stencil<(stencil)))      		\
	                alpha[i].Stencil=(stencil); 				\
			break;                                      		\
	    case STENCILOP_MIN:                      			\
	    	for(i=0;i<l;i++)                            		\
	        	if (((PixelMask[i] & (flag))==(flag)) && 		\
                	 (alpha[i].Stencil>(stencil)))      		\
	                alpha[i].Stencil=(stencil); 				\
			break;                                      		\
	   }                                                		\
    }

void FASTCALL GAlphaBuffer::ApplyStencilFunction(GAlpha *alpha,INT l,USHORT s)
{
 DoStencilOp(StencilOpFail,GMZ_ALPHA_STENCILFAILED,s);
 DoStencilOp(StencilOpPass,GMZ_ALPHA_STENCILPASSED | GMZ_ALPHA_DEPTHPASSED,s);
 DoStencilOp(StencilOpZFail,GMZ_ALPHA_STENCILPASSED | GMZ_ALPHA_DEPTHFAILED,s);
}


void FASTCALL GAlphaBuffer::ApplyStencilFunction(GAlpha *alpha,INT l,GExtPixel *p)
{
 DoStencilOp(StencilOpFail,GMZ_ALPHA_STENCILFAILED,p[i].Stencil);
 DoStencilOp(StencilOpPass,GMZ_ALPHA_STENCILPASSED | GMZ_ALPHA_DEPTHPASSED,p[i].Stencil);
 DoStencilOp(StencilOpZFail,GMZ_ALPHA_STENCILPASSED | GMZ_ALPHA_DEPTHFAILED,p[i].Stencil);
}



///////////////////////////////////////////////////////////////////////////////
//
// Custom GetSpan / PutSpan routines
//
#define GenericPutSpan(itype,pixel,depth,stencil) 							    	\
	 INT o=Width*y+x;															    \
	 if ((Flags & STENCILENABLED) && (Flags & DEPTHENABLED))						\
	   {                                                                            \
	 	memset(PixelMask,0,sizeof(PixelMask));                                      \
		AddStencilMask(&AlphaBuffer[o],l,stencil);                                  \
	    AddDepthMask(&AlphaBuffer[o],l,depth);                                      \
		ApplyStencilFunction(&AlphaBuffer[o],l,stencil);                            \
	   }                                                                            \
	 else if (Flags & STENCILENABLED)                                     			\
	   {                                                                            \
	 	memset(PixelMask,GMZ_ALPHA_DEPTHPASSED,sizeof(PixelMask));                  \
		AddStencilMask(&AlphaBuffer[o],l,stencil);                                  \
		ApplyStencilFunction(&AlphaBuffer[o],l,stencil);                            \
	   }                                                                            \
	 else if (Flags & DEPTHENABLED)                                       			\
	   {                                                                            \
	 	memset(PixelMask,GMZ_ALPHA_STENCILPASSED,sizeof(PixelMask));                \
	    AddDepthMask(&AlphaBuffer[o],l,depth);                                      \
	   }                                                                            \
	 else                                                                           \
	 	memset(PixelMask,GMZ_ALPHA_STENCILPASSED | GMZ_ALPHA_DEPTHPASSED,sizeof(PixelMask)); \
                                                                                    \
	 while(l--)                                                                     \
	   {                                                                            \
	    if ((PixelMask[l] & GMZ_ALPHA_ALLPASSED)==GMZ_ALPHA_ALLPASSED)              \
	    	((itype *)ImageBuffer)[o+l]=(itype)pixel;                         		\
	   }


#pragma argsused
void FASTCALL GAlphaBuffer::PutPixSpan0(INT x,INT y,INT l,GPixel *pixel,ULONG depth,USHORT stencil)
{
}

void FASTCALL GAlphaBuffer::PutPixSpan8(INT x,INT y,INT l,GPixel *pixel,ULONG depth,USHORT stencil)
{
 GenericPutSpan(BYTE,((BYTE *)pixel)[l],depth,stencil);
}

void FASTCALL GAlphaBuffer::PutPixSpan16(INT x,INT y,INT l,GPixel *pixel,ULONG depth,USHORT stencil)
{
 GenericPutSpan(WORD,((WORD *)pixel)[l],depth,stencil);
}

void FASTCALL GAlphaBuffer::PutPixSpan32(INT x,INT y,INT l,GPixel *pixel,ULONG depth,USHORT stencil)
{
 GenericPutSpan(DWORD,((DWORD *)pixel)[l],depth,stencil);
}

#pragma argsused
void FASTCALL GAlphaBuffer::PutColSpan0(INT x,INT y,INT l,DWORD col,ULONG depth,USHORT stencil)
{
}

void FASTCALL GAlphaBuffer::PutColSpan8(INT x,INT y,INT l,DWORD col,ULONG depth,USHORT stencil)
{
 GenericPutSpan(BYTE,col,depth,stencil);
}

void FASTCALL GAlphaBuffer::PutColSpan16(INT x,INT y,INT l,DWORD col,ULONG depth,USHORT stencil)
{
 GenericPutSpan(WORD,col,depth,stencil);
}

void FASTCALL GAlphaBuffer::PutColSpan32(INT x,INT y,INT l,DWORD col,ULONG depth,USHORT stencil)
{
 GenericPutSpan(DWORD,col,depth,stencil);
}

#pragma argsused
void FASTCALL GAlphaBuffer::PutExtSpan0(INT x,INT y,INT l,GExtPixel *pixel)
{
}

void FASTCALL GAlphaBuffer::PutExtSpan8(INT x,INT y,INT l,GExtPixel *pixel)
{
 GenericPutSpan(BYTE,pixel[l].Colour,pixel,pixel);
}

void FASTCALL GAlphaBuffer::PutExtSpan16(INT x,INT y,INT l,GExtPixel *pixel)
{
 GenericPutSpan(WORD,pixel[l].Colour,pixel,pixel);
}

void FASTCALL GAlphaBuffer::PutExtSpan32(INT x,INT y,INT l,GExtPixel *pixel)
{
 GenericPutSpan(DWORD,pixel[l].Colour,pixel,pixel);
}

#pragma argsused
void FASTCALL GAlphaBuffer::GetExtSpan0(INT x,INT y,INT l,GExtPixel *p)
{
}

void FASTCALL GAlphaBuffer::GetExtSpan8(INT x,INT y,INT l,GExtPixel *p)
{
 INT o=Width*y+x+l-1;

 while(l--)
   {
    p[l].Stencil=AlphaBuffer[o].Stencil;
    p[l].Blend=AlphaBuffer[o].Blend;
    p[l].Depth=AlphaBuffer[o].Depth;
    p[l].Colour=(DWORD)((BYTE *)ImageBuffer)[o--];
   }
}

void FASTCALL GAlphaBuffer::GetExtSpan16(INT x,INT y,INT l,GExtPixel *p)
{
 INT o=Width*y+x+l-1;

 while(l--)
   {
    p[l].Stencil=AlphaBuffer[o].Stencil;
    p[l].Blend=AlphaBuffer[o].Blend;
    p[l].Depth=AlphaBuffer[o].Depth;
    p[l].Colour=(DWORD)((WORD *)ImageBuffer)[o--];
   }
}

void FASTCALL GAlphaBuffer::GetExtSpan32(INT x,INT y,INT l,GExtPixel *p)
{
 INT o=Width*y+x+l-1;

 while(l--)
   {
    p[l].Stencil=AlphaBuffer[o].Stencil;
    p[l].Blend=AlphaBuffer[o].Blend;
    p[l].Depth=AlphaBuffer[o].Depth;
    p[l].Colour=(DWORD)((DWORD *)ImageBuffer)[o--];
   }
}

