///////////////////////////////////////////////////////////////////////////////
//
// (c) 1997 by Marc van Shaney , aka Kaya Memisoglu
//
// This Source-Code was written by and is copyrighted by Kaya Memisoglu
// You may use the whole code or only parts of it in your own programs
// whether they are commercial or not. BUT you must give credits for these
// parts to me (Kaya Memisoglu  or  Marc van Shaney).
// I am not responsible for any damage or loss caused by this program, so
// if you success in erasing your harddisk with this code, then it is your
// own fault and you should not claim me to be responsible...
// I would be very pleased if you also sent me a postcard or even a letter
// if you can use this code. My address:
//
//        Kaya Memisoglu
//        Reichenberger Ring 50
//        63512 Hainburg
//        Germany
//
//

#include "../include/gomez.h"

CHAR* FASTCALL GApplication::GetFlagsName(CHAR *buffer)
{
 buffer[0]=0;
 if (Flags & STARTED)		strcat(buffer,"STARTED ");
 return buffer;
}


BOOL FASTCALL GThread::Start(LONG p)
{
 #if defined(__FORWIN32__) && defined(__FORBORLAND__) && defined(__MT__)
  param=p;
  if((ThreadHandle=_beginthread(StartProc,GMZ_THREAD_STACKSIZE,(void *)this))==0xffffffff)
	return (ThreadHandle=ThreadId=NULL,FALSE);
 #elif defined(__FORWIN32__)
  param=p;
  if(!(ThreadHandle=(DWORD)CreateThread(NULL,0,StartProc,(LPVOID)this,0,&ThreadId)))
	return (ThreadHandle=ThreadId=NULL,FALSE);
 #elif defined(__FORUNIX__)

 #else
  ThreadHandle=NULL;
 #endif
 return ThreadHandle ? TRUE : FALSE;
}

BOOL FASTCALL GThread::Terminate(void)
{
 #if defined(__FORWIN32__)
  if (!OnTerminate()) return FALSE;
  if (GetCurrentThread()==(HANDLE)ThreadHandle)
   {
	#if defined(__FORBORLAND__) && defined(__MT__)
	 ThreadHandle=ThreadId=SuspendCount=NULL;
	 _endthread();
	 return TRUE;
	#else
	 ThreadHandle=ThreadId=SuspendCount=NULL;
	 ExitThread(0);
	 return TRUE;
	#endif
   }
  else
   {
	if(!TerminateThread((HANDLE)ThreadHandle,0))
		return FALSE;
	ThreadHandle=ThreadId=SuspendCount=NULL;
	return TRUE;
   }
 #elif defined(__FORUNIX__)

 #else
  return FALSE
 #endif
}

BOOL FASTCALL GThread::Sleep(LONG t)
{
 #if defined(__FORWIN32__)
  Sleep(t);
  return TRUE;
 #elif defined(__FORUNIX__)

 #else
  return FALSE;
 #endif
}

BOOL FASTCALL GThread::Suspend(void)
{
 #if defined(__FORWIN32__)
  DWORD r=SuspendThread((HANDLE)ThreadHandle);
  if (r==0xffffffff) return FALSE;
  SuspendCount=r+1;
  return TRUE;
 #elif defined(__FORUNIX__)

 #else
  return FALSE;
 #endif
}

BOOL FASTCALL GThread::Resume(void)
{
 #if defined(__FORWIN32__)
  DWORD r=ResumeThread((HANDLE)ThreadHandle);
  if (r==0xffffffff) return FALSE;
  SuspendCount=(r ? r-1 : 0);
  return TRUE;
 #elif defined(__FORUNIX__)

 #else
  return FALSE;
 #endif
}

#if defined(__FORWIN32__) && defined(__FORBORLAND__) && defined(__MT__)
 void _USERENTRY GThread::StartProc(void *t)
  {
   GThread *prc=(GThread *)t;
   ((GThread*) prc)->ThreadId=GetCurrentThreadId();
   ((GThread*) prc)->Priority=GetThreadPriority(GetCurrentThread());
   ((GThread*) prc)->OnStart((LONG)((GThread *)prc)->param);
   ((GThread*) prc)->Main((LONG)((GThread *)prc)->param);
   ((GThread*) prc)->ThreadId=
   ((GThread*) prc)->ThreadHandle=
   ((GThread*) prc)->Priority=NULL;
  }
#elif defined(__FORWIN32__)
 DWORD WINAPI GThread::StartProc(LPVOID prc)
  {
   DWORD r;
   ((GThread*) prc)->ThreadId=GetCurrentThreadId();
   ((GThread*) prc)->Priority=GetThreadPriority(GetCurrentThread());
   ((GThread*) prc)->OnStart((LONG)((GThread *)prc)->param);
   r=(DWORD)((GThread*) prc)->Main((LONG)((GThread *)prc)->param);
   ((GThread*) prc)->ThreadId=
   ((GThread*) prc)->ThreadHandle=
   ((GThread*) prc)->Priority=NULL;
   return r;
  }
#endif




LONG FASTCALL GTimer::SetSpeed(LONG del,LONG res)
{
 if (res>del) res=del/2;

 #if defined(__FORWINDOWS__)
  if(!del)
   {
	if (!Speed) return 0;
	if (!TimerId) return 0;
	timeKillEvent(TimerId);
	TimerId=0;
	Speed=0;
	return 0;
   }
  else
   {
	if((TimerId=timeSetEvent(del,res,TimerProc,(DWORD)this,TIME_PERIODIC))==NULL) return FALSE;
	Speed=del;
	TickCount=0;
	return del;
   }
 #elif defined(__FORX11__)

 #else
  return 0;
 #endif
}

#if defined(__FORWINDOWS__)
#pragma argsused
void CALLBACK GTimer::TimerProc(UINT uID,UINT Msg,DWORD tmr,DWORD dw1,DWORD dw2)
{
 ((GTimer *)tmr)->Handler(++((GTimer *)tmr)->TickCount);
}
#endif

