///////////////////////////////////////////////////////////////////////////////
//
// (c) 1997 by Marc van Shaney , aka Kaya Memisoglu
//
// This Source-Code was written by and is copyrighted by Kaya Memisoglu
// You may use the whole code or only parts of it in your own programs
// whether they are commercial or not. BUT you must give credits for these
// parts to me (Kaya Memisoglu  or  Marc van Shaney).
// I am not responsible for any damage or loss caused by this program, so
// if you success in erasing your harddisk with this code, then it is your
// own fault and you should not claim me to be responsible...
// I would be very pleased if you also sent me a postcard or even a letter
// if you can use this code. My address:
//
//        Kaya Memisoglu
//        Reichenberger Ring 50
//        63512 Hainburg
//        Germany
//
//


#include "../include/gomez.h"


BOOL FASTCALL GRasterImage::Alloc(INT w,INT h,INT d)
{
 Width=w;
 Height=h;
 Depth=d;
 LineSize=Width*((d+7)>>3);
 ClipWindow.Left=
 ClipWindow.Top=0;
 ClipWindow.Right=Width-1;
 ClipWindow.Bottom=Height-1;
 if((ImageBuffer=(GPixel *)malloc(LineSize*Height))==NULL) return FALSE;
 SetPixelFunctions();

 return TRUE;
}


BOOL FASTCALL GRasterImage::Free(void)
{
 if (ImageBuffer)
	free(ImageBuffer);

 ImageBuffer=NULL;
 Width=Height=Depth=LineSize=0;
 return TRUE;
}


void FASTCALL GRasterImage::SetPixelFunctions(void)
{
 switch(Depth)
   {
    case 8:
        GetPixelFunc=&GRasterImage::GetPixel8;
        PutPixelFunc=&GRasterImage::PutPixel8;
        GetFastPixelFunc=&GRasterImage::GetFastPixel8;
        PutFastPixelFunc=&GRasterImage::PutFastPixel8;
 		PutBitmapFunc=&GRasterImage::PutBitmap8;
		PutColSpanFunc=&GRasterImage::PutColSpan8;
		PutPixSpanFunc=&GRasterImage::PutPixSpan8;
		GetPixSpanFunc=&GRasterImage::GetPixSpan8;
		break;
	case 15:
	case 16:
		GetPixelFunc=&GRasterImage::GetPixel16;
		PutPixelFunc=&GRasterImage::PutPixel16;
		GetFastPixelFunc=&GRasterImage::GetFastPixel16;
		PutFastPixelFunc=&GRasterImage::PutFastPixel16;
		PutBitmapFunc=&GRasterImage::PutBitmap16;
		PutColSpanFunc=&GRasterImage::PutColSpan16;
		PutPixSpanFunc=&GRasterImage::PutPixSpan16;
		GetPixSpanFunc=&GRasterImage::GetPixSpan16;
		break;
	case 24:
	case 32:
		GetPixelFunc=&GRasterImage::GetPixel32;
		PutPixelFunc=&GRasterImage::PutPixel32;
		GetFastPixelFunc=&GRasterImage::GetFastPixel32;
		PutFastPixelFunc=&GRasterImage::PutFastPixel32;
		PutBitmapFunc=&GRasterImage::PutBitmap32;
		PutColSpanFunc=&GRasterImage::PutColSpan32;
		PutPixSpanFunc=&GRasterImage::PutPixSpan32;
		GetPixSpanFunc=&GRasterImage::GetPixSpan32;
		break;
	default:
		GetPixelFunc=&GRasterImage::GetPixel0;
		PutPixelFunc=&GRasterImage::PutPixel0;
		GetFastPixelFunc=&GRasterImage::GetFastPixel0;
		PutFastPixelFunc=&GRasterImage::PutFastPixel0;
		PutBitmapFunc=&GRasterImage::PutBitmap0;
		PutColSpanFunc=&GRasterImage::PutColSpan0;
		PutPixSpanFunc=&GRasterImage::PutPixSpan0;
		GetPixSpanFunc=&GRasterImage::GetPixSpan0;
   }
}


CHAR* FASTCALL GRasterImage::GetFlagsName(CHAR *b)
{
 strcpy(b,"");
 return b;
}


BOOL FASTCALL GRasterImage::ClearImage(DWORD val)
{
 PTR last,current;
 if (!ImageBuffer) return FALSE;
 switch(Depth)
   {
	case 8:
    	last=(PTR)((BYTE *)ImageBuffer+LineSize*Height);
        for(current=ImageBuffer;current<last;((BYTE *)current)++)
			*(BYTE *)current=(BYTE)val;
        return TRUE;
	case 15:
    case 16:
    	last=(PTR)((BYTE *)ImageBuffer+LineSize*Height);
        for(current=ImageBuffer;current<last;((WORD *)current)++)
			*(WORD *)current=(WORD)val;
        return TRUE;
    case 24:
	case 32:
    	last=(PTR)((BYTE *)ImageBuffer+LineSize*Height);
        for(current=ImageBuffer;current<last;((DWORD *)current)++)
			*(DWORD *)current=(DWORD)val;
        return TRUE;
	default:
    	return FALSE;
   }
}


BOOL FASTCALL GRasterImage::PutBitmap(GBitmap *bmp,INT x,INT y)
{
 GRectL DstWindow=GRectL(x,y,x+bmp->GetWidth()-1,y+bmp->GetHeight()-1) & ClipWindow;
 GRectL SrcWindow=GRectL(0,0,bmp->GetWidth()-1,bmp->GetHeight()-1) & (ClipWindow-GPointL(x,y));
 if (DstWindow.IsEmpty()) return TRUE;

 return (this->*PutBitmapFunc)(bmp,SrcWindow,DstWindow);
}


#pragma argsused
BOOL FASTCALL GRasterImage::PutBitmap0(GBitmap *bmp,GRectL &src,GRectL &dst)
{
 return FALSE;
}


BOOL FASTCALL GRasterImage::PutBitmap8(GBitmap *bmp,GRectL &srcR,GRectL &dstR)
{
 INT width=dstR.GetWidth();
 INT height=dstR.GetHeight();
 BYTE *dst=&((BYTE *)ImageBuffer)[Width*dstR.Top+dstR.Left];
 PTR src;

 switch(bmp->GetDepth())
   {
    case 8:
		(BYTE *)src=&((BYTE *)bmp->GetImage())[srcR.Top*bmp->GetWidth()+srcR.Left];
    	while(height)
           {
			memcpy(dst,src,width);
            dst+=Width;
            (BYTE *)src+=bmp->GetWidth();
            height--;
           }
        return TRUE;
    default:
    	return FALSE;
   }
}


BOOL FASTCALL GRasterImage::PutBitmap32(GBitmap *bmp,GRectL &srcR,GRectL &dstR)
{
 INT width=dstR.GetWidth();
 INT height=dstR.GetHeight();
 INT i;
 DWORD *dst=&((DWORD *)ImageBuffer)[Width*dstR.Top+dstR.Left];
 DWORD *ctable;
 PTR src;

 switch(bmp->GetDepth())
   {
	case 8:
		(BYTE *)src=&((BYTE *)bmp->GetImage())[srcR.Top*bmp->GetWidth()+srcR.Left];
		ctable=bmp->GetPalette()->GetColourTable(GMZ_PAL_RGB32);
    	while(height)
           {
            for(i=0;i<width;i++)
            	dst[i]=ctable[((BYTE *)src)[i]];
            dst+=Width;
            (BYTE *)src+=bmp->GetWidth();
            height--;
           }
        return TRUE;
    case 32:
		(DWORD *)src=&((DWORD *)bmp->GetImage())[srcR.Top*bmp->GetWidth()+srcR.Left];
    	while(height)
           {
			memcpy(dst,src,width<<2);
            dst+=Width;
            (DWORD *)src+=bmp->GetWidth();
            height--;
           }
        return TRUE;
    default:
    	return FALSE;
   }
}


BOOL FASTCALL GRasterImage::PutBitmap16(GBitmap *bmp,GRectL &srcR,GRectL &dstR)
{
 INT width=dstR.GetWidth();
 INT height=dstR.GetHeight();
 INT i;
 WORD *dst=&((WORD *)ImageBuffer)[Width*dstR.Top+dstR.Left];
 DWORD *ctable;
 PTR src;

 switch(bmp->GetDepth())
   {
	case 8:
		(BYTE *)src=&((BYTE *)bmp->GetImage())[srcR.Top*bmp->GetWidth()+srcR.Left];
		ctable=bmp->GetPalette()->GetColourTable((Depth==15) ? GMZ_PAL_RGB15 : GMZ_PAL_RGB16);
    	while(height)
           {
            for(i=0;i<width;i++)
            	dst[i]=(WORD)ctable[((BYTE *)src)[i]];
            dst+=Width;
            (BYTE *)src+=bmp->GetWidth();
            height--;
           }
        return TRUE;
    case 15:
    case 16:
		(WORD *)src=&((WORD *)bmp->GetImage())[srcR.Top*bmp->GetWidth()+srcR.Left];
    	while(height)
           {
			memcpy(dst,src,width<<1);
            dst+=Width;
            (WORD *)src+=bmp->GetWidth();
            height--;
           }
        return TRUE;
    default:
    	return FALSE;
   }
}




BOOL FASTCALL GBitmap::Alloc(INT w,INT h,INT d)
{
 if (!GRasterImage::Alloc(w,h,d)) return FALSE;
 if (Flags & MASK)
 	AllocMask();
 if (Flags & PALETTE)
 	AllocPalette();
 return TRUE;
}


BOOL FASTCALL GBitmap::Resize(INT w,INT h)
{
 if (ImageBuffer) free(ImageBuffer);
 if (MaskBuffer) free(MaskBuffer);
 if (!GRasterImage::Alloc(w,h,Depth)) return FALSE;
 if (Flags & MASK)
 	AllocMask();
 return TRUE;
}


BOOL FASTCALL GBitmap::Free(void)
{
 if (!GRasterImage::Free()) return FALSE;
 if (MaskBuffer)
 	free(MaskBuffer);
 if ((Flags & PALETTE) && (Palette))
	delete Palette;

 (PTR)MaskBuffer=(PTR)Palette=NULL;
 Flags&=~(PALETTE | MASK);
 return TRUE;
}


CHAR* FASTCALL GBitmap::GetFlagsName(CHAR *buffer)
{
 buffer[0]=0;
 if (Flags & PALETTE)  	 	strcat(buffer,"PALETTE ");
 if (Flags & MASK)  	 	strcat(buffer,"MASK ");
 return buffer;
}


BOOL FASTCALL GBitmap::Rescale(INT newwidth,INT newheight)
{
 GPixel* newmap;
 INT i,j;
 INT x,y=0,x_inc,y_inc;

 if (!ImageBuffer) return Alloc(newwidth,newheight,Depth);
 if ((newmap=(GPixel *)malloc(newwidth*newheight))==NULL) return FALSE;

 x_inc=(Width<<16)/newwidth;
 y_inc=(Height<<16)/newheight;

 for(i=0;i<newheight;i++)
   {
	x=0;
	for (j=0;j<newwidth;j++)
	   {
		((BYTE *)newmap)[i*newwidth+j]=((BYTE *)ImageBuffer)[(y>>16)*LineSize+(x>>16)];
		x+=x_inc;
	   }
	y+=y_inc;
   }

 free(ImageBuffer);
 ImageBuffer=newmap;
 Width=newwidth;
 Height=newheight;
 ClipWindow.Left=
 ClipWindow.Top=0;
 ClipWindow.Right=Width-1;
 ClipWindow.Bottom=Height-1;
 return TRUE;
}


BOOL FASTCALL GBitmap::ImportPCX(char *fname,GPalette *pal)
{
 INT bsize,i,fsize;
 BYTE *sbuffer,*pbuffer,*srcptr,*dstptr,col;
 PCX_Header phead;
 FILE *fhandle;

 Free();
 SetName(fname);
 if (pal==NULL)	pal=AllocPalette();
 Palette=pal;

 if ((fhandle=fopen(fname,"rb"))==NULL) return FALSE;
 fseek(fhandle,0,SEEK_END);
 fsize=ftell(fhandle);
 fseek(fhandle,0,SEEK_SET);
 fread(&phead,sizeof(PCX_Header),1,fhandle);

 if (phead.Magic!=PCX_Magic) return (fclose(fhandle),FALSE);

 Width=LSB2WORD(phead.X2)-LSB2WORD(phead.X1)+1;
 Height=LSB2WORD(phead.Y2)-LSB2WORD(phead.Y1)+1;
 bsize=Width*Height;

 if((srcptr=sbuffer=(BYTE *)malloc(fsize-768-sizeof(PCX_Header)))==NULL) return (fclose(fhandle),FALSE);
 if((pbuffer=(BYTE *)malloc(768))==NULL) return (fclose(fhandle),FALSE);
 if(Alloc(Width,Height,8)==FALSE) return (fclose(fhandle),FALSE);
 dstptr=(BYTE *)ImageBuffer;

 fread(sbuffer,fsize-768-sizeof(PCX_Header),1,fhandle);
 fread(pbuffer,768,1,fhandle);

 while(bsize>0)
   {
	if (*srcptr>192)
		{
		 i=(int)((*srcptr++) & 63);
		 col=*srcptr++;
		 bsize-=(int)i;
		 while (i)
			{
			 *dstptr++=col;
			 i--;
			}
		}
	else
		{
		 *dstptr++=*srcptr++;
		 bsize--;
		}
   }

 for (i=0;i<256;i++)
	pal->SetColour(i,pbuffer[i*3],pbuffer[i*3+1],pbuffer[i*3+2]);

 free(sbuffer);
 free(pbuffer);
 fclose(fhandle);

 return TRUE;
}


BOOL FASTCALL GBitmap::Remap(GPalette *dst,GPalette *src)
{
 BYTE *xtable;
 INT i,j;

 if(!ImageBuffer) return FALSE;
 if(Depth!=8) return FALSE;
 if(src==NULL) src=Palette;
 if((xtable=dst->ApproximatePalette(src))==NULL) return NULL;

 for (i=0;i<Height;i++)
	for (j=0;j<Width;j++)
		((BYTE *)ImageBuffer)[i*Width+j]=xtable[((BYTE *)ImageBuffer)[i*Width+j]];

 if (Flags & PALETTE)
	*Palette=*dst;

 free(xtable);
 return TRUE;
}


BOOL FASTCALL GBitmap::MakeMask(DWORD back,INT mode)
{
 INT x,y;
 DWORD col;

 if(!AllocMask()) return FALSE;

 for(y=0;y<Height;y++)
  	for(x=0;x<Width;x++)
       {
		col=GetPixel(x,y);
        SetMask(x,y,col==back);
       }

 return TRUE;
}


BOOL FASTCALL GBitmap::Write(GFile &file,DWORD ctype)
{
 FileBitmapHead fbmp;

 GetName(fbmp.Name);
 fbmp.Magic=DWORD2LSB(Magic);
 fbmp.Type=DWORD2LSB(Type);
 fbmp.Width=DWORD2LSB(Width);
 fbmp.Height=DWORD2LSB(Height);
 fbmp.LineSize=DWORD2LSB(LineSize);
 fbmp.Depth=DWORD2LSB(Depth);
 fbmp.Flags=DWORD2LSB(Flags);

 if(file.CreateMetaChunk(ctype)!=TRUE) return FALSE;
 if(file.CreateChunk(GFile::HEAD_TYPE)!=TRUE) return FALSE;
 if(file.WriteChunk(&fbmp,sizeof(fbmp))!=sizeof(fbmp)) return FALSE;
 if(file.CloseChunk()!=TRUE) return FALSE;

 if (ImageBuffer)
   {
	if(file.CreateChunk(GFile::DATA_TYPE)!=TRUE) return FALSE;
	if(file.WriteChunk(ImageBuffer,GetSize())!=GetSize()) return FALSE;
	if(file.CloseChunk()!=TRUE) return FALSE;
   }
 if (MaskBuffer)
   {
	if(file.CreateChunk(GBitmap::MASK_TYPE)!=TRUE) return FALSE;
	if(file.WriteChunk(MaskBuffer,((Width+7)>>3)*Height)!=((Width+7)>>3)*Height) return FALSE;
	if(file.CloseChunk()!=TRUE) return FALSE;
   }

 if (Palette && (Flags & PALETTE))
   {
    GColour *buf=new GColour[256];
    for (INT i=0;i<256;i++)
    	buf[i]=Palette->GetColour(i);
	if(file.CreateChunk(GPalette::PALETTE_TYPE)!=TRUE) return FALSE;
	if(file.WriteChunk(buf,256*sizeof(GColour))!=256*sizeof(GColour)) return FALSE;
	if(file.CloseChunk()!=TRUE) return FALSE;
    delete buf;
   }

 return file.CloseMetaChunk();
}


BOOL FASTCALL GBitmap::Read(GFile &file)
{
 void *data;
 DWORD type;
 INT i;

 Free();

 while ((type=file.OpenChunk())!=GFile::END_TYPE)
   {
	switch (type)
	   {
		case GFile::HEAD_TYPE:
			if(file.ReadChunk(&data)!=sizeof(FileBitmapHead)) return FALSE;
			if(file.CloseChunk()!=TRUE) return FALSE;
			SetName(((FileBitmapHead *)data)->Name);
			Magic=LSB2DWORD(((FileBitmapHead *)data)->Magic);
			Type=LSB2DWORD(((FileBitmapHead *)data)->Type);
			Flags=LSB2DWORD(((FileBitmapHead *)data)->Flags) & ~PALETTE;
			Depth=LSB2DWORD(((FileBitmapHead *)data)->Depth);
			Width=LSB2DWORD(((FileBitmapHead *)data)->Width);
			Height=LSB2DWORD(((FileBitmapHead *)data)->Height);
			LineSize=LSB2DWORD(((FileBitmapHead *)data)->LineSize);
 			ClipWindow.Left=
			ClipWindow.Top=0;
			ClipWindow.Right=Width-1;
			ClipWindow.Bottom=Height-1;
			free(data);
			break;
		case GFile::DATA_TYPE:
			if(file.ReadChunk(&data)==0) return FALSE;
			if(file.CloseChunk()!=TRUE) return FALSE;
			ImageBuffer=(GPixel *)data;
			break;
		case GBitmap::MASK_TYPE:
			if(file.ReadChunk(&data)==0) return FALSE;
			if(file.CloseChunk()!=TRUE) return FALSE;
			MaskBuffer=(GMask *)data;
            Flags|=MASK;
			break;
		case GPalette::PALETTE_TYPE:
			Flags|=PALETTE;
			Palette=new GPalette;
			if(file.ReadChunk(&data)!=sizeof(GColour)*256) return FALSE;
			if(file.CloseChunk()!=TRUE) return FALSE;
            for (i=0;i<256;i++)
            	Palette->SetColour(i,((GColour *)data)[i]);
			free(data);
			break;
		default:
			if(file.CloseChunk()!=TRUE) return FALSE;
			break;
	   }
   }

 return TRUE;
}


#if defined(__FORWINDOWS__)
HBITMAP FASTCALL GBitmap::CreateDIBitmap(HDC hdc)
{
 BITMAPINFO *BitmapInfo;
 HBITMAP handle;
 WORD *pal;

 if(!ImageBuffer) return NULL;
 if((hdc=CreateCompatibleDC(NULL))==NULL) return NULL;
 if((BitmapInfo=(BITMAPINFO *)malloc(sizeof(BITMAPINFO)+256*sizeof(RGBQUAD)))==NULL) return NULL;
 pal=(WORD *)&BitmapInfo->bmiColors[0];

 BitmapInfo->bmiHeader.biSize=sizeof(BITMAPINFO)-sizeof(RGBQUAD);
 BitmapInfo->bmiHeader.biWidth=Width;
 BitmapInfo->bmiHeader.biHeight=-Height;
 BitmapInfo->bmiHeader.biPlanes=1;
 BitmapInfo->bmiHeader.biBitCount=(WORD)((Depth+7) & 0xf8);
 BitmapInfo->bmiHeader.biCompression=(Depth==15 || Depth==16) ? BI_BITFIELDS : BI_RGB;
 BitmapInfo->bmiHeader.biSizeImage=LineSize*Height;
 BitmapInfo->bmiHeader.biXPelsPerMeter=0;
 BitmapInfo->bmiHeader.biYPelsPerMeter=0;
 BitmapInfo->bmiHeader.biClrUsed=0;
 BitmapInfo->bmiHeader.biClrImportant=0;
 if(Depth==15)
   {
	((LONG *)pal)[0]=0x7c00;
	((LONG *)pal)[1]=0x03e0;
	((LONG *)pal)[2]=0x001f;
   }
 else if (Depth==16)
   {
	((LONG *)pal)[0]=0xf800;
	((LONG *)pal)[1]=0x07e0;
	((LONG *)pal)[2]=0x001f;
   }
 else if ((Depth<=8) && (Palette))
   {
	for (INT i=0;i<256;i++)
	   {
		BitmapInfo->bmiColors[i].rgbBlue=Palette->GetColour(i).B;
		BitmapInfo->bmiColors[i].rgbGreen=Palette->GetColour(i).G;
		BitmapInfo->bmiColors[i].rgbRed=Palette->GetColour(i).R;
		BitmapInfo->bmiColors[i].rgbReserved=0;
	   }
   }

 handle=::CreateDIBitmap(hdc,&BitmapInfo->bmiHeader,CBM_INIT,(void *)ImageBuffer,BitmapInfo,DIB_RGB_COLORS);

 free(BitmapInfo);
 DeleteDC(hdc);

 return handle;
}


HBITMAP FASTCALL GBitmap::CreateCompatibleBitmap(HDC hdc)
{
 BITMAPINFO *BitmapInfo;
 HBITMAP handle;
 WORD *pal;

 if(!ImageBuffer) return NULL;
 if((hdc=CreateCompatibleDC(NULL))==NULL) return NULL;
 if((BitmapInfo=(BITMAPINFO *)malloc(sizeof(BITMAPINFO)+256*sizeof(RGBQUAD)))==NULL) return NULL;
 pal=(WORD *)&BitmapInfo->bmiColors[0];

 BitmapInfo->bmiHeader.biSize=sizeof(BITMAPINFO)-sizeof(RGBQUAD);
 BitmapInfo->bmiHeader.biWidth=Width;
 BitmapInfo->bmiHeader.biHeight=-Height;
 BitmapInfo->bmiHeader.biPlanes=1;
 BitmapInfo->bmiHeader.biBitCount=(WORD)((Depth+7) & 0xf8);
 BitmapInfo->bmiHeader.biCompression=(Depth==15 || Depth==16) ? BI_BITFIELDS : BI_RGB;
 BitmapInfo->bmiHeader.biSizeImage=LineSize*Height;
 BitmapInfo->bmiHeader.biXPelsPerMeter=0;
 BitmapInfo->bmiHeader.biYPelsPerMeter=0;
 BitmapInfo->bmiHeader.biClrUsed=0;
 BitmapInfo->bmiHeader.biClrImportant=0;
 if(Depth==15)
   {
	((LONG *)pal)[0]=0x7c00;
	((LONG *)pal)[1]=0x03e0;
	((LONG *)pal)[2]=0x001f;
   }
 else if (Depth==16)
   {
	((LONG *)pal)[0]=0xf800;
	((LONG *)pal)[1]=0x07e0;
	((LONG *)pal)[2]=0x001f;
   }
 else if ((Depth<=8) && (Palette))
   {
	for (INT i=0;i<256;i++)
	   {
		BitmapInfo->bmiColors[i].rgbBlue=Palette->GetColour(i).B;
		BitmapInfo->bmiColors[i].rgbGreen=Palette->GetColour(i).G;
		BitmapInfo->bmiColors[i].rgbRed=Palette->GetColour(i).R;
		BitmapInfo->bmiColors[i].rgbReserved=0;
	   }
   }

 handle=::CreateCompatibleBitmap(hdc,Width,Height);
 SetDIBits(hdc,handle,0,Height,(void *)ImageBuffer,BitmapInfo,DIB_RGB_COLORS);

 free(BitmapInfo);
 DeleteDC(hdc);
 return handle;
}
#endif
