///////////////////////////////////////////////////////////////////////////////
//
// (c) 1997 by Marc van Shaney , aka Kaya Memisoglu
//
// This Source-Code was written by and is copyrighted by Kaya Memisoglu
// You may use the whole code or only parts of it in your own programs
// whether they are commercial or not. BUT you must give credits for these
// parts to me (Kaya Memisoglu  or  Marc van Shaney).
// I am not responsible for any damage or loss caused by this program, so
// if you success in erasing your harddisk with this code, then it is your
// own fault and you should not claim me to be responsible...
// I would be very pleased if you also sent me a postcard or even a letter
// if you can use this code. My address:
//
//        Kaya Memisoglu
//        Reichenberger Ring 50
//        63512 Hainburg
//        Germany
//
//

#include "../include/gomez.h"

GLogFile		GErrorLog;

#if defined(__FORWINDOWS__)
 HINSTANCE GWindowInstance;

 #if defined(__WINMAIN__)
  extern INT WINAPI WinMain(HINSTANCE ,HINSTANCE ,LPSTR ,INT );
  #undef WinMain
 #else
  extern void main(void);
 #endif

 #pragma argsused
 INT WINAPI WinMain(HINSTANCE hInst,HINSTANCE hPrevInst,LPSTR lpszCmdParam,INT nCmdShow)
 {
  static WNDCLASSEX WndClass;

  GErrorLog.Open();
  GWindowInstance=hInst;

  memset(&WndClass, 0, sizeof(WNDCLASSEX));
  WndClass.cbSize		    = sizeof(WNDCLASSEX);
  WndClass.style 		    = CS_HREDRAW | CS_VREDRAW | CS_OWNDC;
  WndClass.lpfnWndProc    	= GDisplay::WindowStartProc;
  WndClass.hInstance 	    = GWindowInstance;
  WndClass.hIcon 		    = LoadIcon(NULL, IDI_APPLICATION);
  WndClass.hCursor 	    	= LoadCursor(NULL, IDC_ARROW);
  WndClass.hbrBackground  	= (HBRUSH)(COLOR_WINDOW);
  WndClass.lpszMenuName 	= NULL;
  WndClass.lpszClassName  	= GDisplay::CLASSNAME;
  if (!RegisterClassEx(&WndClass)) return FALSE;

  WndClass.style 		    = 0;
  WndClass.lpfnWndProc    	= GSoundInput::WindowProc;
  WndClass.hInstance 	    = GWindowInstance;
  WndClass.hIcon 		    = NULL;
  WndClass.hCursor 	    	= NULL;
  WndClass.hbrBackground  	= NULL;
  WndClass.lpszMenuName 	= NULL;
  WndClass.lpszClassName  	= GMZ_SOUNDINPUT_CLASSNAME;
  if (!RegisterClassEx(&WndClass)) return FALSE;

  WndClass.style 		    = 0;
  WndClass.lpfnWndProc    	= GSoundOutput::WindowProc;
  WndClass.hInstance 	    = GWindowInstance;
  WndClass.hIcon 		    = NULL;
  WndClass.hCursor 	    	= NULL;
  WndClass.hbrBackground  	= NULL;
  WndClass.lpszMenuName 	= NULL;
  WndClass.lpszClassName  	= GMZ_SOUNDOUTPUT_CLASSNAME;
  if (!RegisterClassEx(&WndClass)) return FALSE;

  #if defined(__WINMAIN__)
   return _WinMain(hInst,hPrevInst,lpszCmdParam,nCmdShow);
  #else
   main();
   return TRUE;
  #endif
 }
#elif defined(__FORX11__)
 extern void main(void);
 #undef main
 void main(void)
 {
  GErrorLog.Open();
  XtToolkitInitialize();
  if((GDisplayHandle=XOpenDisplay(NULL))==NULL) return;
  GScreenHandle=DefaultScreen(GDisplayHandle);
  GDisplayVisual=DefaultVisual(GDisplayHandle,GScreenHandle);
  GRootWindow=RootWindow(GDisplayHandle,GScreenHandle);
  _main();
 }
#else
 extern void main(void);
 #undef main
 void main(void)
 {
  GErrorLog.Open();
  _main();
 }
#endif
