///////////////////////////////////////////////////////////////////////////////
//
// (c) 1997 by Marc van Shaney , aka Kaya Memisoglu
//
// This Source-Code was written by and is copyrighted by Kaya Memisoglu
// You may use the whole code or only parts of it in your own programs
// whether they are commercial or not. BUT you must give credits for these
// parts to me (Kaya Memisoglu  or  Marc van Shaney).
// I am not responsible for any damage or loss caused by this program, so
// if you success in erasing your harddisk with this code, then it is your
// own fault and you should not claim me to be responsible...
// I would be very pleased if you also sent me a postcard or even a letter
// if you can use this code. My address:
//
//        Kaya Memisoglu
//        Reichenberger Ring 50
//        63512 Hainburg
//        Germany
//
//


#include "../include/gomez.h"


BOOL FASTCALL GObject::Write(GFile &file,DWORD ctype)
{
 FileObjectHead fobj;

 GetName(fobj.Name);
 fobj.Magic=DWORD2LSB(Magic);
 fobj.Type=DWORD2LSB(Type);
 fobj.Flags=DWORD2LSB(Flags);

 if(file.CreateChunk(ctype)!=TRUE) return FALSE;
 if(file.WriteChunk(&fobj,sizeof(fobj))!=sizeof(fobj)) return FALSE;
 return file.CloseChunk();
}


BOOL FASTCALL GObject::Read(GFile &file)
{
 void *data;

 if(file.ReadChunk(&data)!=sizeof(FileObjectHead)) return FALSE;
 if(file.CloseChunk()!=TRUE) return FALSE;
 SetName(((FileObjectHead*)data)->Name);
 Magic=LSB2DWORD(((FileObjectHead*)data)->Magic);
 Flags=LSB2DWORD(((FileObjectHead*)data)->Flags);
 Type=LSB2DWORD(((FileObjectHead*)data)->Type);
 free(data);

 return TRUE;
}


BOOL FASTCALL GInfoObject::Write(GFile &file,DWORD ctype)
{
 DWORD ver=DWORD2LSB(Version);
 struct tm date=Date;
 FileInfoHead finfo;

 GObject::GetName(finfo.Name);
 finfo.Magic=DWORD2LSB(Magic);
 finfo.Type=DWORD2LSB(Type);
 finfo.Flags=DWORD2LSB(Flags);

 if(file.CreateMetaChunk(ctype)!=TRUE) return FALSE;
 if(file.CreateChunk(GFile::HEAD_TYPE)!=TRUE) return FALSE;
 if(file.WriteChunk(&finfo,sizeof(finfo))!=sizeof(finfo)) return FALSE;
 if(file.CloseChunk()!=TRUE) return FALSE;

 if (Name)
   {
	if(file.CreateChunk(NAME_TYPE)!=TRUE) return FALSE;
	if(file.WriteChunk(Name,strlen(Name)+1)!=(strlen(Name)+1)) return FALSE;
	if(file.CloseChunk()!=TRUE) return FALSE;
   }
 if (Creator)
   {
	if(file.CreateChunk(CREATOR_TYPE)!=TRUE) return FALSE;
	if(file.WriteChunk(Creator,strlen(Creator)+1)!=(strlen(Creator)+1)) return FALSE;
	if(file.CloseChunk()!=TRUE) return FALSE;
   }
 if (Program)
   {
	if(file.CreateChunk(PROGRAM_TYPE)!=TRUE) return FALSE;
	if(file.WriteChunk(Program,strlen(Program)+1)!=(strlen(Program)+1)) return FALSE;
	if(file.CloseChunk()!=TRUE) return FALSE;
   }
 if (Description)
   {
	if(file.CreateChunk(DESCRIPTION_TYPE)!=TRUE) return FALSE;
	if(file.WriteChunk(Description,strlen(Description)+1)!=(strlen(Description)+1)) return FALSE;
	if(file.CloseChunk()!=TRUE) return FALSE;
   }
 if (Copyright)
   {
	if(file.CreateChunk(COPYRIGHT_TYPE)!=TRUE) return FALSE;
	if(file.WriteChunk(Copyright,strlen(Copyright)+1)!=(strlen(Copyright)+1)) return FALSE;
	if(file.CloseChunk()!=TRUE) return FALSE;
   }

 if(file.CreateChunk(VERSION_TYPE)!=TRUE) return FALSE;
 if(file.WriteChunk(&ver,sizeof(ver))!=sizeof(ver)) return FALSE;
 if(file.CloseChunk()!=TRUE) return FALSE;

 if(file.CreateChunk(DATE_TYPE)!=TRUE) return FALSE;
 if(file.WriteChunk(&date,sizeof(date))!=sizeof(date)) return FALSE;
 if(file.CloseChunk()!=TRUE) return FALSE;

 return file.CloseMetaChunk();
}


BOOL FASTCALL GInfoObject::Read(GFile &file)
{
 void *data;
 DWORD type;

 Clear();

 while ((type=file.OpenChunk())!=GFile::END_TYPE)
   {
	switch (type)
	   {
		case GFile::HEAD_TYPE:
			if(file.ReadChunk(&data)!=sizeof(FileInfoHead)) return FALSE;
			if(file.CloseChunk()!=TRUE) return FALSE;
			GObject::SetName(((FileInfoHead*)data)->Name);
			Magic=LSB2DWORD(((FileInfoHead*)data)->Magic);
			Flags=LSB2DWORD(((FileInfoHead*)data)->Flags);
			Type=LSB2DWORD(((FileInfoHead*)data)->Type);
			free(data);
			break;
		case NAME_TYPE:
			if(file.ReadChunk(&data)==0) return FALSE;
			if(file.CloseChunk()!=TRUE) return FALSE;
			Name=(CHAR *)data;
			break;
		case COPYRIGHT_TYPE:
			if(file.ReadChunk(&data)==0) return FALSE;
			if(file.CloseChunk()!=TRUE) return FALSE;
			Copyright=(CHAR *)data;
			break;
		case PROGRAM_TYPE:
			if(file.ReadChunk(&data)==0) return FALSE;
			if(file.CloseChunk()!=TRUE) return FALSE;
			Program=(CHAR *)data;
			break;
		case CREATOR_TYPE:
			if(file.ReadChunk(&data)==0) return FALSE;
			if(file.CloseChunk()!=TRUE) return FALSE;
			Creator=(CHAR *)data;
			break;
		case DESCRIPTION_TYPE:
			if(file.ReadChunk(&data)==0) return FALSE;
			if(file.CloseChunk()!=TRUE) return FALSE;
			Description=(CHAR *)data;
			break;
		case VERSION_TYPE:
			if(file.ReadChunk(&data)!=sizeof(LONG)) return FALSE;
			if(file.CloseChunk()!=TRUE) return FALSE;
			Version=LSB2DWORD(*(LONG *)data);
			free(data);
			break;
		default:
			if(file.CloseChunk()!=TRUE) return FALSE;
			break;
	   }
   }

 return TRUE;
}
