///////////////////////////////////////////////////////////////////////////////
//
// (c) 1997 by Marc van Shaney , aka Kaya Memisoglu
//
// This Source-Code was written by and is copyrighted by Kaya Memisoglu
// You may use the whole code or only parts of it in your own programs
// whether they are commercial or not. BUT you must give credits for these
// parts to me (Kaya Memisoglu  or  Marc van Shaney).
// I am not responsible for any damage or loss caused by this program, so
// if you success in erasing your harddisk with this code, then it is your
// own fault and you should not claim me to be responsible...
// I would be very pleased if you also sent me a postcard or even a letter
// if you can use this code. My address:
//
//        Kaya Memisoglu
//        Reichenberger Ring 50
//        63512 Hainburg
//        Germany
//
//


#include "../include/gomez.h"


DWORD FASTCALL GColour::Convert(INT m)
{
 switch (m)
   {
	case GMZ_PAL_RGB15:
    	return ConvertRGB15();
	case GMZ_PAL_RGB16:
    	return ConvertRGB16();
	case GMZ_PAL_RGB18:
    	return ConvertRGB18();
	case GMZ_PAL_RGB24:
    	return ConvertRGB24();
	case GMZ_PAL_RGB32:
    	return ConvertRGB32();
	case GMZ_PAL_BGR15:
    	return ConvertBGR15();
	case GMZ_PAL_BGR16:
    	return ConvertBGR16();
	case GMZ_PAL_BGR18:
    	return ConvertBGR18();
	case GMZ_PAL_BGR24:
    	return ConvertBGR24();
	case GMZ_PAL_BGR32:
    	return ConvertBGR32();
	default:
    	return 0;
   }
}


DWORD* FASTCALL GPalette::UpdateTable(INT format)
{
 INT i;
 switch(format)
   {
	case GMZ_PAL_RGB15:
 		for(i=0;i<255;i++)
        	Table[i]=Colour[i].ConvertRGB15();
        TableFormat=format;
        Flags&=~GMZ_PAL_DIRTY;
        return Table;
	case GMZ_PAL_RGB16:
 		for(i=0;i<255;i++)
        	Table[i]=Colour[i].ConvertRGB16();
        TableFormat=format;
        Flags&=~GMZ_PAL_DIRTY;
        return Table;
	case GMZ_PAL_RGB18:
 		for(i=0;i<255;i++)
        	Table[i]=Colour[i].ConvertRGB18();
        TableFormat=format;
        Flags&=~GMZ_PAL_DIRTY;
        return Table;
	case GMZ_PAL_RGB24:
 		for(i=0;i<255;i++)
        	Table[i]=Colour[i].ConvertRGB24();
        TableFormat=format;
        Flags&=~GMZ_PAL_DIRTY;
        return Table;
	case GMZ_PAL_RGB32:
 		for(i=0;i<255;i++)
        	Table[i]=Colour[i].ConvertRGB32();
        TableFormat=format;
        Flags&=~GMZ_PAL_DIRTY;
        return Table;
	case GMZ_PAL_BGR15:
 		for(i=0;i<255;i++)
        	Table[i]=Colour[i].ConvertBGR15();
        TableFormat=format;
        Flags&=~GMZ_PAL_DIRTY;
        return Table;
	case GMZ_PAL_BGR16:
 		for(i=0;i<255;i++)
        	Table[i]=Colour[i].ConvertBGR16();
        TableFormat=format;
        Flags&=~GMZ_PAL_DIRTY;
        return Table;
	case GMZ_PAL_BGR18:
 		for(i=0;i<255;i++)
        	Table[i]=Colour[i].ConvertBGR18();
        TableFormat=format;
        Flags&=~GMZ_PAL_DIRTY;
        return Table;
	case GMZ_PAL_BGR24:
 		for(i=0;i<255;i++)
        	Table[i]=Colour[i].ConvertBGR24();
        TableFormat=format;
        Flags&=~GMZ_PAL_DIRTY;
        return Table;
	case GMZ_PAL_BGR32:
 		for(i=0;i<255;i++)
        	Table[i]=Colour[i].ConvertBGR32();
        TableFormat=format;
        Flags&=~GMZ_PAL_DIRTY;
        return Table;
	default:
    	return NULL;
   }
}


INT FASTCALL GPalette::ApproximateColour(GColour &col)
{
 INT i,bestcol;
 LONG bestdiff=1000000L,diff;

 for (i=0;i<256;i++)
	{
	 diff=labs((LONG)col.R-(LONG)Colour[i].R)+
	      labs((LONG)col.G-(LONG)Colour[i].G)+
	      labs((LONG)col.B-(LONG)Colour[i].B);
	 if (diff<bestdiff)
		{
		 bestdiff=diff;
		 bestcol=i;
		}
	}

 return bestcol;
}


BYTE* FASTCALL GPalette::ApproximatePalette(GPalette *pal)
{
 BYTE *table=(BYTE *)malloc(256);
 int i;

 for (i=0;i<256;i++)
	table[i]=(BYTE)ApproximateColour(pal->Colour[i]);

 return table;
}


BOOL FASTCALL GPalette::ImportPAL(char *fname)
{
 FILE *fhandle;
 INT i;
 BYTE buffer[3];

 if ((fhandle=fopen(fname,"rb"))==NULL) return FALSE;
 for(i=0;i<256;i++)
   {
	if(fread(buffer,3,1,fhandle)!=1) return FALSE;
	Colour[i].R=(BYTE)(buffer[0]<<2);
	Colour[i].G=(BYTE)(buffer[1]<<2);
	Colour[i].B=(BYTE)(buffer[2]<<2);
	Colour[i].A=0;
   }

 fclose(fhandle);
 return TRUE;
}


BOOL FASTCALL GPalette::ExportPAL(char *fname)
{
 INT i;
 FILE *fhandle;
 BYTE buffer[3];

 if ((fhandle=fopen(fname,"w+b"))==NULL) return FALSE;
 for(i=0;i<256;i++)
   {
	buffer[0]=(BYTE)(Colour[i].R>>2);
	buffer[0]=(BYTE)(Colour[i].G>>2);
	buffer[0]=(BYTE)(Colour[i].B>>2);
	if(fwrite(buffer,3,1,fhandle)!=1) return FALSE;
   }

 fclose(fhandle);
 return TRUE;
}


BOOL FASTCALL GPalette::ImportMAP(char *fname)
{
 FILE *fhandle;
 INT i,r,g,b;

 if ((fhandle=fopen(fname,"rb"))==NULL) return FALSE;
 for(i=0;i<256;i++)
   {
	fscanf(fhandle,"%d%d%d",&r,&g,&b);
	Colour[i].R=(BYTE)r;
	Colour[i].G=(BYTE)g;
	Colour[i].B=(BYTE)b;
	Colour[i].A=0;
   }

 fclose(fhandle);
 return TRUE;
}


BOOL FASTCALL GPalette::ExportMAP(char *fname)
{
 FILE *fhandle;
 INT i;

 if ((fhandle=fopen(fname,"wt"))==NULL) return FALSE;
 for(i=0;i<256;i++)
	fprintf(fhandle,"%d %d %d",(INT)Colour[i].R,(INT)Colour[i].G,(INT)Colour[i].B);

 fclose(fhandle);
 return TRUE;
}


void FASTCALL GPalette::Reset(void)
{
 INT i;

 for(i=0;i<64;i++)
   {
	Colour[i].R=(BYTE)(i<<2);
	Colour[i].G=
	Colour[i].B=
	Colour[i].A=0;
   }
 for(i=0;i<64;i++)
   {
	Colour[i+64].G=(BYTE)(i<<2);
	Colour[i+64].R=
	Colour[i+64].B=
	Colour[i+64].A=0;
   }
 for(i=0;i<64;i++)
   {
	Colour[i+128].B=(BYTE)(i<<2);
	Colour[i+128].G=
	Colour[i+128].R=
	Colour[i+128].A=0;
   }
 for(i=0;i<64;i++)
   {
	Colour[i+192].R=
	Colour[i+192].G=
	Colour[i+192].B=(BYTE)(i<<2);
	Colour[i+192].A=0;
   }
}


BOOL FASTCALL GPalette::Write(GFile &file,DWORD ctyp,INT first,INT count)
{
 FilePaletteHead fpal;

 GetName(fpal.Name);
 fpal.Flags=DWORD2LSB(Flags);
 fpal.Magic=DWORD2LSB(Magic);
 fpal.Type=DWORD2LSB(Type);
 fpal.FirstEntry=DWORD2LSB(first);
 fpal.EntryCount=DWORD2LSB(count);

 if(file.CreateMetaChunk(ctyp)!=TRUE) return FALSE;
 if(file.CreateChunk(GFile::HEAD_TYPE)!=TRUE) return FALSE;
 if(file.WriteChunk(&fpal,sizeof(fpal))!=sizeof(fpal)) return FALSE;
 if(file.CloseChunk()!=TRUE) return FALSE;

 if(file.CreateChunk(GFile::DATA_TYPE)!=TRUE) return FALSE;
 if(file.WriteChunk(&Colour[first],sizeof(GColour)*count)!=sizeof(GColour)*count) return FALSE;
 if(file.CloseChunk()!=TRUE) return FALSE;

 return file.CloseMetaChunk();
}


BOOL FASTCALL GPalette::Write(GFile &file,DWORD typ)
{
 return Write(file,typ,0,256);
}


BOOL FASTCALL GPalette::Read(GFile &file)
{
 void *data;
 DWORD type;
 INT first,count;

 while ((type=file.OpenChunk())!=GFile::END_TYPE)
   {
	switch (type)
	   {
		case GFile::HEAD_TYPE:
			if(file.ReadChunk(&data)!=sizeof(FilePaletteHead)) return FALSE;
			if(file.CloseChunk()!=TRUE) return FALSE;
			SetName(((FilePaletteHead *)data)->Name);
			Magic=LSB2DWORD(((FilePaletteHead *)data)->Magic);
			Type=LSB2DWORD(((FilePaletteHead *)data)->Type);
			Flags=LSB2DWORD(((FilePaletteHead *)data)->Flags);
			first=LSB2DWORD(((FilePaletteHead *)data)->FirstEntry);
			count=LSB2DWORD(((FilePaletteHead *)data)->EntryCount);
			free(data);
			break;
		case GFile::DATA_TYPE:
			if(file.ReadChunk(&data)==0) return FALSE;
			if(file.CloseChunk()!=TRUE) return FALSE;
			memcpy(&Colour[first],data,sizeof(GColour)*count);
            Flags|=GMZ_PAL_DIRTY;
			free(data);
			break;
		default:
			if(file.CloseChunk()!=TRUE) return FALSE;
			break;
	   }
   }

 return TRUE;
}
