///////////////////////////////////////////////////////////////////////////////
//
// (c) 1997 by Marc van Shaney , aka Kaya Memisoglu
//
// This Source-Code was written by and is copyrighted by Kaya Memisoglu
// You may use the whole code or only parts of it in your own programs
// whether they are commercial or not. BUT you must give credits for these
// parts to me (Kaya Memisoglu  or  Marc van Shaney).
// I am not responsible for any damage or loss caused by this program, so
// if you success in erasing your harddisk with this code, then it is your
// own fault and you should not claim me to be responsible...
// I would be very pleased if you also sent me a postcard or even a letter
// if you can use this code. My address:
//
//        Kaya Memisoglu
//        Reichenberger Ring 50
//        63512 Hainburg
//        Germany
//
//

#include "../include/gomez.h"

BOOL FASTCALL GSample::Alloc(LONG len,LONG rate,INT dep,INT chan)
{
 Length=len;
 Rate=rate;
 Depth=dep;
 Channels=chan;
 Flags=0;
 if ((Data=malloc(len*chan*((dep+7)>>3)))==NULL)
	return FALSE;
 return TRUE;
}

BOOL FASTCALL GSample::Free(void)
{
 if (Data)
	free(Data);
 Data=NULL;
 Flags=0;
 return TRUE;
}

BOOL FASTCALL GSample::ImportWAVE(char *fname)
{
 FILE *fhandle;
 WAVE_Header whead;

 Free();
 SetName(fname);

 if ((fhandle=fopen(fname,"rb"))==NULL) return FALSE;
 if (fread(&whead,sizeof(whead),1,fhandle)!=1) return FALSE;

 if ((whead.FileMagic!=DWORD2LSB(GMZ_RIFF_MAGIC)) ||
	 (whead.FileType!=DWORD2LSB(GMZ_WAVE_MAGIC)) ||
	 (whead.FormatMagic!=DWORD2LSB(GMZ_fmt_MAGIC)) ||
	 (whead.DataMagic!=DWORD2LSB(GMZ_data_MAGIC)))
	return (fclose(fhandle),FALSE);

 Channels=LSB2WORD(whead.Channels);
 Depth=LSB2WORD(whead.SampleDepth);
 Rate=LSB2DWORD(whead.SampleRate);
 Length=LSB2DWORD(whead.DataSize);

 if ((Data=malloc(LSB2DWORD(Length)))==NULL) return (fclose(fhandle),FALSE);
 if (fread(Data,Length,1,fhandle)!=1) return (fclose(fhandle),FALSE);

 Length/=Channels*((Depth+7)>>3);

 fclose(fhandle);
 return TRUE;
}

BOOL FASTCALL GSample::Write(GFile &file,DWORD ctype)
{
 FileSampleHead fsmp;

 GetName(fsmp.Name);
 fsmp.Magic=DWORD2LSB(Magic);
 fsmp.Type=DWORD2LSB(Type);
 fsmp.Flags=DWORD2LSB(Flags);
 fsmp.Rate=DWORD2LSB(Rate);
 fsmp.Length=DWORD2LSB(Length);
 fsmp.Channels=(BYTE)Channels;
 fsmp.Depth=(BYTE)Depth;

 if(file.CreateMetaChunk(ctype)!=TRUE) return FALSE;
 if(file.CreateChunk(GFile::HEAD_TYPE)!=TRUE) return FALSE;
 if(file.WriteChunk(&fsmp,sizeof(fsmp))!=sizeof(fsmp)) return FALSE;
 if(file.CloseChunk()!=TRUE) return FALSE;

 if (Data)
   {
	if(file.CreateChunk(GFile::DATA_TYPE)!=TRUE) return FALSE;
	if(file.WriteChunk(Data,GetSize())!=GetSize()) return FALSE;
	if(file.CloseChunk()!=TRUE) return FALSE;
   }

 return file.CloseMetaChunk();
}

BOOL FASTCALL GSample::Read(GFile &file)
{
 void *data;
 DWORD type;

 Free();

 while ((type=file.OpenChunk())!=GFile::END_TYPE)
   {
	switch (type)
	   {
		case GFile::HEAD_TYPE:
			if(file.ReadChunk(&data)!=sizeof(FileSampleHead)) return FALSE;
			if(file.CloseChunk()!=TRUE) return FALSE;
			SetName(((FileSampleHead *)data)->Name);
			Magic=LSB2DWORD(((FileSampleHead *)data)->Magic);
			Type=LSB2DWORD(((FileSampleHead *)data)->Type);
			Flags=LSB2DWORD(((FileSampleHead *)data)->Flags);
			Length=LSB2DWORD(((FileSampleHead *)data)->Length);
			Rate=LSB2DWORD(((FileSampleHead *)data)->Rate);
			Depth=((FileSampleHead *)data)->Depth;
			Channels=((FileSampleHead *)data)->Channels;
			free(data);
			break;
		case GFile::DATA_TYPE:
			if(file.ReadChunk(&data)==0) return FALSE;
			if(file.CloseChunk()!=TRUE) return FALSE;
			Data=(PTR)data;
			break;
		default:
			if(file.CloseChunk()!=TRUE) return FALSE;
			break;
	   }
   }

 return TRUE;
}



BOOL FASTCALL GSoundOutput::Open(GSample *s)
{
 return Open(s->Rate,s->Depth,s->Channels);
}

BOOL FASTCALL GSoundOutput::Open(LONG rate,INT depth,INT chans)
{
 #if defined(__FORWINDOWS__)
  WAVEFORMATEX wfmt;

  wfmt.wFormatTag=WAVE_FORMAT_PCM;
  wfmt.nChannels=(WORD)chans;
  wfmt.nSamplesPerSec=rate;
  wfmt.nAvgBytesPerSec=rate*chans*((depth+7)>>3);
  wfmt.nBlockAlign=(WORD)(chans*((depth+7)>>3));
  wfmt.wBitsPerSample=(WORD)depth;
  wfmt.cbSize=0;

  WindowHandle=CreateWindowEx(0,GMZ_SOUNDOUTPUT_CLASSNAME,"SoundOutput Handler",
								WS_DISABLED,0,0,0,0,NULL,NULL,
								GWindowInstance,NULL);
  SetWindowLong(WindowHandle,GWL_USERDATA,(LONG)this);

  if (waveOutOpen(&DeviceHandle,WAVE_MAPPER,&wfmt,(DWORD)WindowHandle,NULL,
		CALLBACK_WINDOW)!=MMSYSERR_NOERROR) return FALSE;
  return TRUE;
 #else
  return FALSE;
 #endif
}

BOOL FASTCALL GSoundOutput::Close(void)
{
 #if defined(__FORWINDOWS__)
  if (waveOutClose(DeviceHandle)!=MMSYSERR_NOERROR) return FALSE;
  if (!DestroyWindow(WindowHandle)) return FALSE;
  (PTR)WindowHandle=(PTR)DeviceHandle=NULL;
  return TRUE;
 #else
  return FALSE
 #endif
}

BOOL FASTCALL GSoundOutput::Stop(void)
{
 #if defined(__FORWINDOWS__)
  if (waveOutReset(DeviceHandle)!=MMSYSERR_NOERROR) return FALSE;
  return TRUE;
 #else
  return FALSE
 #endif
}

BOOL FASTCALL GSoundOutput::Pause(void)
{
 #if defined(__FORWINDOWS__)
  if (waveOutPause(DeviceHandle)!=MMSYSERR_NOERROR) return FALSE;
  return TRUE;
 #else
  return FALSE
 #endif
}

BOOL FASTCALL GSoundOutput::Continue(void)
{
 #if defined(__FORWINDOWS__)
  if (waveOutRestart(DeviceHandle)!=MMSYSERR_NOERROR) return FALSE;
  return TRUE;
 #else
  return FALSE
 #endif
}

BOOL FASTCALL GSoundOutput::AddBuffer(GSample *smp)
{
 #if defined(__FORWINDOWS__)
  smp->WaveHeader.lpData=(CHAR *)smp->Data;
  smp->WaveHeader.dwBufferLength=smp->GetSize();
  smp->WaveHeader.dwBytesRecorded=0;
  smp->WaveHeader.dwUser=(DWORD)smp;
  smp->WaveHeader.dwFlags=0;
  smp->WaveHeader.dwLoops=1;
  if(waveOutPrepareHeader(DeviceHandle,&smp->WaveHeader,sizeof(smp->WaveHeader))!=MMSYSERR_NOERROR) return FALSE;
  if(waveOutWrite(DeviceHandle,&smp->WaveHeader,sizeof(smp->WaveHeader))!=MMSYSERR_NOERROR) return FALSE;
  smp->Flags|=GSample::PREPARED | GSample::QUEUED;
  smp->Flags&=~GSample::DONE;
  return TRUE;
 #else
  return FALSE
 #endif
}

INT FASTCALL GSoundOutput::GetVolume(void)
{
 #if defined(__FORWINDOWS__)
  DWORD vol;
  waveOutGetVolume(DeviceHandle,&vol);
  return (INT)vol;
 #else
  return 0;
 #endif
}

INT FASTCALL GSoundOutput::SetVolume(INT vol)
{
 #if defined(__FORWINDOWS__)
  waveOutSetVolume(DeviceHandle,(DWORD)vol);
  return (INT)vol;
 #else
  return 0;
 #endif
}

DOUBLE FASTCALL GSoundOutput::SetRate(DOUBLE r)
{
 #if defined(__FORWINDOWS__)
  waveOutSetPlaybackRate(DeviceHandle,(DWORD)ldexp(r,16));
  return r;
 #else
  return 0;
 #endif
}

DOUBLE FASTCALL GSoundOutput::GetRate(void)
{
 #if defined(__FORWINDOWS__)
  DWORD r;
  waveOutGetPlaybackRate(DeviceHandle,&r);
  return ldexp((DOUBLE)r,-16);
 #else
  return 0;
 #endif
}

DOUBLE FASTCALL GSoundOutput::SetPitch(DOUBLE r)
{
 #if defined(__FORWINDOWS__)
  waveOutSetPitch(DeviceHandle,(DWORD)ldexp(r,16));
  return r;
 #else
  return 0;
 #endif
}

DOUBLE FASTCALL GSoundOutput::GetPitch(void)
{
 #if defined(__FORWINDOWS__)
  DWORD r;
  waveOutGetPitch(DeviceHandle,&r);
  return ldexp((DOUBLE)r,-16);
 #else
  return 0;
 #endif
}

#if defined(__FORWINDOWS__)
LRESULT CALLBACK GSoundOutput::WindowProc(HWND hwnd,UINT msg,WPARAM wParam,LPARAM lParam)
{
 GSoundOutput *strm=(GSoundOutput *)GetWindowLong(hwnd,GWL_USERDATA);

 switch (msg)
   {
	case MM_WOM_DONE:
		waveInUnprepareHeader((HWAVEIN)wParam,(WAVEHDR *)lParam,sizeof(WAVEHDR));
		((GSample *)((WAVEHDR *)lParam)->dwUser)->Flags|=GSample::DONE;
		((GSample *)((WAVEHDR *)lParam)->dwUser)->Flags&=~(GSample::PREPARED | GSample::QUEUED);
		strm->Handler(GMZ_SOUND_DONE,strm,(GSample *)((WAVEHDR *)lParam)->dwUser);
		return 0;
	case MM_WOM_OPEN:
		strm->Handler(GMZ_SOUND_OPEN,strm,NULL);
		return 0;
	case MM_WOM_CLOSE:
		strm->Handler(GMZ_SOUND_CLOSE,strm,NULL);
		return 0;
	default:
		return DefWindowProc(hwnd,msg,wParam,lParam);
   }
}
#endif



BOOL FASTCALL GSoundInput::Open(GSample *s)
{
 return Open(s->Rate,s->Depth,s->Channels);
}

BOOL FASTCALL GSoundInput::Open(LONG rate,INT depth,INT chans)
{
 #if defined(__FORWINDOWS__)
  WAVEFORMATEX wfmt;

  wfmt.wFormatTag=WAVE_FORMAT_PCM;
  wfmt.nChannels=(WORD)chans;
  wfmt.nSamplesPerSec=rate;
  wfmt.nAvgBytesPerSec=rate*chans*((depth+7)>>3);
  wfmt.nBlockAlign=(WORD)(chans*((depth+7)>>3));
  wfmt.wBitsPerSample=(WORD)depth;
  wfmt.cbSize=0;

  WindowHandle=CreateWindowEx(0,GMZ_SOUNDINPUT_CLASSNAME,"SoundInput Handler",
								WS_DISABLED,0,0,0,0,NULL,NULL,
								GWindowInstance,NULL);
  SetWindowLong(WindowHandle,GWL_USERDATA,(LONG)this);

  if (waveInOpen(&DeviceHandle,WAVE_MAPPER,&wfmt,(DWORD)WindowHandle,NULL,
		CALLBACK_WINDOW)!=MMSYSERR_NOERROR) return FALSE;
  return TRUE;
 #else
  return FALSE;
 #endif
}

BOOL FASTCALL GSoundInput::Close(void)
{
 #if defined(__FORWINDOWS__)
  if (waveInClose(DeviceHandle)!=MMSYSERR_NOERROR) return FALSE;
  if (!DestroyWindow(WindowHandle)) return FALSE;
  (PTR)WindowHandle=(PTR)DeviceHandle=NULL;
  return TRUE;
 #else
  return FALSE
 #endif
}

BOOL FASTCALL GSoundInput::Stop(void)
{
 #if defined(__FORWINDOWS__)
  if (waveInReset(DeviceHandle)!=MMSYSERR_NOERROR) return FALSE;
  return TRUE;
 #else
  return FALSE
 #endif
}

BOOL FASTCALL GSoundInput::Pause(void)
{
 #if defined(__FORWINDOWS__)
  if (waveInStop(DeviceHandle)!=MMSYSERR_NOERROR) return FALSE;
  return TRUE;
 #else
  return FALSE
 #endif
}

BOOL FASTCALL GSoundInput::Continue(void)
{
 #if defined(__FORWINDOWS__)
  if (waveInStart(DeviceHandle)!=MMSYSERR_NOERROR) return FALSE;
  return TRUE;
 #else
  return FALSE
 #endif
}

BOOL FASTCALL GSoundInput::AddBuffer(GSample *smp)
{
 #if defined(__FORWINDOWS__)
  smp->WaveHeader.lpData=(CHAR *)smp->Data;
  smp->WaveHeader.dwBufferLength=smp->GetSize();
  smp->WaveHeader.dwBytesRecorded=0;
  smp->WaveHeader.dwUser=(DWORD)smp;
  smp->WaveHeader.dwFlags=0;
  smp->WaveHeader.dwLoops=1;
  if(waveInPrepareHeader(DeviceHandle,&smp->WaveHeader,sizeof(smp->WaveHeader))!=MMSYSERR_NOERROR) return FALSE;
  if(waveInAddBuffer(DeviceHandle,&smp->WaveHeader,sizeof(smp->WaveHeader))!=MMSYSERR_NOERROR) return FALSE;
  smp->Flags|=GSample::PREPARED | GSample::QUEUED;
  smp->Flags&=~GSample::DONE;
  if(waveInStart(DeviceHandle)!=MMSYSERR_NOERROR) return FALSE;
  return TRUE;
 #else
  return FALSE
 #endif
}

#if defined(__FORWINDOWS__)
LRESULT CALLBACK GSoundInput::WindowProc(HWND hwnd,UINT msg,WPARAM wParam,LPARAM lParam)
{
 GSoundInput *strm=(GSoundInput *)GetWindowLong(hwnd,GWL_USERDATA);

 switch (msg)
   {
	case MM_WIM_DATA:
		waveInUnprepareHeader((HWAVEIN)wParam,(WAVEHDR *)lParam,sizeof(WAVEHDR));
		((GSample *)((WAVEHDR *)lParam)->dwUser)->Flags|=GSample::DONE;
		((GSample *)((WAVEHDR *)lParam)->dwUser)->Flags&=~(GSample::PREPARED | GSample::QUEUED);
		strm->Handler(GMZ_SOUND_DONE,strm,(GSample *)((WAVEHDR *)lParam)->dwUser);
		return 0;
	case MM_WIM_OPEN:
		strm->Handler(GMZ_SOUND_OPEN,strm,NULL);
		return 0;
	case MM_WIM_CLOSE:
		strm->Handler(GMZ_SOUND_CLOSE,strm,NULL);
		return 0;
	default:
		return DefWindowProc(hwnd,msg,wParam,lParam);
   }
}
#endif




