///////////////////////////////////////////////////////////////////////////////
//
// (c) 1997 by Marc van Shaney , aka Kaya Memisoglu
//
// This Source-Code was written by and is copyrighted by Kaya Memisoglu
// You may use the whole code or only parts of it in your own programs
// whether they are commercial or not. BUT you must give credits for these
// parts to me (Kaya Memisoglu  or  Marc van Shaney).
// I am not responsible for any damage or loss caused by this program, so
// if you success in erasing your harddisk with this code, then it is your
// own fault and you should not claim me to be responsible...
// I would be very pleased if you also sent me a postcard or even a letter
// if you can use this code. My address:
//
//        Kaya Memisoglu
//        Reichenberger Ring 50
//        63512 Hainburg
//        Germany
//
//


#include "../include/gvepro.h"



BOOL FASTCALL GBumpMap::MakeBump(GPalette *pal)
{
 WORD *newmap;
 INT i,j;

 if(!ImageBuffer) return FALSE;
 Rescale(GVE_TEXTURE_WIDTH,GVE_TEXTURE_HEIGHT);
 if(pal==NULL) pal=Palette;

 if ((newmap=(WORD *)malloc(Width*Height<<1))==NULL) return FALSE;

 for(i=0;i<Height;i++)
	for(j=0;j<Width;j++)
		newmap[i*Width+j]=0;

 FreePalette();
 free(ImageBuffer);
 ImageBuffer=(GPixel *)newmap;
 return TRUE;
}


BOOL FASTCALL GLightMap::MakeLight(GPalette *pal)
{
 BYTE *newmap,*oldmap=(BYTE *)ImageBuffer;
 INT i,j;
 BYTE xtable[256];

 if(!ImageBuffer) return FALSE;
 if(!pal) pal=Palette;
 Rescale(GVE_TEXTURE_WIDTH,GVE_TEXTURE_HEIGHT);

 if ((newmap=(BYTE *)malloc(Width*Height))==NULL) return FALSE;

 for (i=0;i<256;i++)
	xtable[i]=(BYTE)(pal->GetColour(i).Intensity()/4);

 for(i=0;i<Height;i++)
	for(j=0;j<Width;j++)
		newmap[i*Width+j]=xtable[oldmap[i*Width+j]];

 FreePalette();
 free(ImageBuffer);
 ImageBuffer=(GPixel *)newmap;
 return TRUE;
}


BOOL FASTCALL GTextureMap::MakeTexture(GPalette *pal)
{
 if (pal)
	 Remap(pal);
 Rescale(GVE_TEXTURE_WIDTH,GVE_TEXTURE_HEIGHT);
 return TRUE;
}

