///////////////////////////////////////////////////////////////////////////////
//
// (c) 1997 by Marc van Shaney , aka Kaya Memisoglu
//
// This Source-Code was written by and is copyrighted by Kaya Memisoglu
// You may use the whole code or only parts of it in your own programs
// whether they are commercial or not. BUT you must give credits for these
// parts to me (Kaya Memisoglu  or  Marc van Shaney).
// I am not responsible for any damage or loss caused by this program, so
// if you success in erasing your harddisk with this code, then it is your
// own fault and you should not claim me to be responsible...
// I would be very pleased if you also sent me a postcard or even a letter
// if you can use this code. My address:
//
//        Kaya Memisoglu
//        Reichenberger Ring 50
//        63512 Hainburg
//        Germany
//
//

#include "../include/gvepro.h"


CHAR GVectorSystem::BuildInfo[]="Gomez Vector Engine/Pro  1.0\n"
				 "(C) 1998 by Marc van Shaney\n"
			     "         a.k.a. Kaya Memisoglu\n\n"
				 "Build Info:\n"
#if defined __FORWINDOWS__
 " - PLATFORM: Windows\n"
#elif defined __FORDOS__
 " - PLATFORM: DOS\n"
#elif defined __FORUNIX__
 " - PLATFORM: UNIX\n"
#else
 " - PLATFORM: Unknown\n"
#endif
#if defined GVE_PRO
 " - GVE/pro Version\n"
#endif
#if defined GVE_FIXED_MATH
 " - Fixed Point mathematics is in use\n"
#elif defined GVE_FLOAT_MATH
 " - Floating Point mathematics is in use\n"
#endif
#if defined __USEASM__
 " - Assembler will be used\n"
#endif
#if defined GVE_CULL_FIRST
 " - Culling before vertex-transformation\n"
#elif defined GVE_CULL_AFTER
 " - Culling after vertex-transformation\n"
#endif
#if defined GVE_SORT_LIST
 " - Using a sorting list for painters algorithm\n"
#elif defined GVE_SORT_TREE
 " - Using a binary tree for painters algorithm\n"
#elif defined GVE_SORT_HEAP
 " - Using a heap for painters algorithm\n"
#endif
#if defined GVE_ZBUFFER
 " - Using z-buffering technique\n"
#endif
#if defined GVE_MULTI_LIGHTS
 " - Multiple light sources enabled\n"
#endif
#if defined GVE_VIDEO
 " - Video texture support enabled\n"
#endif
#if defined GVE_SPHERICAL_CHROME
 " - Spherical chrome mapping via acos/asin enabled\n"
#endif
#if defined GVE_VERTEX_TEXTURE_UV
 " - Texture UV coordinates stored in vertices\n"
#endif
#if defined GVE_BOUNDING_BOX
 " - Bounding boxes for trivial object rejecting enabled\n"
#endif
#if defined GVE_TRIVIAL_REJECT
 " - Trivial rejecting for polygons enabled\n"
#endif
#if defined GVE_WALK_PREORDER
 " - Preorder will be used for traversing the object tree\n"
#elif defined GVE_WALK_POSTORDER
 " - Postorder will be used for traversing the object tree\n"
#endif
#if defined GVE_RASTER8
 " - 8 Bit Raster Code enabled\n"
#endif
#if defined GVE_RASTER16
 " - 15/16 Bit Raster Code enabled\n"
#endif
#if defined GVE_RASTER24
 " - 24 Bit Raster Code enabled\n"
#endif
#if defined GVE_RASTER32
 " - 32 Bit Raster Code enabled\n"
#endif
#if defined GVE_PROFILER
 " - Profiler enabled\n"
 #ifndef GVE_EXACT_FRAME_SPEED
  " - 16 frames will be used for fps calculation\n"
 #else
  " - 1 frame will be used for fps calculation\n"
 #endif
#endif
#if defined GVE_DEBUG
 " - Debugger enabled\n"
#endif
;


MATH 	GVectorSystem::SinusTable[GVE_COSINE_TABLE_SIZE+GVE_COSINE_TABLE_SIZE/4];
#if defined GVE_SPHERICAL_CHROME
LONG 	GVectorSystem::ASinusTable[GVE_ASINE_TABLE_SIZE+1];
#endif


//
// Now follow the error messages of the vector system
//
GVectorSystem::GRasterIndex GVectorSystem::RasterIndex[]={
	{GVE_SHAD_NOTHING				,0L},
	{GVE_SHAD_POINT					,GVE_SF_VERTEX},
	{GVE_SHAD_WIREFRAME				,GVE_SF_WIRE},
	{GVE_SHAD_SOFT_WIRE				,GVE_SF_WIRE | GVE_SF_SOFT},
	{GVE_SHAD_GLASS_WIRE			,GVE_SF_WIRE | GVE_SF_GLASS},
	{GVE_SHAD_FILLED				,GVE_SF_FILLED},
	{GVE_SHAD_LAMBERT				,GVE_SF_FILLED | GVE_SF_LAMBERT},
	{GVE_SHAD_GOURAUD				,GVE_SF_FILLED | GVE_SF_GOURAUD},
	{GVE_SHAD_PHONG					,GVE_SF_FILLED | GVE_SF_PHONG},
	{GVE_SHAD_GLASS					,GVE_SF_FILLED | GVE_SF_GLASS},
	{GVE_SHAD_LAMBERT_GLASS			,GVE_SF_FILLED | GVE_SF_GLASS | GVE_SF_LAMBERT},
	{GVE_SHAD_GOURAUD_GLASS			,GVE_SF_FILLED | GVE_SF_GLASS | GVE_SF_GOURAUD},
	{GVE_SHAD_PHONG_GLASS			,GVE_SF_FILLED | GVE_SF_GLASS | GVE_SF_PHONG},
	{GVE_SHAD_TEXTURE				,GVE_SF_TEXTURE},
	{GVE_SHAD_TEXTURE_LAMBERT   	,GVE_SF_TEXTURE | GVE_SF_LAMBERT},
	{GVE_SHAD_TEXTURE_GOURAUD		,GVE_SF_TEXTURE | GVE_SF_GOURAUD},
	{GVE_SHAD_TEXTURE_PHONG			,GVE_SF_TEXTURE | GVE_SF_PHONG},
	{GVE_SHAD_TEXTURE_GLASS			,GVE_SF_TEXTURE | GVE_SF_GLASS},
	{GVE_SHAD_TEXTURE_LIGHTMAP		,GVE_SF_TEXTURE | GVE_SF_LIGHTMAP},
	{GVE_SHAD_TEXTURE_CHROME		,GVE_SF_TEXTURE | GVE_SF_CHROME},
	{GVE_SHAD_TEXTURE_BUMP_CHROME  	,GVE_SF_TEXTURE | GVE_SF_BUMP | GVE_SF_CHROME},
	{GVE_SHAD_TEXTURE_BUMP_LIGHTMAP	,GVE_SF_TEXTURE | GVE_SF_BUMP | GVE_SF_LIGHTMAP},
	{GVE_SHAD_PTEXTURE				,GVE_SF_TEXTURE | GVE_SF_PERSPECTIVE},
	{GVE_SHAD_PTEXTURE_LAMBERT   	,GVE_SF_TEXTURE | GVE_SF_PERSPECTIVE | GVE_SF_LAMBERT},
	{GVE_SHAD_PTEXTURE_GOURAUD		,GVE_SF_TEXTURE | GVE_SF_PERSPECTIVE | GVE_SF_GOURAUD},
	{GVE_SHAD_PTEXTURE_PHONG	   	,GVE_SF_TEXTURE | GVE_SF_PERSPECTIVE | GVE_SF_PHONG},
	{GVE_SHAD_PTEXTURE_GLASS	   	,GVE_SF_TEXTURE | GVE_SF_PERSPECTIVE | GVE_SF_GLASS},
	{GVE_SHAD_PTEXTURE_LIGHTMAP		,GVE_SF_TEXTURE | GVE_SF_PERSPECTIVE | GVE_SF_LIGHTMAP},
	{GVE_SHAD_PTEXTURE_CHROME		,GVE_SF_TEXTURE | GVE_SF_PERSPECTIVE | GVE_SF_CHROME},
	{GVE_SHAD_PTEXTURE_BUMP_CHROME 	,GVE_SF_TEXTURE | GVE_SF_PERSPECTIVE | GVE_SF_BUMP | GVE_SF_CHROME},
	{GVE_SHAD_PTEXTURE_BUMP_LIGHTMAP,GVE_SF_TEXTURE | GVE_SF_PERSPECTIVE | GVE_SF_BUMP | GVE_SF_LIGHTMAP},
	{GVE_SHAD_CHROME				,GVE_SF_CHROME},
	{GVE_SHAD_CHROME_LAMBERT		,GVE_SF_CHROME | GVE_SF_LAMBERT},
	{GVE_SHAD_CHROME_GOURAUD		,GVE_SF_CHROME | GVE_SF_GOURAUD},
	{GVE_SHAD_CHROME_PHONG			,GVE_SF_CHROME | GVE_SF_PHONG},
	{GVE_SHAD_CHROME_GLASS			,GVE_SF_CHROME | GVE_SF_GLASS},
	{GVE_SHAD_BUMP					,GVE_SF_BUMP},
	{GVE_SHAD_BUMP_LAMBERT			,GVE_SF_BUMP | GVE_SF_LAMBERT},
	{GVE_SHAD_BUMP_GOURAUD			,GVE_SF_BUMP | GVE_SF_GOURAUD},
	{GVE_SHAD_BUMP_PHONG			,GVE_SF_BUMP | GVE_SF_PHONG},
	{GVE_SHAD_BUMP_GLASS			,GVE_SF_BUMP | GVE_SF_GLASS},
	{GVE_SHAD_BUMP_CHROME			,GVE_SF_CHROME | GVE_SF_BUMP},
	{GVE_SHAD_BUMP_LIGHTMAP			,GVE_SF_BUMP | GVE_SF_LIGHTMAP},
	{GVE_SHAD_BUMP_CHROME			,GVE_SF_BUMP | GVE_SF_CHROME},
	{GVE_SHAD_CARVA					,GVE_SF_CARVA},
	{GVE_SHAD_CARVA_LAMBERT			,GVE_SF_CARVA | GVE_SF_LAMBERT},
	{GVE_SHAD_CARVA_GOURAUD			,GVE_SF_CARVA | GVE_SF_GOURAUD},
	{GVE_SHAD_CARVA_PHONG			,GVE_SF_CARVA | GVE_SF_PHONG},
	{GVE_SHAD_CARVA_GLASS			,GVE_SF_CARVA | GVE_SF_GLASS},
	{GVE_SHAD_CARVA_LAMBERT_GLASS	,GVE_SF_CARVA | GVE_SF_LAMBERT | GVE_SF_GLASS},
	{GVE_SHAD_CARVA_GOURAUD_GLASS	,GVE_SF_CARVA | GVE_SF_GOURAUD | GVE_SF_GLASS},
	{GVE_SHAD_CARVA_PHONG_GLASS		,GVE_SF_CARVA | GVE_SF_PHONG | GVE_SF_GLASS}
   };



//
// Now starts the real system
//
BOOL FASTCALL GVectorSystem::Init(GRasterEngine *engine)
{
 DWORD			rflags;
 INT			i;

 RasterEngine=engine;
 if (RasterEngine->Init()!=TRUE)	return FALSE;

 for (i=0;i<(GVE_COSINE_TABLE_SIZE+GVE_COSINE_TABLE_SIZE/4);i++)
	SinusTable[i]=DOUBLE2MATH(sin((DOUBLE)M_2_PI*(DOUBLE)i/(DOUBLE)GVE_COSINE_TABLE_SIZE),GVE_COSINE_SHIFT);
 #ifdef GVE_SPHERICAL_CHROME
 for (i=0;i<=GVE_ASINE_TABLE_SIZE;i++)
	ASinusTable[i]=(LONG)(asin((DOUBLE)(i-GVE_ASINE_TABLE_SIZE/2)/(DOUBLE)(GVE_ASINE_TABLE_SIZE/2))/M_PI*(DOUBLE)(1<<GVE_ASINE_SHIFT));
 #endif

 #if defined(GVE_SORT_LIST) || defined(GVE_SORT_HEAP) || defined(GVE_SORT_TREE)
 if(!OrderList.Alloc(GVE_MAX_VISIBLE_POLYS)) return FALSE;
 #endif

 return TRUE;
}


BOOL FASTCALL GVectorSystem::Exit(void)
{
 #if defined(GVE_ORDER_TREE) || defined(GVE_ORDER_HEAP) || defined(GVE_ORDER_LIST)
 if (!OrderList.Free()) return FALSE;
 #endif

 if (RasterEngine->Exit()!=TRUE) return FALSE;

 return TRUE;
}


CHAR* FASTCALL GVectorSystem::GetShadingName(INT s,CHAR *b)
{
 int i;
 if (!b) return NULL;
 b[0]=0;

 for(i=0;i<sizeof(RasterIndex)/sizeof(GRasterIndex);i++)
	if (RasterIndex[i].Type==s)
	   {
		if (RasterIndex[i].Flags & GVE_SF_VERTEX)
			strcat(b,"Vertices ");
		if (RasterIndex[i].Flags & GVE_SF_WIRE)
			strcat(b,"Wireframe ");
		if (RasterIndex[i].Flags & GVE_SF_FILLED)
			strcat(b,"Filled ");
		if (RasterIndex[i].Flags & GVE_SF_TEXTURE)
			strcat(b,"Texture ");
		if (RasterIndex[i].Flags & GVE_SF_PERSPECTIVE)
			strcat(b,"(pers.) ");
		if (RasterIndex[i].Flags & GVE_SF_BUMP)
			strcat(b,"Bump ");
		if (RasterIndex[i].Flags & GVE_SF_CHROME)
			strcat(b,"Chrome ");
		if (RasterIndex[i].Flags & GVE_SF_LIGHTMAP)
			strcat(b,"Lightmap ");
		if (RasterIndex[i].Flags & GVE_SF_CARVA)
			strcat(b,"Carva ");
		if (RasterIndex[i].Flags & GVE_SF_LAMBERT)
			strcat(b,"Lambert ");
		if (RasterIndex[i].Flags & GVE_SF_GOURAUD)
			strcat(b,"Gouraud ");
		if (RasterIndex[i].Flags & GVE_SF_PHONG)
			strcat(b,"Phong ");
		if (RasterIndex[i].Flags & GVE_SF_SOFT)
			strcat(b,"Soft ");
		if (RasterIndex[i].Flags & GVE_SF_GLASS)
			strcat(b,"Transparent ");
		if (!RasterIndex[i].Flags)
			strcat(b,"Nothing");
		else if (strlen(b)==0) strcpy(b,"Unkown");

		return b;
	   }
 return NULL;
}


DWORD FASTCALL GVectorSystem::GetShadingFlags(INT s)
{
 int i;

 for(i=0;i<sizeof(RasterIndex)/sizeof(GRasterIndex);i++)
	if (RasterIndex[i].Type==s)
		return RasterIndex[i].Flags;
 return NULL;
}


INT FASTCALL GVectorSystem::FindShading(DWORD f)
{
 int i;
 int bestdiff=1000,bestshad=GVE_SHAD_NOTHING,diff;
 DWORD mask;

 for(i=0;i<sizeof(RasterIndex)/sizeof(GRasterIndex);i++)
   {
	mask=(f^RasterIndex[i].Flags) & ~(GVE_SF_LOWDETAIL | GVE_SF_MEDIUMDETAIL | GVE_SF_HIGHDETAIL );
	diff=0;
	while(mask)
	   {
		if (mask & 1) diff++;
		mask>>=1;
	   }
	if (diff<bestdiff)
	   {
		bestdiff=diff;
		bestshad=RasterIndex[i].Type;
	   }
   }

 return bestshad;
}


void FASTCALL GVectorSystem::DrawWorld(void)
{
 GMeshObject	*mesh;
 GLightObject	*light;
 GCameraObject	*camera;
 GVectorObject 	*o;
 GObjectStack 	*stack=new GObjectStack;
 GVertex 		*v,*firstv,*lastv;
 GFace			*face;
 INT			i,j,fcount;
 GMatrix 		camera_matrix,light_matrix,object_matrix;
 GNormal 		global_light,local_light;
 GPointL 		center;
 GPointM		distance,factor;
 MATH 			sortkey;

 if (World->GetFlag(GVE_WRLD_RENDERING)) return;
 World->SetFlag(GVE_WRLD_RENDERING);
 RasterEngine->Begin();
 RasterEngine->Preprocess(World->Flags);

 //
 // Now we transform the camera and the only lightsource
 //
 camera=World->Camera;
 light=World->Light;
 camera_matrix=camera->FinalMatrix;
 light_matrix=light->FinalMatrix;
 global_light=light_matrix*GNormal(1.0,0.0,0.0);
 distance.x=camera->Distance.x;
 distance.y=camera->Distance.y;
 OrderList.DeleteAll();


 center.x=((FrameWidth>>1)<<GVE_RASTERX_SHIFT)+((camera->Offset.x*FrameWidth)<<(GVE_RASTERX_SHIFT-GVE_MATH_SHIFT));
 center.y=((FrameHeight>>1)<<GVE_RASTERY_SHIFT)+((camera->Offset.y*FrameHeight)>>(GVE_MATH_SHIFT-GVE_RASTERY_SHIFT));
 #ifdef GVE_FIXED_MATH
  factor.x=(LONG)ldexp((DOUBLE)FrameHeight*(DOUBLE)camera->Zoom*(DOUBLE)camera->DistanceX*(DOUBLE)FrameAspectRatio,GVE_RASTERX_SHIFT-GVE_ZOOM_SHIFT-GVE_VECTOR_SHIFT-8);
  factor.y=(LONG)ldexp((DOUBLE)FrameHeight*(DOUBLE)camera->Zoom*(DOUBLE)camera->DistanceY,GVE_RASTERY_SHIFT-GVE_ZOOM_SHIFT-GVE_VECTOR_SHIFT-8);
 #else
  factor.x=(DOUBLE)FrameHeight*(DOUBLE)camera->Zoom*(DOUBLE)camera->Distance.x*(DOUBLE)FrameAspectRatio*(DOUBLE)(1<<(GVE_RASTERX_SHIFT))/(DOUBLE)(1<<8);
  factor.y=(DOUBLE)FrameHeight*(DOUBLE)camera->Zoom*(DOUBLE)camera->Distance.y*(DOUBLE)(1<<(GVE_RASTERY_SHIFT))/(DOUBLE)(1<<8);
 #endif

 //
 // Now lets walk thorugh all objects
 //
 o=World->GetRootObject();
 do
   {
	if (o->Son)
		stack->Push(o->Son);
	if ((o->Type!=GMeshObject::MESH_TYPE) || (typeid(*o)!=typeid(GMeshObject)))
		continue;

	mesh=(GMeshObject *)o;
	if ((!mesh->VertexList) || (!mesh->FaceList) || (mesh->Flags & (GVE_OBJ_HIDE | GVE_OBJ_VERTEX_INDEX)))
		continue;

	object_matrix=camera_matrix^o->FinalMatrix;

	//
	// Transform all vertices of current object
	//
	local_light=mesh->FinalMatrix^global_light;

	#ifdef GVE_CULL_FIRST
	 LONG lookat[3];

	 lookat[0]=mesh->FinalMatrix[0][2];
	 lookat[1]=mesh->FinalMatrix[1][2];
	 lookat[2]=mesh->FinalMatrix[2][2];

	 fcount=mesh->FaceList->Count;
	 face=&mesh->FaceList->Face[0];
	 for (i=0;i<fcount;i++)
	   {
		if(face->Normal[0]*lookat[0]+
		   face->Normal[1]*lookat[1]+
		   face->Normal[2]*lookat[2]<0)
		   {
			OrderList.AddEntry(sortkey,f);
			// tag vertices !!!
		   }
		(BYTE *)face+=(LONG)face->Size;
	   }
	#endif

	firstv=&mesh->VertexList->Vertex[0];
	lastv=&mesh->VertexList->Vertex[mesh->VertexList->Count];
	for (v=firstv;v<lastv;v++)
	   {
		#ifdef GVE_CULL_FIRST

		#endif
		// Get the final Position
		v->TPosition=object_matrix*v->Position;

		// Transform the vertex GNormal, if neccessary
		if (mesh->Flags & GVE_OBJ_NORMALS)
		   {
			v->TNormal=object_matrix*v->Normal;
			#ifdef GVE_SPHERICAL_CHROME
			 #ifdef GVE_FIXED_MATH
			  v->Chrome.u=ASinusTable[
				(v->TNormal.x>>(GVE_NORMAL_SHIFT-GVE_ASINE_TABLE_SHIFT+1))
				  + (GVE_ASINE_TABLE_SIZE >> 1)];
			  v->Chrome.v=ASinusTable[
				(v->TNormal.y>>(GVE_NORMAL_SHIFT-GVE_ASINE_TABLE_SHIFT+1))
				  + (GVE_ASINE_TABLE_SIZE >> 1)];
			 #else
			  v->Chrome.u=ASinusTable[
				MATH2FIXED(v->TNormal.x,GVE_ASINE_TABLE_SHIFT-1)
				  + (GVE_ASINE_TABLE_SIZE >> 1)];
			  v->Chrome.v=ASinusTable[
				MATH2FIXED(v->TNormal.y,GVE_ASINE_TABLE_SHIFT-1)
				  + (GVE_ASINE_TABLE_SIZE >> 1)];
			  #endif
			#else
			 #ifdef GVE_FIXED_MATH
			  v->Chrome.u=((v->TNormal.x+LONG2MATH(1,GVE_NORMAL_SHIFT)) << (GVE_MAPPING_SHIFT-GVE_NORMAL_SHIFT+7));
			  v->Chrome.v=((v->TNormal.y+LONG2MATH(1,GVE_NORMAL_SHIFT)) << (GVE_MAPPING_SHIFT-GVE_NORMAL_SHIFT+7));
			 #else
			  v->Chrome.u=MATH2FIXED(v->TNormal.x+1.0,GVE_MAPPING_SHIFT+7);
			  v->Chrome.v=MATH2FIXED(v->TNormal.y+1.0,GVE_MAPPING_SHIFT+7);
			 #endif
			#endif
		   }

		// Perform vertex shading, if neccessary
		if ((mesh->Flags & GVE_OBJ_VERTEX_SHADING)== GVE_OBJ_VERTEX_SHADING)
			v->Shading=MATH2FIXED(local_light*v->Normal,2*GVE_NORMAL_SHIFT)+(1<<(2*GVE_NORMAL_SHIFT));

		// Perform perspective projection 3D->2D
		if (v->TPosition.z>0)
		   {
			#if defined(GVE_FIXED_MATH)
			 v->SPosition.x=(LONG)MulDiv(v->TPosition.x,factor.x,v->TPosition.z+distance.x)+center.x;
			 v->SPosition.y=(LONG)MulDiv(v->TPosition.y,factor.y,v->TPosition.z+distance.y)+center.y;
			#else
			 v->SPosition.x=(LONG)(v->TPosition.x*factor.x/(v->TPosition.z+distance.x))+center.x;
			 v->SPosition.y=(LONG)(v->TPosition.y*factor.y/(v->TPosition.z+distance.y))+center.y;
			#endif
			#if defined(GVE_ZBUFEER)
			 #if defined(GVE_FIXED_MATH)
			  v->ReverseZ=0x80000000LU/(ULONG)v->TPosition.z;
			 #else
			  v->ReverseZ=(LONG)((DOUBLE)20000000.0/(DOUBLE)v->TPosition.z);
			 #endif
			#endif
		   }
	   }

	//
	// Add all visible faces to sorting list
	//
	#if defined(GVE_CULL_AFTER)
	fcount=mesh->FaceList->Count;
	face=&mesh->FaceList->Face[0];
	for (i=0;i<fcount;((BYTE *)face+=(LONG)face->Size,i++))
	   {
		#if defined(GVE_SORT_LIST) || defined(GVE_SORT_TREE) || defined(GVE_SORT_HEAP)
		 #if defined(GVE_PRO)
		 sortkey=face->Vertex[0]->TPosition.z+
				 face->Vertex[1]->TPosition.z+
				 face->Vertex[2]->TPosition.z;
		 if (sortkey<LONG2MATH(3,GVE_VECTOR_SHIFT)) continue;
		 #else
		 sortkey=0;
		 for (j=0;j<face->VertexCount;j++)
			sortkey+=face->Vertex[j]->TPosition.z;
		 sortkey/=face->VertexCount;
		 if (sortkey<LONG2MATH(1,GVE_VECTOR_SHIFT)) continue;
		 #endif
		#endif
		if(mesh->Flags & GVE_OBJ_BACKCULLING)
			if(((face->Vertex[0]->SPosition.x - face->Vertex[1]->SPosition.x)*
				(face->Vertex[2]->SPosition.y - face->Vertex[1]->SPosition.y))
			  -((face->Vertex[0]->SPosition.y - face->Vertex[1]->SPosition.y)*
				(face->Vertex[2]->SPosition.x - face->Vertex[1]->SPosition.x)) < 0)
					continue;
		#if defined(GVE_SORT_LIST) || defined(GVE_SORT_TREE) || defined(GVE_SORT_HEAP)
		 OrderList.AddEntry(sortkey,face);
		#else
         RasterEngine->Drawface(face);
		#endif
	   }
	#endif
   }
 while((o=(GVectorObject *)((o->Brother!=NULL) ? o->Brother : (GVectorObject *)stack->Pop()))!=NULL);


 //
 // Now lets draw all polys
 //
 #if defined GVE_SORT_LIST
 if(!(World->Flags & GVE_WRLD_NOSORT)) 	OrderList.Sort();
 GFaceOrderList::GEntry *fentry,*lentry,*centry;
 fentry=OrderList.FirstEntry;
 lentry=OrderList.LastEntry;
 for(centry=fentry;centry<lentry;centry++)
 	RasterEngine->DrawFace(centry->Face);
 #elif defined GVE_SORT_TREE

 #elif defined GVE_SORT_HEAP

 #endif


 //
 // Finally we perform some postprocessing
 //
 RasterEngine->Postprocess(World->Flags);
 RasterEngine->End();
 delete stack;
 World->ClearFlag(GVE_WRLD_RENDERING);
}



///////////////////////////////////////////////////////////////////////////////
//
// The following routines are part of GFaceOrderTree
//
//
BOOL FASTCALL GFaceOrderTree::Alloc(INT n)
{
 if (FirstEntry!=NULL) free(FirstEntry);
 if ((FirstEntry=(GEntry *)malloc(n*sizeof(GEntry)))==NULL) return FALSE;
 Head=LastEntry=FirstEntry;
 CurrentEntry=NULL;
 Size=n;
 return TRUE;
}



BOOL FASTCALL GFaceOrderTree::Free(void)
{
 if (FirstEntry!=NULL) free(FirstEntry);
 Head=CurrentEntry=LastEntry=FirstEntry=NULL;
 Size=0;
 return TRUE;
}



void FASTCALL GFaceOrderTree::AddEntry(MATH key,GFace *face)
{
 GEntry *l=Head;

 LastEntry->Key=key;
 LastEntry->Face=face;
 LastEntry->LeftSon=NULL;
 LastEntry->RightSon=NULL;

 if(LastEntry==FirstEntry)
   {
	LastEntry++;
	return;
   }

 for(;;)
   {
	if (l->Key>key)
	   {
		if (l->LeftSon!=NULL)
			l=l->LeftSon;
		else
		   {
			l->LeftSon=LastEntry;
			LastEntry++;
			return;
		   }
	   }
	else
	   {
		if (l->RightSon!=NULL)
			l=l->RightSon;
		else
		   {
			l->RightSon=LastEntry;
			LastEntry++;
			return;
		   }
	   }
  }
}


GFace* FASTCALL GFaceOrderTree::Start(void)
{
 if (LastEntry==FirstEntry)
	return  (GFace *)(CurrentEntry=NULL);
 else
   {
	CurrentEntry=Head;

	while(CurrentEntry->LeftSon!=NULL)
	CurrentEntry=CurrentEntry->LeftSon;
	return CurrentEntry->Face;
   }
}



BOOL FASTCALL GFaceOrderList::Alloc(INT n)
{
 if (FirstEntry!=NULL) free(FirstEntry);
 if ((FirstEntry=(GEntry *)malloc(n*sizeof(GEntry)))==NULL) return FALSE;
 LastEntry=FirstEntry;
 CurrentEntry=NULL;
 Size=n;
 return TRUE;
}



BOOL FASTCALL GFaceOrderList::Free(void)
{
 if (FirstEntry!=NULL) free(FirstEntry);
 CurrentEntry=LastEntry=FirstEntry=NULL;
 Size=0;
 return TRUE;
}


BOOL FASTCALL GFaceOrderHeap::Alloc(INT n)
{
 if (FirstEntry!=NULL) free(FirstEntry);
 if ((FirstEntry=(GEntry *)malloc(n*sizeof(GEntry)))==NULL) return FALSE;
 LastEntry=FirstEntry;
 CurrentEntry=NULL;
 Size=n;
 return TRUE;
}



BOOL FASTCALL GFaceOrderHeap::Free(void)
{
 if (FirstEntry!=NULL) free(FirstEntry);
 CurrentEntry=LastEntry=FirstEntry=NULL;
 Size=0;
 return TRUE;
}



