///////////////////////////////////////////////////////////////////////////////
//
// (c) 1997 by Marc van Shaney , aka Kaya Memisoglu
//
// This Source-Code was written by and is copyrighted by Kaya Memisoglu
// You may use the whole code or only parts of it in your own programs
// whether they are commercial or not. BUT you must give credits for these
// parts to me (Kaya Memisoglu  or  Marc van Shaney).
// I am not responsible for any damage or loss caused by this program, so
// if you success in erasing your harddisk with this code, then it is your
// own fault and you should not claim me to be responsible...
// I would be very pleased if you also sent me a postcard or even a letter
// if you can use this code. My address:
//
//        Kaya Memisoglu
//        Reichenberger Ring 50
//        63512 Hainburg
//        Germany
//
//

#include "../include/gvepro.h"


GRasterEngine::GRasterEngine(void)
{
 INT i;

 (PTR)CurrentFrame=
 (PTR)LastFrame=
 (PTR)TextureMapList=
 (PTR)BumpMapList=
 (PTR)LightMapList=
 (PTR)Ambient=NULL;
  FrameWidth=FrameHeight=FrameDepth=0;

 for (i=0;i<sizeof(Light)/sizeof(GLightObject*);i++)
	Light[i]=NULL;

 for (i=0;i<64;i++)
 	DrawFaceFunc[i]=&GRasterEngine::DrawNothing;

 DrawFaceFunc[GVE_SHAD_NOTHING]=&GRasterEngine::DrawNothing;
 DrawFaceFunc[GVE_SHAD_POINT]=&GRasterEngine::DrawVertex;
 DrawFaceFunc[GVE_SHAD_WIREFRAME]=&GRasterEngine::DrawWire;
 DrawFaceFunc[GVE_SHAD_SOFT_WIRE]=&GRasterEngine::DrawWireSoft;
 DrawFaceFunc[GVE_SHAD_GLASS_WIRE]=&GRasterEngine::DrawWireGlass;
 DrawFaceFunc[GVE_SHAD_FILLED]=&GRasterEngine::DrawFilled;
 DrawFaceFunc[GVE_SHAD_LAMBERT]=&GRasterEngine::DrawFilledLambert;
 DrawFaceFunc[GVE_SHAD_GOURAUD]=&GRasterEngine::DrawFilledGouraud;
 DrawFaceFunc[GVE_SHAD_PHONG]=&GRasterEngine::DrawFilledPhong;
 DrawFaceFunc[GVE_SHAD_GLASS]=&GRasterEngine::DrawFilledGlass;
 DrawFaceFunc[GVE_SHAD_LAMBERT_GLASS]=&GRasterEngine::DrawFilledGlassLambert;
 DrawFaceFunc[GVE_SHAD_GOURAUD_GLASS]=&GRasterEngine::DrawFilledGlassGouraud;
 DrawFaceFunc[GVE_SHAD_PHONG_GLASS]=&GRasterEngine::DrawFilledGlassPhong;
 DrawFaceFunc[GVE_SHAD_TEXTURE]=&GRasterEngine::DrawTextured;
 DrawFaceFunc[GVE_SHAD_TEXTURE_LAMBERT]=&GRasterEngine::DrawTexturedLambert;
 DrawFaceFunc[GVE_SHAD_TEXTURE_GOURAUD]=&GRasterEngine::DrawTexturedGouraud;
 DrawFaceFunc[GVE_SHAD_TEXTURE_PHONG]=&GRasterEngine::DrawTexturedPhong;
 DrawFaceFunc[GVE_SHAD_TEXTURE_LIGHTMAP]=&GRasterEngine::DrawTexturedLightmap;
 DrawFaceFunc[GVE_SHAD_TEXTURE_CHROME]=&GRasterEngine::DrawTexturedChrome;
 DrawFaceFunc[GVE_SHAD_TEXTURE_GLASS]=&GRasterEngine::DrawTexturedGlass;
 DrawFaceFunc[GVE_SHAD_TEXTURE_BUMP_LIGHTMAP]=&GRasterEngine::DrawTexturedBumpLightmap;
 DrawFaceFunc[GVE_SHAD_TEXTURE_BUMP_CHROME]=&GRasterEngine::DrawTexturedBumpChrome;
 DrawFaceFunc[GVE_SHAD_PTEXTURE]=&GRasterEngine::DrawPersTextured;
 DrawFaceFunc[GVE_SHAD_PTEXTURE_LAMBERT]=&GRasterEngine::DrawPersTexturedLambert;
 DrawFaceFunc[GVE_SHAD_PTEXTURE_GOURAUD]=&GRasterEngine::DrawPersTexturedGouraud;
 DrawFaceFunc[GVE_SHAD_PTEXTURE_PHONG]=&GRasterEngine::DrawPersTexturedPhong;
 DrawFaceFunc[GVE_SHAD_PTEXTURE_LIGHTMAP]=&GRasterEngine::DrawPersTexturedLightmap;
 DrawFaceFunc[GVE_SHAD_PTEXTURE_CHROME]=&GRasterEngine::DrawPersTexturedChrome;
 DrawFaceFunc[GVE_SHAD_PTEXTURE_GLASS]=&GRasterEngine::DrawPersTexturedGlass;
 DrawFaceFunc[GVE_SHAD_PTEXTURE_BUMP_LIGHTMAP]=&GRasterEngine::DrawPersTexturedBumpLightmap;
 DrawFaceFunc[GVE_SHAD_PTEXTURE_BUMP_CHROME]=&GRasterEngine::DrawPersTexturedBumpChrome;
 DrawFaceFunc[GVE_SHAD_CHROME]=&GRasterEngine::DrawChrome;
 DrawFaceFunc[GVE_SHAD_CHROME_LAMBERT]=&GRasterEngine::DrawChromeLambert;
 DrawFaceFunc[GVE_SHAD_CHROME_GOURAUD]=&GRasterEngine::DrawChromeGouraud;
 DrawFaceFunc[GVE_SHAD_CHROME_PHONG]=&GRasterEngine::DrawChromePhong;
 DrawFaceFunc[GVE_SHAD_CHROME_GLASS]=&GRasterEngine::DrawChromeGlass;
 DrawFaceFunc[GVE_SHAD_BUMP]=&GRasterEngine::DrawBump;
 DrawFaceFunc[GVE_SHAD_BUMP_LAMBERT]=&GRasterEngine::DrawBumpLambert;
 DrawFaceFunc[GVE_SHAD_BUMP_GOURAUD]=&GRasterEngine::DrawBumpGouraud;
 DrawFaceFunc[GVE_SHAD_BUMP_PHONG]=&GRasterEngine::DrawBumpPhong;
 DrawFaceFunc[GVE_SHAD_BUMP_CHROME]=&GRasterEngine::DrawBumpChrome;
 DrawFaceFunc[GVE_SHAD_BUMP_LIGHTMAP]=&GRasterEngine::DrawBumpLightmap;
 DrawFaceFunc[GVE_SHAD_BUMP_GLASS]=&GRasterEngine::DrawBumpGlass;
 DrawFaceFunc[GVE_SHAD_CARVA]=&GRasterEngine::DrawCarva;
 DrawFaceFunc[GVE_SHAD_CARVA_LAMBERT]=&GRasterEngine::DrawCarvaLambert;
 DrawFaceFunc[GVE_SHAD_CARVA_GOURAUD]=&GRasterEngine::DrawCarvaGouraud;
 DrawFaceFunc[GVE_SHAD_CARVA_PHONG]=&GRasterEngine::DrawCarvaPhong;
 DrawFaceFunc[GVE_SHAD_CARVA_GLASS]=&GRasterEngine::DrawCarvaGlass;
 DrawFaceFunc[GVE_SHAD_CARVA_LAMBERT_GLASS]=&GRasterEngine::DrawCarvaLambertGlass;
 DrawFaceFunc[GVE_SHAD_CARVA_GOURAUD_GLASS]=&GRasterEngine::DrawCarvaGouraudGlass;
 DrawFaceFunc[GVE_SHAD_CARVA_PHONG_GLASS]=&GRasterEngine::DrawCarvaPhongGlass;
}


///////////////////////////////////////////////////////////////////////////////
//
// Implementation of GRasterEngine8
//
BOOL FASTCALL GRasterEngine8::Init(void)
{
 INT i;

 for (i=0;i<256;i++)
	CarvaTable[i]=(BYTE)(((LONG)rand()<<8)/(RAND_MAX+1));
 return TRUE;
}

BOOL FASTCALL GRasterEngine8::Exit(void)
{
 return TRUE;
}

void FASTCALL GRasterEngine8::MakeShadingLUT()
{
 GColour c,ambient,light;
 INT i,j,spec;
 BYTE* lut=ShadingLUT;

 if ((!Ambient) || (!Light)) return;
 ambient=Ambient->GetColour();
 spec=Ambient->GetSpecularity();
 light=Light[0]->GetColour();

 for(j=0;j<64;j++)
	for(i=0;i<256;i++)
	   {
		c=Palette.GetColour(i).Shade(ambient,light,spec,j);
		*lut++ = (BYTE)Palette.ApproximateColour(c);
	   }
}


void FASTCALL GRasterEngine8::MakeGlassLUT()
{
 GColour c;
 INT i,j;
 BYTE* lut=GlassLUT;

 for(j=0;j<256;j++)
	for(i=0;i<256;i++)
	   {
		c=Palette.GetColour(i).Mix(Palette.GetColour(j));
		*lut++ = (BYTE)Palette.ApproximateColour(c);
	   }
}


void FASTCALL GRasterEngine8::MakeBlurrLUT()
{
 GColour c;
 INT i,j;
 BYTE* lut=BlurrLUT;

 for(j=0;j<256;j++)
	for(i=0;i<256;i++)
	   {
		c.R=(BYTE)((INT)Palette.GetColour(i).R*3>>2);
		c.G=(BYTE)((INT)Palette.GetColour(i).G*3>>2);
		c.B=(BYTE)((INT)Palette.GetColour(i).B*3>>2);
		*lut++ = (BYTE)Palette.ApproximateColour(c);
	   }
}


void FASTCALL GRasterEngine8::MakeBumpLUT()
{
 if ((!Ambient) || (!Light)) return;
}



///////////////////////////////////////////////////////////////////////////////
//
// Implementation of GRasterEngine16
//
BOOL FASTCALL GRasterEngine16::Init(void)
{
 INT i;

 for (i=0;i<256;i++)
	CarvaTable[i]=(BYTE)(((LONG)rand()<<8)/(RAND_MAX+1));
 return TRUE;
}


BOOL FASTCALL GRasterEngine16::Exit(void)
{
 return TRUE;
}


void FASTCALL GRasterEngine16::MakeShadingLUT()
{
 GColour c,ambient,light;
 INT i,j,spec;
 WORD* lut=ShadingLUT;

 if ((!Ambient) || (!Light)) return;
 ambient=Ambient->GetColour();
 spec=Ambient->GetSpecularity();
 light=Light[0]->GetColour();


 for(j=0;j<64;j++)
 	for(i=0;i<256;i++)
 	   {
		c=Palette.GetColour(i).Shade(ambient,light,spec,j);
		*lut++ = (WORD)c.Convert(FrameDepth);
 	   }
}


void FASTCALL GRasterEngine16::MakeGlassLUT()
{
 GColour c;
 INT i,j;
 WORD* lut=GlassLUT;

 for(j=0;j<256;j++)
	for(i=0;i<256;i++)
	   {
		c=Palette.GetColour(i).Mix(Palette.GetColour(j));
		*lut++ = (WORD)c.Convert(FrameDepth);
	   }
}


void FASTCALL GRasterEngine16::MakeBumpLUT()
{
 if ((!Ambient) || (!Light)) return;
}


