///////////////////////////////////////////////////////////////////////////////
//
// (c) 1997 by Marc van Shaney , aka Kaya Memisoglu
//
// This Source-Code was written by and is copyrighted by Kaya Memisoglu
// You may use the whole code or only parts of it in your own programs
// whether they are commercial or not. BUT you must give credits for these
// parts to me (Kaya Memisoglu  or  Marc van Shaney).
// I am not responsible for any damage or loss caused by this program, so
// if you success in erasing your harddisk with this code, then it is your
// own fault and you should not claim me to be responsible...
// I would be very pleased if you also sent me a postcard or even a letter
// if you can use this code. My address:
//
//        Kaya Memisoglu
//        Reichenberger Ring 50
//        63512 Hainburg
//        Germany
//
//


#define STRICT
#include <windows.h>
#include <windowsx.h>
#include "..\include\gvepro.h"
#include "gve4win.h"


EXTERN HINSTANCE    	hMainInstance;
EXTERN HWND 			hMainWindow,hObjectList,hObjCtrl,hCamCtrl,hLightCtrl;
EXTERN char				AppName[];
EXTERN char 			AppTitle[];
EXTERN char 			ErrTitle[];

EXTERN RECT 		 	ClientRect,MainRect,ObjectListRect;
EXTERN RECT				ObjControlRect,CamControlRect,LightControlRect;
EXTERN GVectorSystem 	VSystem;
EXTERN GVectorWorld  	*VWorld;
EXTERN GVectorObject 	*VObject;
EXTERN GVectorObject 	*VMesh;
EXTERN GLightObject  	*VLight;
EXTERN GCameraObject 	*VCamera;

LOCAL BOOL APIENTRY CamCtrlProc(HWND ,UINT ,WPARAM ,LPARAM );
LOCAL void CamCtrlOnCommand(HWND hwnd, int id, HWND hwndCtl,UINT codeNotify);




BOOL DisplayCamControl(HWND hwnd)
{
 if (hCamCtrl)
   {
	SetFocus(hCamCtrl);
	return TRUE;
   }

 hCamCtrl = CreateDialog(hMainInstance,
				MAKEINTRESOURCE(IDD_CAMCTRL),
				hwnd,
				CamCtrlProc);

 if (!hCamCtrl) return FALSE;

 SetWindowPos(hCamCtrl,NULL,CamControlRect.left,CamControlRect.top,0,0,SWP_NOSIZE|SWP_NOZORDER|SWP_SHOWWINDOW);
 UpdateWindow(hCamCtrl);

 return TRUE;
}



BOOL DestroyCamControl(HWND hwnd)
{
 if (hCamCtrl) DestroyWindow(hCamCtrl);
 hCamCtrl=NULL;
 return TRUE;
}


BOOL APIENTRY CamCtrlProc(HWND hdlg,UINT Message,WPARAM wParam,LPARAM lParam)
{
 CHAR buffer[40];

 switch (Message)
   {
	HANDLE_MSG (hdlg, WM_COMMAND, CamCtrlOnCommand);
	case WM_INITDIALOG:
	case PM_CHANGE_OBJECT:
	case PM_CHANGE_OBJECTLIST:
		Edit_SetText(GetDlgItem(hdlg,IDC_CAMCTRL_CAMNAME),VCamera->GetName());
		sprintf(buffer,"%.2lf",VCamera->GetPosition().GetX());
		Edit_SetText(GetDlgItem(hdlg,IDC_CAMCTRL_POSX),buffer);
		sprintf(buffer,"%.2lf",VCamera->GetPosition().GetY());
		Edit_SetText(GetDlgItem(hdlg,IDC_CAMCTRL_POSY),buffer);
		sprintf(buffer,"%.2lf",VCamera->GetPosition().GetZ());
		Edit_SetText(GetDlgItem(hdlg,IDC_CAMCTRL_POSZ),buffer);

		sprintf(buffer,"%.2lf",GRad2Deg(VCamera->GetRotation().GetX()));
		Edit_SetText(GetDlgItem(hdlg,IDC_CAMCTRL_ROTX),buffer);
		sprintf(buffer,"%.2lf",GRad2Deg(VCamera->GetRotation().GetY()));
		Edit_SetText(GetDlgItem(hdlg,IDC_CAMCTRL_ROTY),buffer);
		sprintf(buffer,"%.2lf",GRad2Deg(VCamera->GetRotation().GetZ()));
		Edit_SetText(GetDlgItem(hdlg,IDC_CAMCTRL_ROTZ),buffer);
		return TRUE;
	case WM_CLOSE:
		DestroyWindow(hdlg);
		return TRUE;
	case WM_DESTROY:
		GetWindowRect(hdlg,&CamControlRect);
		hCamCtrl=NULL;
		return TRUE;
	default:
		return FALSE;
   }
}




void CamCtrlOnCommand(HWND hdlg, int id, HWND hwndCtl,UINT codeNotify)
{
 CHAR buffer[40];

 switch (id)
   {
	case IDC_CAMCTRL_DECPOSX:
		VCamera->SetPosition(VCamera->GetPosition() - GVector(0.5,0,0));
		sprintf(buffer,"%.2lf",VCamera->GetPosition().GetX());
		Edit_SetText(GetDlgItem(hdlg,IDC_CAMCTRL_POSX),buffer);
		VCamera->RealizePosition();
		break;
	case IDC_CAMCTRL_INCPOSX:
		VCamera->SetPosition(VCamera->GetPosition() + GVector(0.5,0,0));
		sprintf(buffer,"%.2lf",VCamera->GetPosition().GetX());
		Edit_SetText(GetDlgItem(hdlg,IDC_CAMCTRL_POSX),buffer);
		VCamera->RealizePosition();
		break;

	case IDC_CAMCTRL_DECPOSY:
		VCamera->SetPosition(VCamera->GetPosition() - GVector(0,0.5,0));
		sprintf(buffer,"%.2lf",VCamera->GetPosition().GetY());
		Edit_SetText(GetDlgItem(hdlg,IDC_CAMCTRL_POSY),buffer);
		VCamera->RealizePosition();
		break;
	case IDC_CAMCTRL_INCPOSY:
		VCamera->SetPosition(VCamera->GetPosition() + GVector(0,0.5,0));
		sprintf(buffer,"%.2lf",VCamera->GetPosition().GetY());
		Edit_SetText(GetDlgItem(hdlg,IDC_CAMCTRL_POSY),buffer);
		VCamera->RealizePosition();
		break;

	case IDC_CAMCTRL_DECPOSZ:
		VCamera->SetPosition(VCamera->GetPosition() - GVector(0,0,0.5));
		sprintf(buffer,"%.2lf",VCamera->GetPosition().GetZ());
		Edit_SetText(GetDlgItem(hdlg,IDC_CAMCTRL_POSZ),buffer);
		VCamera->RealizePosition();
		break;
	case IDC_CAMCTRL_INCPOSZ:
		VCamera->SetPosition(VCamera->GetPosition() + GVector(0,0,0.5));
		sprintf(buffer,"%.2lf",VCamera->GetPosition().GetZ());
		Edit_SetText(GetDlgItem(hdlg,IDC_CAMCTRL_POSZ),buffer);
		VCamera->RealizePosition();
		break;

	case IDC_CAMCTRL_DECROTX:
		VCamera->SetRotation(VCamera->GetRotation() - GVector(GDeg2Rad(0.5),0,0));
		sprintf(buffer,"%.2lf",GRad2Deg(VCamera->GetRotation().GetX()));
		Edit_SetText(GetDlgItem(hdlg,IDC_CAMCTRL_ROTX),buffer);
		VCamera->RealizePosition();
		break;
	case IDC_CAMCTRL_INCROTX:
		VCamera->SetRotation(VCamera->GetRotation() + GVector(GDeg2Rad(0.5),0,0));
		sprintf(buffer,"%.2lf",GRad2Deg(VCamera->GetRotation().GetX()));
		Edit_SetText(GetDlgItem(hdlg,IDC_CAMCTRL_ROTX),buffer);
		VCamera->RealizePosition();
		break;

	case IDC_CAMCTRL_DECROTY:
		VCamera->SetRotation(VCamera->GetRotation() - GVector(0,GDeg2Rad(0.5),0));
		sprintf(buffer,"%.2lf",GRad2Deg(VCamera->GetRotation().GetY()));
		Edit_SetText(GetDlgItem(hdlg,IDC_CAMCTRL_ROTY),buffer);
		VCamera->RealizePosition();
		break;
	case IDC_CAMCTRL_INCROTY:
		VCamera->SetRotation(VCamera->GetRotation() + GVector(0,GDeg2Rad(0.5),0));
		sprintf(buffer,"%.2lf",GRad2Deg(VCamera->GetRotation().GetY()));
		Edit_SetText(GetDlgItem(hdlg,IDC_CAMCTRL_ROTY),buffer);
		VCamera->RealizePosition();
		break;

	case IDC_CAMCTRL_DECROTZ:
		VCamera->SetRotation(VCamera->GetRotation() - GVector(0,0,GDeg2Rad(0.5)));
		sprintf(buffer,"%.2lf",GRad2Deg(VCamera->GetRotation().GetZ()));
		Edit_SetText(GetDlgItem(hdlg,IDC_CAMCTRL_ROTZ),buffer);
		VCamera->RealizePosition();
		break;
	case IDC_CAMCTRL_INCROTZ:
		VCamera->SetRotation(VCamera->GetRotation() + GVector(0,0,GDeg2Rad(0.5)));
		sprintf(buffer,"%.2lf",GRad2Deg(VCamera->GetRotation().GetZ()));
		Edit_SetText(GetDlgItem(hdlg,IDC_CAMCTRL_ROTZ),buffer);
		VCamera->RealizePosition();
		break;

	case IDC_CAMCTRL_POSX:
		if (codeNotify==EN_CHANGE)
		   {
			GVector pos=VCamera->GetPosition();
			Edit_GetText(GetDlgItem(hdlg,IDC_CAMCTRL_POSX),buffer,sizeof(buffer));
			pos.SetX(atof(buffer));
			VCamera->SetPosition(pos);
			VCamera->RealizePosition();
		   }
		break;

	case IDC_CAMCTRL_POSY:
		if (codeNotify==EN_CHANGE)
		   {
			GVector pos=VCamera->GetPosition();
			Edit_GetText(GetDlgItem(hdlg,IDC_CAMCTRL_POSY),buffer,sizeof(buffer));
			pos.SetY(atof(buffer));
			VCamera->SetPosition(pos);
			VCamera->RealizePosition();
		   }
		break;

	case IDC_CAMCTRL_POSZ:
		if (codeNotify==EN_CHANGE)
		   {
			GVector pos=VCamera->GetPosition();
			Edit_GetText(GetDlgItem(hdlg,IDC_CAMCTRL_POSZ),buffer,sizeof(buffer));
			pos.SetZ(atof(buffer));
			VCamera->SetPosition(pos);
			VCamera->RealizePosition();
		   }
		break;

	case IDC_CAMCTRL_ROTX:
		if (codeNotify==EN_CHANGE)
		   {
			GVector rot=VCamera->GetRotation();
			Edit_GetText(GetDlgItem(hdlg,IDC_CAMCTRL_ROTX),buffer,sizeof(buffer));
			rot.SetX(GDeg2Rad(atof(buffer)));
			VCamera->SetRotation(rot);
			VCamera->RealizePosition();
		   }
		break;

	case IDC_CAMCTRL_ROTY:
		if (codeNotify==EN_CHANGE)
		   {
			GVector rot=VCamera->GetRotation();
			Edit_GetText(GetDlgItem(hdlg,IDC_CAMCTRL_ROTY),buffer,sizeof(buffer));
			rot.SetY(GDeg2Rad(atof(buffer)));
			VCamera->SetRotation(rot);
			VCamera->RealizePosition();
		   }
		break;

	case IDC_CAMCTRL_ROTZ:
		if (codeNotify==EN_CHANGE)
		   {
			GVector rot=VCamera->GetRotation();
			Edit_GetText(GetDlgItem(hdlg,IDC_CAMCTRL_ROTZ),buffer,sizeof(buffer));
			rot.SetZ(GDeg2Rad(atof(buffer)));
			VCamera->SetRotation(rot);
			VCamera->RealizePosition();
		   }
		break;

   }
}

