///////////////////////////////////////////////////////////////////////////////
//
// (c) 1997 by Marc van Shaney , aka Kaya Memisoglu
//
// This Source-Code was written by and is copyrighted by Kaya Memisoglu
// You may use the whole code or only parts of it in your own programs
// whether they are commercial or not. BUT you must give credits for these
// parts to me (Kaya Memisoglu  or  Marc van Shaney).
// I am not responsible for any damage or loss caused by this program, so
// if you success in erasing your harddisk with this code, then it is your
// own fault and you should not claim me to be responsible...
// I would be very pleased if you also sent me a postcard or even a letter
// if you can use this code. My address:
//
//        Kaya Memisoglu
//        Reichenberger Ring 50
//        63512 Hainburg
//        Germany
//
//


#define STRICT
#include <windows.h>
#include <windowsx.h>
#include "..\include\gvepro.h"
#include "gve4win.h"


PUBLIC HINSTANCE    	hMainInstance;
PUBLIC HWND 			hMainWindow=NULL,hObjectList=NULL;
PUBLIC HWND				hObjCtrl=NULL,hCamCtrl=NULL,hLightCtrl=NULL;
PUBLIC char				AppName[]="GVEpro32 Viewer";
PUBLIC char 			AppTitle[]="Gomez Vector Engine";
PUBLIC char 			ErrTitle[]="Error in Gomez Vector Engine:";

PUBLIC RECT 		 	ClientRect,MainRect,ObjectListRect;
PUBLIC RECT				ObjControlRect,CamControlRect,LightControlRect;
PUBLIC GVectorSystem 	VSystem;
PUBLIC CHAR				VWorldName[MAXPATH]="noname.gve";
PUBLIC GVectorWorld  	*VWorld=NULL;
PUBLIC GVectorObject 	*VObject=NULL;
PUBLIC GVectorObject 	*VMesh=NULL;
PUBLIC GCameraObject	*VCamera=NULL;
PUBLIC GLightObject		*VLight=NULL;
PUBLIC GFrame		 	*VFrame=NULL;
PUBLIC GRasterEngine	*VRasterEngine=NULL;




BOOL AppLoadOptions(void)
{
 char buffer[64];

 GetProfileString(AppName,"MainWindow","20 20 400 300",buffer,sizeof(buffer));
 sscanf(buffer,"%d %d %d %d",	&MainRect.left,
				&MainRect.top,
				&MainRect.right,
				&MainRect.bottom);

 GetProfileString(AppName,"ObjectListWindow","120 120 390 300",buffer,sizeof(buffer));
 sscanf(buffer,"%d %d %d %d",	&ObjectListRect.left,
				&ObjectListRect.top,
				&ObjectListRect.right,
				&ObjectListRect.bottom);

 GetProfileString(AppName,"ObjControlWindow","50 50 120 120",buffer,sizeof(buffer));
 sscanf(buffer,"%d %d %d %d", &ObjControlRect.left,
				&ObjControlRect.top,
				&ObjControlRect.right,
				&ObjControlRect.bottom);

 GetProfileString(AppName,"CamControlWindow","50 150 120 120",buffer,sizeof(buffer));
 sscanf(buffer,"%d %d %d %d", &CamControlRect.left,
				&CamControlRect.top,
				&CamControlRect.right,
				&CamControlRect.bottom);

 return TRUE;
}



BOOL AppSaveOptions(void)
{
 char buffer[64];
 sprintf(buffer,"%d %d %d %d",	MainRect.left,
				MainRect.top,
				MainRect.right,
				MainRect.bottom);
 WriteProfileString(AppName,"MainWindow",buffer);

 sprintf(buffer,"%d %d %d %d",	ObjectListRect.left,
				ObjectListRect.top,
				ObjectListRect.right,
				ObjectListRect.bottom);
 WriteProfileString(AppName,"ObjectListWindow",buffer);

 sprintf(buffer,"%d %d %d %d",	ObjControlRect.left,
				ObjControlRect.top,
				ObjControlRect.right,
				ObjControlRect.bottom);
 WriteProfileString(AppName,"ObjControlWindow",buffer);

 sprintf(buffer,"%d %d %d %d",	CamControlRect.left,
				CamControlRect.top,
				CamControlRect.right,
				CamControlRect.bottom);
 WriteProfileString(AppName,"CamControlWindow",buffer);
 

 return TRUE;
}



BOOL AppSetFrameRect(void)
{
 int width,height;

 width=ClientRect.right-ClientRect.left+1;
 height=ClientRect.bottom-ClientRect.top+1;
 VFrame->Resize(width,height);

 return TRUE;
}





BOOL AppRegister(void)
{
 WNDCLASSEX WndClass;

 memset(&WndClass, 0, sizeof(WNDCLASSEX));
 WndClass.cbSize		= sizeof(WNDCLASSEX);
 WndClass.style 		= CS_HREDRAW | CS_VREDRAW;
 WndClass.lpfnWndProc 	= MainWindowProc;
 WndClass.hInstance 	= hMainInstance;
 WndClass.hIcon 		= LoadIcon(hMainInstance,MAKEINTRESOURCE(IDI_MAINICON));
 WndClass.hCursor 		= LoadCursor(NULL, IDC_ARROW);
 WndClass.hbrBackground = NULL;
 WndClass.lpszMenuName 	= "GVEMENU";
 WndClass.lpszClassName = AppName;
 if (!RegisterClassEx(&WndClass)) return FALSE;


 // Register Object Trees and Toolbars
 WndClass.cbSize        = sizeof(WNDCLASSEX);
 WndClass.style         = CS_HREDRAW | CS_VREDRAW;
 WndClass.lpfnWndProc   = ObjectListProc;
 WndClass.hInstance     = hMainInstance;
 WndClass.hIcon         = LoadIcon(hMainInstance, MAKEINTRESOURCE(IDI_MAINICON));
 WndClass.hCursor       = LoadCursor(NULL, IDC_ARROW);
 WndClass.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);
 WndClass.lpszMenuName  = NULL;
 WndClass.lpszClassName = "ObjectList";
 if (!RegisterClassEx(&WndClass)) return FALSE;

 return TRUE;
}



BOOL AppRealizeObjectList(void)
{
 if (!VWorld->FindObject(VObject)) VObject=VWorld->GetRootObject();
 if (!VWorld->FindObject(VMesh)) VMesh=VWorld->GetRootObject();
 if (!VWorld->FindObject(VCamera)) VCamera=VWorld->GetCamera();
 if (!VWorld->FindObject(VLight))  VLight=VWorld->GetLight();
 VWorld->SetCamera(VCamera);
 VWorld->SetLight(VLight);
 VWorld->RealizePosition(TRUE);

 if (hObjectList)
	PostMessage(hObjectList,PM_CHANGE_OBJECTLIST,0,0);

 return TRUE;
}



BOOL AppRealizeWorld(void)
{
 VObject=VWorld->GetRootObject();
 VMesh=VWorld->GetRootObject();
 VLight=VWorld->GetLight();
 VCamera=VWorld->GetCamera();
 VFrame->SetPalette(VWorld->GetPalette());
 VFrame->RealizePalette();
 VSystem.SetWorld(VWorld);
 AppRealizeObjectList();

 return TRUE;
}



BOOL AppRealizeObject(void)
{
 if (hObjCtrl) PostMessage(hObjCtrl,PM_CHANGE_OBJECT,0,0);
 if (hCamCtrl) PostMessage(hCamCtrl,PM_CHANGE_OBJECT,0,0);
 if (hLightCtrl) PostMessage(hLightCtrl,PM_CHANGE_OBJECT,0,0);

 return TRUE;
}

