///////////////////////////////////////////////////////////////////////////////
//
// (c) 1997 by Marc van Shaney , aka Kaya Memisoglu
//
// This Source-Code was written by and is copyrighted by Kaya Memisoglu
// You may use the whole code or only parts of it in your own programs
// whether they are commercial or not. BUT you must give credits for these
// parts to me (Kaya Memisoglu  or  Marc van Shaney).
// I am not responsible for any damage or loss caused by this program, so
// if you success in erasing your harddisk with this code, then it is your
// own fault and you should not claim me to be responsible...
// I would be very pleased if you also sent me a postcard or even a letter
// if you can use this code. My address:
//
//        Kaya Memisoglu
//        Reichenberger Ring 50
//        63512 Hainburg
//        Germany
//
//


#define STRICT
#include <windows.h>
#include <windowsx.h>
#include "..\include\gvepro.h"
#include "gve4win.h"

EXTERN HINSTANCE    	hMainInstance;
EXTERN HWND 			hMainWindow,hObjectList,hObjCtrl,hCamCtrl,hLightCtrl;
EXTERN char				AppName[];
EXTERN char 			AppTitle[];
EXTERN char 			ErrTitle[];

EXTERN RECT 		 	ClientRect,MainRect,ObjectListRect;
EXTERN RECT				ObjControlRect,CamControlRect,LightControlRect;
EXTERN GVectorSystem 	VSystem;
EXTERN GVectorWorld  	*VWorld;
EXTERN GVectorObject 	*VObject;
EXTERN GVectorObject 	*VMesh;
EXTERN GLightObject  	*VLight;
EXTERN GCameraObject 	*VCamera;
EXTERN GFrame		 	*VFrame;
EXTERN GRasterEngine	*VRasterEngine;

LOCAL BOOL 	MainOnCreate(HWND hwnd, CREATESTRUCT* lpCreateStruct);
LOCAL void 	MainOnDestroy(HWND hwnd);
LOCAL void 	MainOnPaint(HWND hwnd);
LOCAL void 	MainOnSize(HWND hwnd,UINT state,int cx,int cy);
LOCAL void 	MainOnTimer(HWND hwnd,UINT id);




LRESULT CALLBACK MainWindowProc(HWND hwnd, UINT Message,WPARAM wParam, LPARAM lParam)
{
 switch(Message)
   {
	HANDLE_MSG(hwnd, WM_CREATE, MainOnCreate);
	HANDLE_MSG(hwnd, WM_DESTROY, MainOnDestroy);
	HANDLE_MSG(hwnd, WM_COMMAND, MainMenu);
	HANDLE_MSG(hwnd, WM_PAINT, MainOnPaint);
	HANDLE_MSG(hwnd, WM_SIZE, MainOnSize);
   	HANDLE_MSG(hwnd, WM_TIMER, MainOnTimer);
	default:
		return DefWindowProc(hwnd, Message, wParam, lParam);
   }
}


BOOL MainOnCreate(HWND hwnd, CREATESTRUCT* lpCreateStruct)
{
 HDC dc;
 int width,height,depth;

 GetWindowRect(hwnd,&MainRect);
 GetClientRect(hwnd,&ClientRect);

 dc=GetDC(hwnd);
 width=ClientRect.right-ClientRect.left+1;
 height=ClientRect.bottom-ClientRect.top+1;
 depth=GetDeviceCaps(dc,BITSPIXEL);
 ReleaseDC(hwnd,dc);
 VRasterEngine=new GRasterEngine16();

 if(VSystem.Init(VRasterEngine)==FALSE)
	{
	 MessageBox(hwnd,"Could not initialize Gomez Vector Engine!\n"
			 "Perhaps you are running the system in an\n"
			 "unsupported colour resolution.\n\n"
			 "   Click to exit the program.",
			 ErrTitle,MB_OK|MB_ICONSTOP);
	 return FALSE;
	}

 VWorld=new GVectorWorld();
 VWorld->Alloc();
 VFrame=new GFrame();
 VFrame->Alloc(width,height,depth);
 VFrame->SetPalette(VWorld->GetPalette());
 VFrame->RealizePalette();
 AppRealizeWorld();

 SetTimer(hwnd,0,50,NULL);

 return TRUE;
}



void MainOnDestroy(HWND hwnd)
{
 KillTimer(hwnd,0);
 GetWindowRect(hwnd,&MainRect);

 if (VWorld)	delete VWorld;
 if (VFrame) 	delete VFrame;
 VSystem.Exit();
 delete VRasterEngine;
 PostQuitMessage(0);
}



void MainOnSize(HWND hwnd,UINT state,int cx,int cy)
{
 GetClientRect(hwnd,&ClientRect);
 AppSetFrameRect();
}



void MainOnPaint(HWND hwnd)
{
 PAINTSTRUCT PaintStruct;
 HDC PaintDC;

 PaintDC = BeginPaint(hwnd, &PaintStruct);
 VFrame->Put((PTR)PaintDC,0,0);
 EndPaint(hwnd, &PaintStruct);
}



void MainOnTimer(HWND hwnd,UINT id)
{
 HDC PaintDC;

 PaintDC = GetDC(hwnd);
 VSystem.SetBuffers(VFrame,VFrame);
 VSystem.DrawWorld();
 VFrame->Put((PTR)PaintDC,0,0);
 ReleaseDC(hwnd,PaintDC);
}
