///////////////////////////////////////////////////////////////////////////////
//
// (c) 1997 by Marc van Shaney , aka Kaya Memisoglu
//
// This Source-Code was written by and is copyrighted by Kaya Memisoglu
// You may use the whole code or only parts of it in your own programs
// whether they are commercial or not. BUT you must give credits for these
// parts to me (Kaya Memisoglu  or  Marc van Shaney).
// I am not responsible for any damage or loss caused by this program, so
// if you success in erasing your harddisk with this code, then it is your
// own fault and you should not claim me to be responsible...
// I would be very pleased if you also sent me a postcard or even a letter
// if you can use this code. My address:
//
//        Kaya Memisoglu
//        Reichenberger Ring 50
//        63512 Hainburg
//        Germany
//
//


#define STRICT
#include <windows.h>
#include <windowsx.h>
#include "..\include\gvepro.h"
#include "gve4win.h"


EXTERN HINSTANCE    	hMainInstance;
EXTERN HWND 			hMainWindow,hObjectList,hObjCtrl,hCamCtrl,hLightCtrl;
EXTERN char				AppName[];
EXTERN char 			AppTitle[];
EXTERN char 			ErrTitle[];

EXTERN RECT 		 	ClientRect,MainRect,ObjectListRect;
EXTERN RECT				ObjControlRect,CamControlRect,LightControlRect;
EXTERN GVectorSystem 	VSystem;
EXTERN GVectorWorld  	*VWorld;
EXTERN GVectorObject 	*VObject;
EXTERN GVectorObject 	*VMesh;
EXTERN GLightObject  	*VLight;
EXTERN GCameraObject 	*VCamera;

LOCAL BOOL APIENTRY ObjCtrlProc(HWND ,UINT ,WPARAM ,LPARAM );
LOCAL void ObjCtrlOnCommand(HWND hwnd, int id, HWND hwndCtl,UINT codeNotify);




BOOL DisplayObjControl(HWND hwnd)
{
 if (hObjCtrl)
   {
	SetFocus(hObjCtrl);
	return TRUE;
   }

 hObjCtrl = CreateDialog(hMainInstance,
				MAKEINTRESOURCE(IDD_OBJCTRL),
				hwnd,
				ObjCtrlProc);

 if (!hObjCtrl) return FALSE;

 SetWindowPos(hObjCtrl,NULL,ObjControlRect.left,ObjControlRect.top,0,0,SWP_NOSIZE|SWP_NOZORDER|SWP_SHOWWINDOW);
 UpdateWindow(hObjCtrl);

 return TRUE;
}



BOOL DestroyObjControl(HWND hwnd)
{
 if (hObjCtrl) DestroyWindow(hObjCtrl);
 hObjCtrl=NULL;
 return TRUE;
}


BOOL APIENTRY ObjCtrlProc(HWND hdlg,UINT Message,WPARAM wParam,LPARAM lParam)
{
 CHAR buffer[40];

 switch (Message)
   {
	HANDLE_MSG (hdlg, WM_COMMAND, ObjCtrlOnCommand);
	case WM_INITDIALOG:
	case PM_CHANGE_OBJECT:
	case PM_CHANGE_OBJECTLIST:
		Edit_SetText(GetDlgItem(hdlg,IDC_OBJCTRL_OBJNAME),VMesh->GetName());
		sprintf(buffer,"%.2lf",VMesh->GetPosition().GetX());
		Edit_SetText(GetDlgItem(hdlg,IDC_OBJCTRL_POSX),buffer);
		sprintf(buffer,"%.2lf",VMesh->GetPosition().GetY());
		Edit_SetText(GetDlgItem(hdlg,IDC_OBJCTRL_POSY),buffer);
		sprintf(buffer,"%.2lf",VMesh->GetPosition().GetZ());
		Edit_SetText(GetDlgItem(hdlg,IDC_OBJCTRL_POSZ),buffer);

		sprintf(buffer,"%.2lf",GRad2Deg(VMesh->GetRotation().GetX()));
		Edit_SetText(GetDlgItem(hdlg,IDC_OBJCTRL_ROTX),buffer);
		sprintf(buffer,"%.2lf",GRad2Deg(VMesh->GetRotation().GetY()));
		Edit_SetText(GetDlgItem(hdlg,IDC_OBJCTRL_ROTY),buffer);
		sprintf(buffer,"%.2lf",GRad2Deg(VMesh->GetRotation().GetZ()));
		Edit_SetText(GetDlgItem(hdlg,IDC_OBJCTRL_ROTZ),buffer);
		return TRUE;
	case WM_CLOSE:
		DestroyWindow(hdlg);
		return TRUE;
	case WM_DESTROY:
		GetWindowRect(hdlg,&ObjControlRect);
		hObjCtrl=NULL;
		return TRUE;
	default:
		return FALSE;
   }
}




void ObjCtrlOnCommand(HWND hdlg, int id, HWND hwndCtl,UINT codeNotify)
{
 CHAR buffer[40];

 switch (id)
   {
	case IDC_OBJCTRL_DECPOSX:
		VMesh->SetPosition(VMesh->GetPosition() - GVector(0.5,0,0));
		sprintf(buffer,"%.2lf",VMesh->GetPosition().GetX());
		Edit_SetText(GetDlgItem(hdlg,IDC_OBJCTRL_POSX),buffer);
		VMesh->RealizePosition();
		break;
	case IDC_OBJCTRL_INCPOSX:
		VMesh->SetPosition(VMesh->GetPosition() + GVector(0.5,0,0));
		sprintf(buffer,"%.2lf",VMesh->GetPosition().GetX());
		Edit_SetText(GetDlgItem(hdlg,IDC_OBJCTRL_POSX),buffer);
		VMesh->RealizePosition();
		break;

	case IDC_OBJCTRL_DECPOSY:
		VMesh->SetPosition(VMesh->GetPosition() - GVector(0,0.5,0));
		sprintf(buffer,"%.2lf",VMesh->GetPosition().GetY());
		Edit_SetText(GetDlgItem(hdlg,IDC_OBJCTRL_POSY),buffer);
		VMesh->RealizePosition();
		break;
	case IDC_OBJCTRL_INCPOSY:
		VMesh->SetPosition(VMesh->GetPosition() + GVector(0,0.5,0));
		sprintf(buffer,"%.2lf",VMesh->GetPosition().GetY());
		Edit_SetText(GetDlgItem(hdlg,IDC_OBJCTRL_POSY),buffer);
		VMesh->RealizePosition();
		break;

	case IDC_OBJCTRL_DECPOSZ:
		VMesh->SetPosition(VMesh->GetPosition() - GVector(0,0,0.5));
		sprintf(buffer,"%.2lf",VMesh->GetPosition().GetZ());
		Edit_SetText(GetDlgItem(hdlg,IDC_OBJCTRL_POSZ),buffer);
		VMesh->RealizePosition();
		break;
	case IDC_OBJCTRL_INCPOSZ:
		VMesh->SetPosition(VMesh->GetPosition() + GVector(0,0,0.5));
		sprintf(buffer,"%.2lf",VMesh->GetPosition().GetZ());
		Edit_SetText(GetDlgItem(hdlg,IDC_OBJCTRL_POSZ),buffer);
		VMesh->RealizePosition();
		break;

	case IDC_OBJCTRL_DECROTX:
		VMesh->SetRotation(VMesh->GetRotation() - GVector(GDeg2Rad(0.5),0,0));
		sprintf(buffer,"%.2lf",GRad2Deg(VMesh->GetRotation().GetX()));
		Edit_SetText(GetDlgItem(hdlg,IDC_OBJCTRL_ROTX),buffer);
		VMesh->RealizePosition();
		break;
	case IDC_OBJCTRL_INCROTX:
		VMesh->SetRotation(VMesh->GetRotation() + GVector(GDeg2Rad(0.5),0,0));
		sprintf(buffer,"%.2lf",GRad2Deg(VMesh->GetRotation().GetX()));
		Edit_SetText(GetDlgItem(hdlg,IDC_OBJCTRL_ROTX),buffer);
		VMesh->RealizePosition();
		break;

	case IDC_OBJCTRL_DECROTY:
		VMesh->SetRotation(VMesh->GetRotation() - GVector(0,GDeg2Rad(0.5),0));
		sprintf(buffer,"%.2lf",GRad2Deg(VMesh->GetRotation().GetY()));
		Edit_SetText(GetDlgItem(hdlg,IDC_OBJCTRL_ROTY),buffer);
		VMesh->RealizePosition();
		break;
	case IDC_OBJCTRL_INCROTY:
		VMesh->SetRotation(VMesh->GetRotation() + GVector(0,GDeg2Rad(0.5),0));
		sprintf(buffer,"%.2lf",GRad2Deg(VMesh->GetRotation().GetY()));
		Edit_SetText(GetDlgItem(hdlg,IDC_OBJCTRL_ROTY),buffer);
		VMesh->RealizePosition();
		break;

	case IDC_OBJCTRL_DECROTZ:
		VMesh->SetRotation(VMesh->GetRotation() - GVector(0,0,GDeg2Rad(0.5)));
		sprintf(buffer,"%.2lf",GRad2Deg(VMesh->GetRotation().GetZ()));
		Edit_SetText(GetDlgItem(hdlg,IDC_OBJCTRL_ROTZ),buffer);
		VMesh->RealizePosition();
		break;
	case IDC_OBJCTRL_INCROTZ:
		VMesh->SetRotation(VMesh->GetRotation() + GVector(0,0,GDeg2Rad(0.5)));
		sprintf(buffer,"%.2lf",GRad2Deg(VMesh->GetRotation().GetZ()));
		Edit_SetText(GetDlgItem(hdlg,IDC_OBJCTRL_ROTZ),buffer);
		VMesh->RealizePosition();
		break;

	case IDC_OBJCTRL_POSX:
		if (codeNotify==EN_CHANGE)
		   {
			GVector pos=VMesh->GetPosition();
			Edit_GetText(GetDlgItem(hdlg,IDC_OBJCTRL_POSX),buffer,sizeof(buffer));
			pos.SetX(atof(buffer));
			VMesh->SetPosition(pos);
			VMesh->RealizePosition();
		   }
		break;

	case IDC_OBJCTRL_POSY:
		if (codeNotify==EN_CHANGE)
		   {
			GVector pos=VMesh->GetPosition();
			Edit_GetText(GetDlgItem(hdlg,IDC_OBJCTRL_POSY),buffer,sizeof(buffer));
			pos.SetY(atof(buffer));
			VMesh->SetPosition(pos);
			VMesh->RealizePosition();
		   }
		break;

	case IDC_OBJCTRL_POSZ:
		if (codeNotify==EN_CHANGE)
		   {
			GVector pos=VMesh->GetPosition();
			Edit_GetText(GetDlgItem(hdlg,IDC_OBJCTRL_POSZ),buffer,sizeof(buffer));
			pos.SetZ(atof(buffer));
			VMesh->SetPosition(pos);
			VMesh->RealizePosition();
		   }
		break;

	case IDC_OBJCTRL_ROTX:
		if (codeNotify==EN_CHANGE)
		   {
			GVector rot=VMesh->GetRotation();
			Edit_GetText(GetDlgItem(hdlg,IDC_OBJCTRL_ROTX),buffer,sizeof(buffer));
			rot.SetX(GDeg2Rad(atof(buffer)));
			VMesh->SetRotation(rot);
			VMesh->RealizePosition();
		   }
		break;

	case IDC_OBJCTRL_ROTY:
		if (codeNotify==EN_CHANGE)
		   {
			GVector rot=VMesh->GetRotation();
			Edit_GetText(GetDlgItem(hdlg,IDC_OBJCTRL_ROTY),buffer,sizeof(buffer));
			rot.SetY(GDeg2Rad(atof(buffer)));
			VMesh->SetRotation(rot);
			VMesh->RealizePosition();
		   }
		break;

	case IDC_OBJCTRL_ROTZ:
		if (codeNotify==EN_CHANGE)
		   {
			GVector rot=VMesh->GetRotation();
			Edit_GetText(GetDlgItem(hdlg,IDC_OBJCTRL_ROTZ),buffer,sizeof(buffer));
			rot.SetZ(GDeg2Rad(atof(buffer)));
			VMesh->SetRotation(rot);
			VMesh->RealizePosition();
		   }
		break;

   }
}

