///////////////////////////////////////////////////////////////////////////////
//
// (c) 1997 by Marc van Shaney , aka Kaya Memisoglu
//
// This Source-Code was written by and is copyrighted by Kaya Memisoglu
// You may use the whole code or only parts of it in your own programs
// whether they are commercial or not. BUT you must give credits for these
// parts to me (Kaya Memisoglu  or  Marc van Shaney).
// I am not responsible for any damage or loss caused by this program, so
// if you success in erasing your harddisk with this code, then it is your
// own fault and you should not claim me to be responsible...
// I would be very pleased if you also sent me a postcard or even a letter
// if you can use this code. My address:
//
//        Kaya Memisoglu
//        Reichenberger Ring 50
//        63512 Hainburg
//        Germany
//
//


#define STRICT
#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include "..\include\gvepro.h"
#include "gve4win.h"

EXTERN HINSTANCE        hMainInstance;
EXTERN HWND 		    hMainWindow,hObjectList;
EXTERN char		        AppName[];
EXTERN char 		    AppTitle[];
EXTERN char 		    ErrTitle[];

EXTERN RECT 		    ClientRect,MainRect,ObjectListRect;
EXTERN RECT				ObjControlRect,CamControlRect,LightControlRect;
EXTERN GVectorSystem    VSystem;
EXTERN GVectorWorld	    *VWorld;
EXTERN GVectorObject    *VObject;
EXTERN GVectorObject 	*VMesh;
EXTERN GLightObject  	*VLight;
EXTERN GCameraObject 	*VCamera;

LOCAL LRESULT CALLBACK  GeneralDlgProc(HWND, UINT, WPARAM, LPARAM);
LOCAL LRESULT CALLBACK  MaterialDlgProc(HWND, UINT, WPARAM, LPARAM);
LOCAL LRESULT CALLBACK  LightDlgProc(HWND, UINT, WPARAM, LPARAM);
LOCAL LRESULT CALLBACK  MeshDlgProc(HWND, UINT, WPARAM, LPARAM);
LOCAL LRESULT CALLBACK  CameraDlgProc(HWND, UINT, WPARAM, LPARAM);
LOCAL INT FASTCALL 		ComboAddBitmap(GBitmapList *list,GBitmap *map,HWND cbox,HWND bmap,HWND desc);
LOCAL INT FASTCALL 		ComboDeleteBitmap(GBitmapList *list,HWND cbox,HWND bmap,HWND desc);
LOCAL INT FASTCALL 		ComboSetBitmapList(GBitmapList *list,GBitmap *map,HWND cbox,HWND bmap,HWND desc);
LOCAL INT FASTCALL 		ComboSelectBitmap(GBitmapList *list,HWND cbox,HWND bmap,HWND desc);
LOCAL GVectorObject		*CObject;




BOOL DisplayObjectProps(HWND hwnd)
{
 PROPSHEETPAGE psp[3];
 PROPSHEETHEADER psh;
 INT npages=1;

 CObject=VObject;

 psp[0].dwSize = sizeof(PROPSHEETPAGE);
 psp[0].dwFlags = PSP_USEICONID | PSP_USETITLE;
 psp[0].hInstance = hMainInstance;
 psp[0].pszTemplate = MAKEINTRESOURCE(IDD_OBJPROPS_GENERAL);
 psp[0].pszIcon = MAKEINTRESOURCE(IDI_CONTAINERICON);
 psp[0].pfnDlgProc =(DLGPROC) GeneralDlgProc;
 psp[0].pszTitle = (LPSTR) "General";
 psp[0].lParam = 0;
 psp[0].pfnCallback = NULL;

 if (typeid(*CObject)==typeid(GMeshObject))
   {
	psp[1].dwSize = sizeof(PROPSHEETPAGE);
	psp[1].dwFlags = PSP_USEICONID | PSP_USETITLE;
	psp[1].hInstance = hMainInstance;
	psp[1].pszTemplate = MAKEINTRESOURCE(IDD_OBJPROPS_MESH);
	psp[1].pszIcon = MAKEINTRESOURCE(IDI_MESHICON);
	psp[1].pfnDlgProc = (DLGPROC)MeshDlgProc;
	psp[1].pszTitle = (LPSTR) "Mesh";
	psp[1].lParam = 0;
	psp[1].pfnCallback = NULL;

	psp[2].dwSize = sizeof(PROPSHEETPAGE);
	psp[2].dwFlags = PSP_USEICONID | PSP_USETITLE;
	psp[2].hInstance = hMainInstance;
	psp[2].pszTemplate = MAKEINTRESOURCE(IDD_OBJPROPS_MATERIAL);
	psp[2].pszIcon = MAKEINTRESOURCE(IDI_MESHICON);
	psp[2].pfnDlgProc = (DLGPROC)MaterialDlgProc;
	psp[2].pszTitle = (LPSTR) "Material";
	psp[2].lParam = 0;
	psp[2].pfnCallback = NULL;
	npages+=2;
   }
 else if (typeid(*CObject)==typeid(GLightObject))
   {
	psp[1].dwSize = sizeof(PROPSHEETPAGE);
	psp[1].dwFlags = PSP_USEICONID | PSP_USETITLE;
	psp[1].hInstance = hMainInstance;
	psp[1].pszTemplate = MAKEINTRESOURCE(IDD_OBJPROPS_LIGHT);
	psp[1].pszIcon = MAKEINTRESOURCE(IDI_LIGHTICON);
	psp[1].pfnDlgProc = (DLGPROC)LightDlgProc;
	psp[1].pszTitle = (LPSTR) "Light";
	psp[1].lParam = 0;
	psp[1].pfnCallback = NULL;
	npages+=1;
   }
 else if (typeid(*CObject)==typeid(GCameraObject))
   {
	psp[1].dwSize = sizeof(PROPSHEETPAGE);
	psp[1].dwFlags = PSP_USEICONID | PSP_USETITLE;
	psp[1].hInstance = hMainInstance;
	psp[1].pszTemplate = MAKEINTRESOURCE(IDD_OBJPROPS_CAMERA);
	psp[1].pszIcon = MAKEINTRESOURCE(IDI_CAMERAICON);
	psp[1].pfnDlgProc = (DLGPROC)CameraDlgProc;
	psp[1].pszTitle = (LPSTR) "Camera";
	psp[1].lParam = 0;
	psp[1].pfnCallback = NULL;
	npages+=1;
   }

 psh.dwSize = sizeof(PROPSHEETHEADER);
 psh.dwFlags = PSH_USEICONID | PSH_PROPSHEETPAGE | PSH_NOAPPLYNOW;
 psh.hwndParent = hwnd;
 psh.hInstance = hMainInstance;
 psh.pszIcon = MAKEINTRESOURCE(IDI_OBJECTICON);
 psh.pszCaption = (LPSTR) "Object Properties";
 psh.nPages = npages;
 psh.nStartPage = 0;
 psh.ppsp = (LPCPROPSHEETPAGE) &psp;
 psh.pfnCallback = NULL;

 PropertySheet(&psh);
 return TRUE;
}




LOCAL LRESULT CALLBACK GeneralDlgProc(HWND hdlg,UINT uMessage,WPARAM wparam,LPARAM lparam)
{
 LPNMHDR lpnmhdr;
 char buffer[200];

 switch (uMessage)
   {
	case WM_INITDIALOG:
		Edit_SetText(GetDlgItem(hdlg,IDC_OBJPROPS_NAME),
				 CObject->GetName());
		Edit_SetText(GetDlgItem(hdlg,IDC_OBJPROPS_VERTEXCOUNT),
				 itoa(CObject->GetVertexCount(FALSE),buffer,10));
		Edit_SetText(GetDlgItem(hdlg,IDC_OBJPROPS_FACECOUNT),
				 itoa(CObject->GetFaceCount(FALSE),buffer,10));
		Edit_SetText(GetDlgItem(hdlg,IDC_OBJPROPS_ALLVERTEXCOUNT),
				 itoa(CObject->GetVertexCount(TRUE),buffer,10));
		Edit_SetText(GetDlgItem(hdlg,IDC_OBJPROPS_ALLFACECOUNT),
				 itoa(CObject->GetFaceCount(TRUE),buffer,10));
		Edit_SetText(GetDlgItem(hdlg,IDC_OBJPROPS_ALLOBJECTCOUNT),
				 itoa(CObject->GetObjectCount(TRUE),buffer,10));
		return 0;
	case WM_NOTIFY:
		lpnmhdr = (NMHDR FAR *)lparam;

		switch (lpnmhdr->code)
		   {
			case PSN_SETACTIVE:
				PropSheet_UnChanged(lpnmhdr->hwndFrom, hdlg);
				break;
			case PSN_APPLY:
				Edit_GetText(GetDlgItem(hdlg,IDC_OBJPROPS_NAME),buffer,200);
				CObject->SetName(buffer);
			case PSN_KILLACTIVE:
				PropSheet_UnChanged(lpnmhdr->hwndFrom, hdlg);
				break;
		   }
		return 0;
	case WM_COMMAND:
//		PropSheet_Changed(hObjectProps, hdlg);
		return 0;
	default:
		return 0;
   }
}



LOCAL LRESULT CALLBACK CameraDlgProc(HWND hdlg,UINT uMessage,WPARAM wparam,LPARAM lparam)
{
 LPNMHDR lpnmhdr;
 char buffer[200];
 GCameraObject *camera=(GCameraObject *)CObject;

 switch (uMessage)
   {
	case WM_INITDIALOG:
		sprintf(buffer,"%.2lf",camera->GetDistance().x);
		Edit_SetText(GetDlgItem(hdlg,IDC_OBJPROPS_CAMXDIST),buffer);
		sprintf(buffer,"%.2lf",camera->GetDistance().y);
		Edit_SetText(GetDlgItem(hdlg,IDC_OBJPROPS_CAMYDIST),buffer);
		sprintf(buffer,"%.2lf",camera->GetZoom());
		Edit_SetText(GetDlgItem(hdlg,IDC_OBJPROPS_CAMZOOM),buffer);
		return 0;
	case WM_NOTIFY:
		lpnmhdr = (NMHDR FAR *)lparam;

		switch (lpnmhdr->code)
		   {
			case PSN_SETACTIVE:
				PropSheet_UnChanged(lpnmhdr->hwndFrom, hdlg);
				break;
			case PSN_APPLY:
				Edit_GetText(GetDlgItem(hdlg,IDC_OBJPROPS_CAMXDIST),buffer,90);
				Edit_GetText(GetDlgItem(hdlg,IDC_OBJPROPS_CAMYDIST),buffer+100,90);
				camera->SetDistance(atof(buffer),atof(buffer+100));
				Edit_GetText(GetDlgItem(hdlg,IDC_OBJPROPS_CAMZOOM),buffer,90);
				camera->SetZoom(atof(buffer));
			case PSN_KILLACTIVE:
				PropSheet_UnChanged(lpnmhdr->hwndFrom, hdlg);
				break;
		   }
		return 0;
	case WM_COMMAND:
//		PropSheet_Changed(hObjectProps, hdlg);
		return 0;
	default:
		return 0;
   }
}


LOCAL LRESULT CALLBACK LightDlgProc(HWND hdlg,UINT uMessage,WPARAM wparam,LPARAM lparam)
{
 LPNMHDR lpnmhdr;
 char buffer[200];
 GColour col;
 COLORREF colref;
 GLightObject *light=(GLightObject *)CObject;

 switch (uMessage)
   {
	case WM_INITDIALOG:
		Edit_SetText(GetDlgItem(hdlg,IDC_OBJPROPS_LIGHTRED),
				 itoa((INT)light->GetColour().R,buffer,10));
		Edit_SetText(GetDlgItem(hdlg,IDC_OBJPROPS_LIGHTGREEN),
				 itoa((INT)light->GetColour().G,buffer,10));
		Edit_SetText(GetDlgItem(hdlg,IDC_OBJPROPS_LIGHTBLUE),
				 itoa((INT)light->GetColour().B,buffer,10));
		Edit_SetText(GetDlgItem(hdlg,IDC_OBJPROPS_AMBIENTRED),
				 itoa((INT)VWorld->GetAmbientLight()->GetColour().R,buffer,10));
		Edit_SetText(GetDlgItem(hdlg,IDC_OBJPROPS_AMBIENTGREEN),
				 itoa((INT)VWorld->GetAmbientLight()->GetColour().G,buffer,10));
		Edit_SetText(GetDlgItem(hdlg,IDC_OBJPROPS_AMBIENTBLUE),
				 itoa((INT)VWorld->GetAmbientLight()->GetColour().B,buffer,10));
		SendMessage(GetDlgItem(hdlg,IDC_OBJPROPS_LIGHTSPEC),TBM_SETRANGEMIN,0,1);
		SendMessage(GetDlgItem(hdlg,IDC_OBJPROPS_LIGHTSPEC),TBM_SETRANGEMAX,0,255);
		SendMessage(GetDlgItem(hdlg,IDC_OBJPROPS_LIGHTSPEC),TBM_SETTICFREQ,16,0);
		SendMessage(GetDlgItem(hdlg,IDC_OBJPROPS_LIGHTSPEC),TBM_SETPOS,1,light->GetSpecularity());
		return 0;
	case WM_NOTIFY:
		lpnmhdr = (NMHDR FAR *)lparam;

		switch (lpnmhdr->code)
		   {
			case PSN_APPLY:
				Edit_GetText(GetDlgItem(hdlg,IDC_OBJPROPS_LIGHTRED),buffer,120);
				col.R=(BYTE)atoi(buffer);
				Edit_GetText(GetDlgItem(hdlg,IDC_OBJPROPS_LIGHTGREEN),buffer,120);
				col.G=(BYTE)atoi(buffer);
				Edit_GetText(GetDlgItem(hdlg,IDC_OBJPROPS_LIGHTBLUE),buffer,120);
				col.B=(BYTE)atoi(buffer);
				light->SetColour(col);
				Edit_GetText(GetDlgItem(hdlg,IDC_OBJPROPS_AMBIENTRED),buffer,120);
				col.R=(BYTE)atoi(buffer);
				Edit_GetText(GetDlgItem(hdlg,IDC_OBJPROPS_AMBIENTGREEN),buffer,120);
				col.G=(BYTE)atoi(buffer);
				Edit_GetText(GetDlgItem(hdlg,IDC_OBJPROPS_AMBIENTBLUE),buffer,120);
				col.B=(BYTE)atoi(buffer);
				VWorld->GetAmbientLight()->SetColour(col);
				light->SetSpecularity(SendMessage(GetDlgItem(hdlg,IDC_OBJPROPS_LIGHTSPEC),TBM_GETPOS,0,0));
			case PSN_KILLACTIVE:
				PropSheet_UnChanged(lpnmhdr->hwndFrom, hdlg);
				break;
		   }
		return 0;
	case WM_COMMAND:
		switch (LOWORD(wparam))
		   {
			case IDC_OBJPROPS_LIGHTCHOOSE:
				colref=RGB(light->GetColour().R,
						   light->GetColour().G,
						   light->GetColour().B);
				if (ChooseColour(hdlg,&colref)==TRUE)
				   {
					Edit_SetText(GetDlgItem(hdlg,IDC_OBJPROPS_LIGHTRED),
							 itoa((INT)GetRValue(colref),buffer,10));
					Edit_SetText(GetDlgItem(hdlg,IDC_OBJPROPS_LIGHTGREEN),
							 itoa((INT)GetGValue(colref),buffer,10));
					Edit_SetText(GetDlgItem(hdlg,IDC_OBJPROPS_LIGHTBLUE),
							 itoa((INT)GetBValue(colref),buffer,10));
				   }
				break;
			case IDC_OBJPROPS_AMBIENTCHOOSE:
				colref=RGB(VWorld->GetAmbientLight()->GetColour().R,
						   VWorld->GetAmbientLight()->GetColour().G,
						   VWorld->GetAmbientLight()->GetColour().B);
				if (ChooseColour(hdlg,&colref)==TRUE)
				   {
					Edit_SetText(GetDlgItem(hdlg,IDC_OBJPROPS_AMBIENTRED),
							 itoa((INT)GetRValue(colref),buffer,10));
					Edit_SetText(GetDlgItem(hdlg,IDC_OBJPROPS_AMBIENTGREEN),
							 itoa((INT)GetGValue(colref),buffer,10));
					Edit_SetText(GetDlgItem(hdlg,IDC_OBJPROPS_AMBIENTBLUE),
							 itoa((INT)GetBValue(colref),buffer,10));
				   }
				break;
			default:
//				PropSheet_Changed(hObjectProps, hdlg);
				break;
		   }
		return 0;
	default:
		return 0;
   }

}



LOCAL LRESULT CALLBACK MeshDlgProc(HWND hdlg,UINT uMessage,WPARAM wparam,LPARAM lparam)
{
 LPNMHDR lpnmhdr;
 INT shad;
 char buffer[200];
 INT i,j;
 GMeshObject *mesh=(GMeshObject *)CObject;

 switch (uMessage)
   {
	case WM_INITDIALOG:
		shad=mesh->GetShading();
		Button_SetCheck(GetDlgItem(hdlg,IDC_OBJPROPS_BACKCULLING),
				mesh->GetFlag(GVE_OBJ_BACKCULLING));
		Button_SetCheck(GetDlgItem(hdlg,IDC_OBJPROPS_SHADEVERTICES),
				mesh->GetFlag(GVE_OBJ_VERTEX_SHADING));
		Button_SetCheck(GetDlgItem(hdlg,IDC_OBJPROPS_HIDE),
				mesh->GetFlag(GVE_OBJ_HIDE));
		Button_SetCheck(GetDlgItem(hdlg,IDC_OBJPROPS_TRANSFORMNORMALS),
				mesh->GetFlag(GVE_OBJ_NORMALS));
		Button_SetCheck(GetDlgItem(hdlg,IDC_OBJPROPS_NOSORT),
				mesh->GetFlag(GVE_OBJ_NOSORT));
		Button_SetCheck(GetDlgItem(hdlg,IDC_OBJPROPS_USEBOUNDING),
				mesh->GetFlag(GVE_OBJ_VERTEXBOX));
		Button_SetCheck(GetDlgItem(hdlg,IDC_OBJPROPS_TRANSFORMNORMALS),
				mesh->GetFlag(GVE_OBJ_NORMALS));
		Edit_SetText(GetDlgItem(hdlg,IDC_OBJPROPS_OBJCOLOUR),
				 itoa(mesh->GetColour(),buffer,10));
		for(i=0;i<=GVE_SHAD_MAX_METHOD;i++)
			if (VSystem.GetShadingName(i,buffer))
			   {
				j=ComboBox_AddString(GetDlgItem(hdlg,IDC_OBJPROPS_OBJSHADING),buffer);
				ComboBox_SetItemData(GetDlgItem(hdlg,IDC_OBJPROPS_OBJSHADING),j,i);
				if (i==shad) ComboBox_SetCurSel(GetDlgItem(hdlg,IDC_OBJPROPS_OBJSHADING),j);
			   }
		SendMessage(GetDlgItem(hdlg,IDC_OBJPROPS_OBJPHONG),TBM_SETRANGEMIN,0,1);
		SendMessage(GetDlgItem(hdlg,IDC_OBJPROPS_OBJPHONG),TBM_SETRANGEMAX,0,16);
		SendMessage(GetDlgItem(hdlg,IDC_OBJPROPS_OBJPHONG),TBM_SETPOS,1,mesh->GetPhong());
		return 0;

	case WM_NOTIFY:
		lpnmhdr = (NMHDR FAR *)lparam;

		switch (lpnmhdr->code)
		   {
			case PSN_APPLY:
				Edit_GetText(GetDlgItem(hdlg,IDC_OBJPROPS_OBJCOLOUR),buffer,120);
				mesh->SetColour(atoi(buffer));
				mesh->ChangeFlag(GVE_OBJ_BACKCULLING,
					Button_GetCheck(GetDlgItem(hdlg,IDC_OBJPROPS_BACKCULLING)));
				mesh->ChangeFlag(GVE_OBJ_HIDE,
					Button_GetCheck(GetDlgItem(hdlg,IDC_OBJPROPS_HIDE)));
				mesh->ChangeFlag(GVE_OBJ_VERTEXBOX,
					Button_GetCheck(GetDlgItem(hdlg,IDC_OBJPROPS_USEBOUNDING)));
				mesh->ChangeFlag(GVE_OBJ_NOSORT,
					Button_GetCheck(GetDlgItem(hdlg,IDC_OBJPROPS_NOSORT)));
				mesh->ChangeFlag(GVE_OBJ_VERTEX_SHADING,
					Button_GetCheck(GetDlgItem(hdlg,IDC_OBJPROPS_SHADEVERTICES)));
				mesh->ChangeFlag(GVE_OBJ_NORMALS,
					Button_GetCheck(GetDlgItem(hdlg,IDC_OBJPROPS_TRANSFORMNORMALS)));
				mesh->SetShading(ComboBox_GetItemData(GetDlgItem(hdlg,IDC_OBJPROPS_OBJSHADING),
									ComboBox_GetCurSel(GetDlgItem(hdlg,IDC_OBJPROPS_OBJSHADING))));
			case PSN_KILLACTIVE:
				PropSheet_UnChanged(lpnmhdr->hwndFrom, hdlg);
				break;
		   }
		return 0;
	case WM_COMMAND:
		switch (LOWORD(wparam))
		   {
			case IDC_OBJPROPS_INITBOUNDING:
				mesh->InitBoundingBox();
				break;
			case IDC_OBJPROPS_INITNORMALS:
				mesh->InitNormals();
				break;
			case IDC_OBJPROPS_MAKETRIANGLES:
				mesh->MakeTriangles();
				break;
			default:
//				PropSheet_Changed(hObjectProps, hdlg);
				break;
		   }
		return 0;
	default:
		return 0;
   }
}



LOCAL LRESULT CALLBACK MaterialDlgProc(HWND hdlg,UINT uMessage,WPARAM wparam,LPARAM lparam)
{
 LPNMHDR lpnmhdr;
 INT i;
 GBitmap *tmap,*lmap,*bmap,*map;
 GMeshObject *mesh=(GMeshObject *)CObject;
 char szFile[MAXPATH]="";
 char szFilter[]= "PCX 256-colour files (*.PCX)\0*.PCX\0"
				  "All files (*.*)\0*.*\0";


 switch (uMessage)
   {
	case WM_INITDIALOG:
		i=mesh->GetTextureMap();
		tmap=(GBitmap *)VWorld->TextureMapList.GetEntry(i);
		ComboSetBitmapList(&VWorld->TextureMapList,tmap,
					GetDlgItem(hdlg,IDC_OBJPROPS_TEXSELECT),
					GetDlgItem(hdlg,IDC_OBJPROPS_TEXMAP),
					GetDlgItem(hdlg,IDC_OBJPROPS_TEXDESC));
		return 0;
	case WM_NOTIFY:
		lpnmhdr = (NMHDR FAR *)lparam;

		switch (lpnmhdr->code)
		   {
			case PSN_APPLY:
			case PSN_KILLACTIVE:
				PropSheet_UnChanged(lpnmhdr->hwndFrom, hdlg);
				break;
		   }
		return 0;
	case WM_COMMAND:
		switch (LOWORD(wparam))
		   {
			case IDC_OBJPROPS_TEXSELECT:
				ComboSelectBitmap(&VWorld->TextureMapList,
							GetDlgItem(hdlg,IDC_OBJPROPS_TEXSELECT),
							GetDlgItem(hdlg,IDC_OBJPROPS_TEXMAP),
							GetDlgItem(hdlg,IDC_OBJPROPS_TEXDESC));
				break;
			case IDC_OBJPROPS_TEXLOAD:
				if(GetLoadFileName(hdlg,"Import Texture",szFilter,szFile,MAXPATH)==NULL) break;
				map=new GBitmap;
				map->ImportPCX(szFile);
				ComboAddBitmap(&VWorld->TextureMapList,map,
							GetDlgItem(hdlg,IDC_OBJPROPS_TEXSELECT),
							GetDlgItem(hdlg,IDC_OBJPROPS_TEXMAP),
							GetDlgItem(hdlg,IDC_OBJPROPS_TEXDESC));
				break;
			case IDC_OBJPROPS_TEXDELETE:
				ComboDeleteBitmap(&VWorld->TextureMapList,
							GetDlgItem(hdlg,IDC_OBJPROPS_TEXSELECT),
							GetDlgItem(hdlg,IDC_OBJPROPS_TEXMAP),
							GetDlgItem(hdlg,IDC_OBJPROPS_TEXDESC));
				break;
		   }
//		PropSheet_Changed(hObjectProps, hdlg);
		return 0;
	default:
		return 0;
   }
}



INT FASTCALL ComboSetBitmapList(GBitmapList *list,GBitmap *sel,HWND cbox,HWND bmap,HWND desc)
{
 GBitmap *map;
 INT i,j;
 HBITMAP hmap;

 if (hmap=(HBITMAP)SendMessage(bmap,STM_GETIMAGE,IMAGE_BITMAP,0))
	 DeleteBitmap(hmap);

 for(i=0;i<GMZ_OBJECTLIST_SIZE;i++)
	if (map=(GBitmap *)list->GetEntry(i))
	   {
		j=ComboBox_AddString(cbox,map->GetName());
		ComboBox_SetItemData(cbox,j,i);
		if (map==sel) ComboBox_SetCurSel(cbox,j);
	   }

 return ComboSelectBitmap(list,cbox,bmap,desc);
}


INT FASTCALL ComboSelectBitmap(GBitmapList *list,HWND cbox,HWND bmap,HWND desc)
{
 GBitmap *map;
 INT i;
 HBITMAP hmap;
 CHAR buffer[100];

 if (hmap=(HBITMAP)SendMessage(bmap,STM_GETIMAGE,IMAGE_BITMAP,0))
	 DeleteBitmap(hmap);

 SendMessage(bmap,STM_SETIMAGE,IMAGE_BITMAP,0);
 i=ComboBox_GetItemData(cbox,ComboBox_GetCurSel(cbox));
 if (map=list->GetEntry(i))
	{
	 sprintf(buffer,"Dimension: %dx%dx%dbpp",map->GetWidth(),map->GetHeight(),map->GetDepth());
	 Static_SetText(desc,buffer);
	 hmap=map->CreateDIBitmap();
	 SendMessage(bmap,STM_SETIMAGE,IMAGE_BITMAP,(LPARAM)hmap);
	}
 else
	{
	 sprintf(buffer,"Empty bitmap");
	 Static_SetText(desc,buffer);
	}

 return i;
}


INT FASTCALL ComboDeleteBitmap(GBitmapList *list,HWND cbox,HWND bmap,HWND desc)
{
 INT i;

 i=ComboBox_GetItemData(cbox,ComboBox_GetCurSel(cbox));
 ComboBox_DeleteString(cbox,i);
 list->DeleteEntry(i);
 return ComboSelectBitmap(list,cbox,bmap,desc);
}



INT FASTCALL ComboAddBitmap(GBitmapList *list,GBitmap *map,HWND cbox,HWND bmap,HWND desc)
{
 INT i,j;

 list->AddEntry(map);
 i=list->GetIndex(map);
 j=ComboBox_AddString(cbox,map->GetName());
 ComboBox_SetItemData(cbox,j,i);
 ComboBox_SetCurSel(cbox,j);
 return ComboSelectBitmap(list,cbox,bmap,desc);
}
