///////////////////////////////////////////////////////////////////////////////
//
// (c) 1997 by Marc van Shaney , aka Kaya Memisoglu
//
// This Source-Code was written by and is copyrighted by Kaya Memisoglu
// You may use the whole code or only parts of it in your own programs
// whether they are commercial or not. BUT you must give credits for these
// parts to me (Kaya Memisoglu  or  Marc van Shaney).
// I am not responsible for any damage or loss caused by this program, so
// if you success in erasing your harddisk with this code, then it is your
// own fault and you should not claim me to be responsible...
// I would be very pleased if you also sent me a postcard or even a letter
// if you can use this code. My address:
//
//        Kaya Memisoglu
//        Reichenberger Ring 50
//        63512 Hainburg
//        Germany
//
//


#define STRICT
#include <mem.h>
#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>               // TreeView declarations live here.
#include "treeview.h"


HWND CreateTreeView(HINSTANCE hInst,HWND hwndParent, HIMAGELIST hImageList, int iID, DWORD dwStyle)
{
 RECT rc;
 HWND hwnd;

 InitCommonControls();

 GetClientRect(hwndParent, &rc);

 hwnd = CreateWindowEx(0, WC_TREEVIEW,
			  "",
			  dwStyle,
			  0, 0,
			  rc.right, rc.bottom,
			  hwndParent,
			  (HMENU)iID,
			  hInst,
			  NULL);

 if (hImageList && hwnd)
	(void) TreeView_SetImageList(hwnd, hImageList, 0);
 else
	return NULL;

 return hwnd;
}



BOOL ExpandTreeView(HWND hwndTreeView)
{
 HTREEITEM htiNext = TreeView_GetRoot(hwndTreeView);

 if (ItemHasChild(hwndTreeView,htiNext)) ExpandChildren(hwndTreeView,htiNext);

 while ((htiNext = TreeView_GetNextSibling(hwndTreeView, htiNext))!=NULL)
	if (ItemHasChild(hwndTreeView,htiNext)) ExpandChildren(hwndTreeView,htiNext);

 return TRUE;
}



BOOL ExpandBranch(HWND hwndTreeView,HTREEITEM htiParent)
{
 if (ItemHasChild(hwndTreeView,htiParent))
	ExpandChildren(hwndTreeView,htiParent);

 return TRUE;
}


BOOL ExpandChildren(HWND hwndTreeView,HTREEITEM htiParent)
{
 HTREEITEM htiChild;

 TreeView_Expand(hwndTreeView, htiParent, TVE_EXPAND);

 htiChild = TreeView_GetChild(hwndTreeView, htiParent);
 if (ItemHasChild(hwndTreeView,htiChild)) 	ExpandChildren(hwndTreeView,htiChild);

 while ((htiChild = TreeView_GetNextSibling(hwndTreeView, htiChild))!=NULL)
	if (ItemHasChild(hwndTreeView,htiChild))
		ExpandChildren(hwndTreeView,htiChild);

 return TRUE;
}



BOOL ItemHasChild(HWND hwndTreeView,HTREEITEM hti)
{
 TV_ITEM tvi;

 memset((LPBYTE)&tvi, 0, sizeof(TV_ITEM));
 tvi.hItem = hti;
 tvi.mask = TVIF_CHILDREN;
 TreeView_GetItem(hwndTreeView, &tvi);
 return (tvi.cChildren) ? TRUE : FALSE;
}
